' bitmap editor with UI recycled from mbfast
' a392 is next

' compile with FreeBASIC 0.23
' (remove reference to AllocConsole if not targetting win32)

' stats(2)-(3) is old copy of renderh/renderv?
'
' stats(11)-(13) is number of r/g/b levels for color space setting
'
' stats(15) is palette number of colors setting
'
' stats(17)-(18) is multipalette zone size H and V
' stats(19) is (pre-palette shrinkage) number of colors
' stats(20 thru 23) are for debug
'
' stats(28) is default pen size
' stats(30) is default JPEG quality   
' stats(31) is beginning X coord of line or -1
' stats(32) is beginning Y coord of line
'
' stats(37) is number of colors in custom color space
' stats(38)-(43) is current and new screen dimensions and depth
' stats(44)-(45) is default bitmap size override (if any)
' stats(46)-(47) is tile cursor H and V
' stats(48)-(49) is tile size H and V
' stats(50) is magnification for pixel art mode
' stats(51)-(52) is position of pixel art window
' stats(53)-(54) is pixel cursor position (relative to tile)
'
' stats(55)-(56) is noise reduction strength
' stats(57) is tile number
' stats(58) is grid size
' stats(59)-(60) is screen coords
' stats(61)-(62) is bitmap coords
' stats(63)-(64) is bitmap coords with snap
' stats(65)-(66) is selection size
' stats(67)-(68) is selection first corner (bitmap coords)
' stats(69)-(70) is selection second corner (bitmap coords)
' stats(71) is box outline color
' stats(72) is number of points plotted for gradient tool
'
' stats(73) is f bias (for palette color reduction)
' stats(74) is y bias (for yuv color matching)
' stats(75) is max error (for dithering)                 (unused)
'
' stats(76)-(77) is alternate cursor size H and V
' stats(78)-(79) is active cursor size H and V (copied from 48 or from 76)
'
' stats(80) is parameter (and enabler) for ordered dither

' fpval(0) is aspect
' fpval(1) is scale

' bools bits:
'
' 0  - lock view?
' 1  - center on screen on load
' 2  -                              (unused?)
' 3  - color adjust
' 4  - color space dither
' 5  - floyd-steinberg
' 6  - multi-palette mode
' 7  - palette change
' 8  - color space change
' 9  - fit to screen on load
' 10 - intensity bit
' 11 - grayscale
' 12 - paste-with-transparency
' 13 - show all files
' 14 - custom palette
' 15 - custom color space
' 16 - reset pixel aspect on load
' 17 - tile edit mode
' 18 - align cursor horizontally
' 19 - pixel edit mode
' 20 - luma smoothing
' 21 - chroma smoothing
' 22 - antistatic
' 23 - EHB mode
' 24 - CTRL + arrow was pressed
' 25 - showmask
' 26 - draw-on-mask
' 27 - applymask
' 28 - showgrid
' 29 - gradient color calculation (used by fillstuff)
' 30 - paste preview
'
' 0  - YUV colormatch mode
' 1  - palette dither
' 2  - align cursor vertically
' 3  - palette bind mode
' 4  - round-down colormatch mode
' 5  - alternate cursor size


#lang "fblite"
option gosub
option explicit

declare function colormatch (byval testrange as long,byval thresh as long, _
                byval cmred as ubyte,byval cmgrn as ubyte,byval cmblu as ubyte) as long

extern "windows" lib "kernel32"
declare sub AllocConsole ()
'declare sub FreeConsole ()
end extern

'extern "windows" lib "kernel32"
'declare function GetCurrentThread () as long
'declare function SetThreadAffinityMask (byval as long, byval as long) as long
'end extern

dim shared as integer rh,rv,sh,sv,ix,iy,xc,yc,iyy,newh,newv
dim shared as integer c0,c1,c2,d0,d1,d2,v1,v2,rd,gd,bd,plane,cmd0,mindist
dim shared cpy(0 to 2) as integer

dim shared as ushort s,rstint
dim shared as ubyte cnum,sambits,bbits,bcom,dbuf,ybh,ybv,wbits
dim shared as integer bkh,bv,m,huffptr,ebsize
dim shared as integer bbytes,bho,bvo,blksdone
dim shared cr(1 to 4) as ubyte
dim shared cq(1 to 4) as ubyte
dim shared ced(1 to 8) as ubyte
dim shared olddc(1 to 4) as short
dim shared qtable(0 to 3,0 to 63) as ubyte
dim shared htl(0 to 7,0 to 15) as ubyte
dim shared htable(0 to 7,0 to 255) as ubyte
dim shared hcode(0 to 7,0 to 255) as ushort
dim shared blk4(1 to 6,0 to 63) as integer
dim shared filebuf(0 to 4095) as ubyte
redim shared encbuf(0 to 1) as integer
ebsize=1

dim shared hcount(0 to 7,0 to 256) as integer
dim shared hlength(0 to 7,0 to 2047) as ubyte
dim shared blk(0 to 63) as integer

dim shared qtable2(0 to 1,0 to 63) as ubyte
dim shared qtable3(0 to 1,0 to 63) as ubyte => _
{{ 6,4,5,6,5,4,6,6,5,6,7,7,6,8,10,16,10,10,9,9,10,20,14,15,12,16,23,20,24,24,23,20, _
  22,22,26,29,37,31,26,27,35,28,22,22,32,44,32,35,38,39,41,42,41,25,31,45,48,45,40,48,37,40,41,40 }, _
 { 7,7,7,10,8,10,19,10,10,19,40,26,22,26,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40, _
  40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40,40 }}
dim shared qtable4(0 to 1,0 to 63) as ubyte => _
{{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,2,1, _
   1,1,2,2,2,2,2,2,2,2,2,3,3,4,3,3,3,3,3,2,2,3,4,3,3,4,4,4,4,4,2,3,5,5,4,4,5,4,4,4,4 }, _
 { 1,1,1,1,1,1,2,1,1,2,4,3,2,3,4,4,4,4,4,4,4,4, _
   4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4 }}
dim shared qtable71(0 to 1,0 to 63) as ubyte => _
{{ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,2,1, _
   1,1,2,2,2,2,2,2,2,2,2,3,3,4,3,3,3,3,3,2,2,4,5,3,4,5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5 }, _
 { 1,1,1,1,1,1,2,1,1,2,4,3,2,3,4,5,5,5,5,5,5,5, _
   5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 }}

dim shared zigzag2(0 to 63) as ubyte => _
{ 0,1,5,6,14,15,27,28,2,4,7,13,16,26,29,42, _
  3,8,12,17,25,30,41,43,9,11,18,24,31,40,44,53, _
  10,19,23,32,39,45,52,54,20,22,33,38,46,51,55,60, _
  21,34,37,47,50,56,59,61,35,36,48,49,57,58,62,63 }

dim shared as integer exifptr,eindex,eindex2,extraifd
dim shared exifdump(0 to 65535) as ubyte
dim shared exiftype(0 to 99) as integer
dim shared exifunit(0 to 99) as short
dim shared exifstr(0 to 99) as string*26
dim shared labelstr as string*12
dim shared typesize(1 to 12) as ubyte => _
{ 1,1,2,4,8,1,1,2,4,8,4,8 }
dim shared knowntags(0 to 99) as integer => _
{ &H100,&H101,&H102,&H103,&H106,&H10E,&H10F,&H110,&H112, _
  &H115,&H11A,&H11B,&H128,&H131,&H132,&H13B,&H13E,&H13F, _
  &H211,&H212,&H213,&H214,&H8298,&H829A,&H829D,&H8822,&H8827,&H8828, _
  &H8830,&H8831,&H8832,&H8833,&H8834,&H8835,&H9000,&H9003,&H9004,&H9101, _
  &H9102,&H9201,&H9202,&H9203,&H9204,&H9205,&H9206,&H9207,&H9208,&H9209, _
  &H920A,&H9214,&H927C,&H9286,&H9290,&H9291,&H9292,&HA000,&HA001,&HA002, _
  &HA003,&HA004,&HA20B,&HA20C,&HA20E,&HA20F,&HA210,&HA214,&HA215,&HA217, _
  &HA300,&HA301,&HA302,&HA401,&HA402,&HA403,&HA404,&HA405,&HA406,&HA407, _
  &HA408,&HA409,&HA40A,&HA40B,&HA40C,&HA420,&HA430,&HA431,&HA432,&HA433, _
  &HA434,&HA435,&HA500,0 }
dim shared tagnames(0 to 99) as string*12 => _
{ "width       ", _
  "height      ", _
  "bits/pixel  ", _
  "compression ", _
  "color space ", _
  "title       ", _
  "device make ", _
  "dev model   ", _
  "orientation ", _
  "components  ", _
  "X res       ", _
  "Y res       ", _
  "res unit    ", _
  "software    ", _
  "date/time   ", _                          
  "artist      ", _
  "wht chroma  ", _
  "pri chroma  ", _
  "cs transfrm ", _
  "subsampling ", _
  "chrom.pos   ", _
  "B/W ref val ", _
  "copyright   ", _
  "exp. time   ", _
  "F number    ", _
  "exp. prog   ", _
  "photo sens. ", _
  "opto factor ", _
  "sens type   ", _
  "std sens    ", _
  "rec.exp.ind ", _
  "ISO         ", _
  "ISO lat y   ", _
  "ISO lat z   ", _
  "exif ver    ", _
  "org. date   ", _
  "dig. date   ", _
  "compon.conf ", _
  "comp bpp    ", _
  "shutter spd ", _
  "aperture    ", _
  "brightness  ", _
  "exp. bias   ", _
  "max aprture ", _
  "subj dist   ", _
  "metermode   ", _
  "lgt source  ", _
  "flash       ", _
  "focal len   ", _
  "subj area   ", _
  "makernote   ", _
  "user note   ", _
  "subseconds  ", _
  "o subsecond ", _
  "d subsecond ", _
  "flashpix v. ", _
  "color space ", _
  "valid X     ", _
  "valid Y     ", _
  "audio file  ", _
  "flash nrg   ", _
  "spatial rsp ", _
  "fp X res    ", _
  "fp Y res    ", _
  "fp unit     ", _
  "subj locat. ", _
  "exp index   ", _
  "sen method  ", _
  "file source ", _
  "scene type  ", _
  "CFA pattern ", _
  "cust render ", _
  "exp mode    ", _
  "wht balance ", _
  "dig zoom    ", _
  "f len @35mm ", _
  "scn capture ", _
  "gain contrl ", _
  "contrast    ", _
  "saturation  ", _
  "sharpness   ", _
  "dev setting ", _
  "subj range  ", _
  "image ID    ", _
  "cam owner   ", _
  "serial #    ", _
  "lens spec   ", _
  "lens make   ", _
  "lens model  ", _
  "lens serial ", _
  "gamma       " _
}

dim shared as integer hindex,hindex2,helpsize
dim shared helptext(0 to 99) as string*36 => _
{ "keyboard controls help              ", _
  "    general                         ", _
  " F1 opens this help window          ", _
  " F2 fit image to screen             ", _
  " F3 info window                     ", _
  " CTRL+F3 previous file              ", _
  " CTRL+F4 next file                  ", _
  " F5 show original size              ", _
  " F6 quicksave IMGTOOL.BMP           ", _
  " F7 toggle tile mode                ", _
  " F8 open drawing menu               ", _
  " F11 hide menus                     ", _
  " ALT access menu bar                ", _
  " arrows navigate menus or scroll    ", _
  " TAB cycle active menu              ", _
  " PGUP/PGDN/HOME/END aspect / zoom   ", _
  "                                    ", _
  "    tile edit mode                  ", _
  " CTRL+arrow - scroll image          ", _
  " space - toggle cursor              ", _
  " 2 / 4 - zoom image to 2x / 4x      ", _
  " g / h - get / put tile             ", _
  " H - replace all identical tiles    ", _
  " v - define upper-left point        ", _
  " b - define lower-right pt. and copy", _
  " n - paste (same as h)              ", _
  " N - paste with transparency        ", _
  " m - define lower-right pt. and fill", _
  " < - paste 2x size                  ", _
  " w - brighten tile                  ", _
  " s - darken tile                    ", _
  " e - enter pixel editor             ", _
  "                                    ", _
  "    pixel edit mode                 ", _
  " q - exit pixel editor              ", _
  " CTRL+arrow - move to adjacent tile ", _
  " a - open / change to palette window", _
  " G - get color and blend            ", _
  " g / h - get / put color            ", _
  " H - replace all identical colors   ", _
  " v - define upper-left point        ", _
  " b - define lower-right pt. and copy", _
  " n - paste                          ", _
  " N - paste with mask                ", _
  " m - define lower-right pt. and fill", _
  " S - define  ...  and darken        ", _
  " t - toggle mask mode               ", _
  " s - darken pixel                   ", _
  " 1/2/3 increase R/G/B by 10         ", _
  " SHIFT+1/2/3 increase R/G/B by 1    ", _
  " - / + - palette color selection    ", _
  " i - flip tile horizontally         ", _
  " I - flip tile vertically           ", _
  " o - outline inside area            ", _
  " O - black border inside area       ", _
  " f - copy horizontal line           ", _
  " j - paste horizontal line          ", _
  " l - fill area (same as fill tool)  ", _
  " z - define point and draw line     ", _
  " / - invert mask                    ", _
  " | - rotate tile 90 degrees         ", _
  " p - toggle palette bind mode       ", _
  " P - build palette from tile        ", _
  "                                    ", _
  "    drawing palette window controls ", _
  " 1/2/3 - increase R/G/B by 10       ", _
  " SHIFT+1/2/3 - increase R/G/B by 1  ", _
  " b - set color to black             ", _
  " r - reset to default colors        ", _
  "end" _
}
helpsize=0
while helptext(helpsize)<>"end"
helpsize+=1
wend

dim shared as any ptr scrp
dim shared as integer ptr xptr,yptr
dim shared as ubyte ptr bp1,bp2,cbp,scrp2
dim shared as double bfps,btimer
dim shared as single scale,scaleold,aspect,aspectold
dim shared as single pi,z1,z2,z3,z4,r1,r2,r3
dim shared as integer u,bools1,bools2,maxx,maxy,lbytes,pbytes
dim shared as integer tcopyh,tcopyv,pcopyh,pcopyv
dim shared as integer maxh,maxv,amxold,amyold,bmp1h,bmp1v,maxh2,barg
dim shared as integer c,h,v,hh,vv,x,y,z,xx,yy,zz,mx,my,amx,amy,mw,mb,ff1,ff2

'ff2=freefile:open "derp.txt" for output as #ff2

dim shared as integer mxold,myold,mwold,mbold,h1,h2,f0,f1,f2,tformat,orgformat
dim shared as integer oldmx,oldmy,txtheight,lastalt,i0,i1,i2,i3,dirindex
dim shared as integer renderh,renderv,numbuttons,wid,imgtype,bgc,bgc2
dim shared as integer findex,findex2,findold,lastattr,totalfiles
dim shared as integer lfrt,updn,snapmask,pastex,pastey
dim shared as integer zoneh1,zoneh2,zonev1,zonev2,numzone,pzone
dim shared as short region,defcol,focusb=-1,focusw=-1
dim shared as ubyte redraw,render,recalc,lc,rc,a,e,nextbox,uitool,notool
dim shared as ubyte message,winmove,mpwin,r,g,b,hidemenu,fillhole,bmode
dim shared as ubyte scrollb,scrollpos,mouserep,dragscroll,oldmsg,palindex
dim shared aa as string*1
'dim shared pindex(1 to 39) as byte
'dim shared pindex2(1 to 39) as byte
dim shared stats(0 to 80) as integer
dim shared fpval(0 to 29) as single
dim shared blah(0 to 10) as ubyte
dim shared ki as string
dim shared ki2 as string
dim shared fname as string
dim shared sstr as string*4
dim shared wtitle as string*30
dim shared penpal(0 to 63) as integer
dim shared tline(0 to 63,0 to 3) as ubyte
dim shared gradact(0 to 9) as ubyte
dim shared gradh(0 to 9) as integer
dim shared gradv(0 to 9) as integer
dim shared gradc(0 to 9) as integer
dim shared gradprox(0 to 9) as single
dim shared gradc2(0 to 9,0 to 9) as integer
dim shared gradist(0 to 9,0 to 9) as single
dim shared gradang(0 to 9,0 to 9) as single
dim shared gradcr(0 to 9,0 to 9) as single
dim shared gradsr(0 to 9,0 to 9) as single
dim shared graddist as single
dim shared gradflatc as integer
dim shared graddiv as single
dim shared gradred as single
dim shared gradgrn as single
dim shared gradblu as single

gosub defaultdrawpal

'{ &H000000,&H0000AA,&H00AA00,&H00AAAA,&HAA0000,&HAA00AA,&HAAAA00,&HAAAAAA, _
'  &H555555,&H5555FF,&H55FF55,&H55FFFF,&HFF5555,&HFF55FF,&HFFFF55,&HFFFFFF }

'x=SetThreadAffinityMask(GetCurrentThread,1)

dim shared imgspecs(0 to 4) as string*5 => _
{ "*.bmp","*.jpg","*.png","*.tex","*.*  " }

dim shared dirfiles(0 to 13) as string*64
dim shared dirattr(0 to 13) as integer

' bpal is 18-bit RGB, cspace is 24-bit RGB (both 32-bit aligned)
dim shared cspace(0 to 65535,0 to 3) as ubyte
dim shared bpal(0 to 262143) as integer
dim shared ccount(0 to 262143) as integer
dim shared bcount(0 to 262143) as integer

' PNG stuff

dim shared ltable(257 to 285) as ubyte => _
{ 0,1,2,3,4,5,6,7,8,10,12,14,16,20,24,28,32, _
 40,48,56,64,80,96,112,128,160,192,224,255 }
dim shared dtable(0 to 29) as ushort => _
{ 1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769, _
 1025,1537,2049,3073,4097,6145,8193,12289,16385,24577 }
dim shared ccorder(0 to 18) as ubyte => _
{ 16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15 }

dim shared as integer w,l,crc32,blklen,stackloc
dim shared as integer windex,psh,psv,clen,cd
dim shared as integer paeth,pdiff,pa,pb,pc
dim shared as ubyte dbits,bitdepth,lastblk,blktype,lbits
dim shared as ubyte filter,px,colrtype
dim shared wdata(0 to 32767) as ubyte
dim shared ccodes(0 to 18) as ubyte
dim shared clengths(0 to 18) as ubyte
dim shared llengths(0 to 485) as ubyte
dim shared lreverse(0 to 32767) as ubyte
dim shared dreverse(0 to 32767) as ubyte
dim shared pngpal(0 to 255,0 to 2) as ubyte

' some tables for huffman encoding/decoding
dim shared ptl(0 to 15) as ushort
dim shared ptable(0 to 285) as ushort
dim shared pcode(0 to 285) as ushort

' UI stuff

dim shared messages(0 to 26) as string*25 => _
{ _
 "                         ", _
 "Canceled.                ", _
 "Error: unrecognized file ", _
 "Error: size is too large ", _
 "Error: data decode error ", _
 "File saved.              ", _
 "File loaded.             ", _
 "must be <=256 col palette", _
 "Bitmap cleared!          ", _
 "Error: couldn't open file", _
 "function not implemented ", _         ' 10
 "Nothing selected!        ", _
 "Palette loaded.          ", _
 "Palette saved.           ", _
 "color map loaded.        ", _
 "invalid rectangle        ", _
 "EHB fail: too many colors", _
 "copied.                  ", _
 "out of bounds!           ", _
 "cleared points!          ", _
 "removed a point.         ", _         ' 20
 "no points defined!       ", _
 "Error: redundant points  ", _
 "pal fail: too many colors", _
 "too many palettes        ", _
 "Error: file not found    ", _
 "Can't save this format!  " _
}

' text colors
dim shared tcol(0 to 15) as integer
dim shared tcolrgb(0 to 15) as integer => _
{ &H000000,&H404040,&H808080,&HC0C0C0,&H000040,&H80C080,&HC08080,&H8080C0, _
  &HC0A080,&HC060C0,&HC000C0 }

' color for each button type
dim shared buttcol(0 to 16) as ubyte => _
{ 2,7,5,6,2,2,9,8,2,2, _
  2,9,8,2,2,8,2 }

' h position, v position, width (chars), button ID, window ID, misc
dim shared btlst(0 to 199,0 to 5) as ubyte

dim shared winadrs(0 to 39) as ushort

' window data format
' 1 byte - h position
' 1 byte - v position
' 1 byte - width (unused?)
' 1 byte - number of buttons
' n bytes - ID of each button
dim shared windata(0 to 999) as ubyte => _
{ _
 2,2,16,1,0, _
 2,4,16,16,14,81,6,158,7,133,8,66,67,9,12,82,83,5,10,11, _          ' file
 2,4,16,16,14,22,23,24,27,142,21,68,69,70,80,86,25,71,72,112, _     ' edit
 2,4,16,14,14,15,16,17,18,19,20,58,59,60,110,109,131,161, _            ' view
 2,4,16,13,14,181,34,35,36,171,40,41,128,121,122,134,135, _         ' colors
 19,4,16,17,14,73,85,141,152,74,75,76,77,78,79,87,84,120,132,139,140, _   ' drawing
 19,4,16,7,14,10,11,31,32,136,137, _                ' resize
 19,4,16,16,14,57,42,43,44,45,46,47,61,48,175,49,96,130,97,98, _    ' color space
 19,4,16,19,14,56,167,129,50,165,162,51,53,54,55,93,94,95,99,168,169,163,164, _   ' color palettes
 2,4,16,5,14,62,63,64,65, _                        ' debug
 2,4,36,19,14,89,91,90,88,88,88,88,88,88,88,88,88,88,88,88,88,88,92, _ ' file list
 19,4,16,15,14,100,101,102,103,177,178,179,180,104,105,106,107,108,33, _    ' screen mode
 19,4,16,13,14,111,113,114,138,115,116,117,118,170,172,173,174, _         ' tile editing
 2,20,32,5,14,119,119,119,119, _                         ' drawing palette
 19,4,16,6,14,125,123,126,124,127, _                     ' noise reduction
 19,4,16,10,14,143,144,145,146,147,148,149,150,151, _     ' infowin
 19,4,16,6,14,153,154,155,156,157, _                      ' gradient tools
 2,4,36,16,14,159,160,160,160,160,160,160,160,160,160,160,160,160,160,160, _  ' exif
 2,4,36,16,14,159,176,176,176,176,176,176,176,176,176,176,176,176,176,176, _   ' help
 19,4,16,14,14,37,38,39,182,183,184,185,186,187,188,189,190,191 _         ' color channels  (19)
}
dim shared btext(0 to 199) as string*16 => _
{ _
 "                ", _
 "  File          ", _
 "  Edit          ", _
 "  View          ", _
 " Colors         ", _
 " Quit           ", _
 " Open           ", _ 
 " Save           ", _ 
 " save as Bmp 24 ", _
 " save as Tex    ", _
 "width           ", _          ' 10
 "height          ", _
 " save as Jpeg   ", _
 "                ", _
 "---- close -----", _
 "aspect          ", _
 "scaling         ", _
 "h offset        ", _
 "v offset        ", _
 "Original size   ", _
 "[_] locK view   ", _          ' 20
 "selection Tool  ", _
 "flip X          ", _
 "flip Y          ", _
 "Benchmark       ", _
 "Drawing         ", _
 "Angle           ", _
 "reSize image    ", _
 "[_] Lock aspect ", _
 "X scale         ", _
 "Y scale         ", _          ' 30
 "nEw x           ", _
 "neW y           ", _
 "....confirm.....", _
 "[_] adJust color", _
 "Contrast        ", _
 "brigHt          ", _
 "Red add         ", _
 "Green add       ", _
 "Blue add        ", _          
 "color Space     ", _          ' 40
 "color Palette   ", _
 "# of levels for ", _
 " each component ", _
 "Red             ", _
 "Green           ", _
 "Blue            ", _
 "[_] Intensty bit", _
 "[_] Dithering   ", _
 "[_] Floyd/steinb", _
 "Pal size        ", _          ' 50
 "[_] Multipalette", _
 "# of palS       ", _
 "pal zone size   ", _
 "Width           ", _
 "Height          ", _
 "[_] Use palette ", _
 "[_] adJust depth", _
 "Fit to screen   ", _
 "[_] Auto resize ", _
 "[_] auto Center ", _          ' 60
 "[_] greYscale   ", _
 "debug 1         ", _
 "debug 2         ", _
 "debug 3         ", _
 "debug 4         ", _
 " save as bMp 15 ", _
 " save as bmP 8  ", _
 " cRop           ", _
 " Copy           ", _
 " Paste          ", _          ' 70
 "rOtate right    ", _
 "rotate Left     ", _
 "Pen tool        ", _
 "<  pen color   >", _
 "Color #         ", _
 " Red            ", _
 " Green          ", _
 " Blue           ", _
 " pen Size       ", _
 " Alpha          ", _          ' 80
 " New            ", _
 "jpeg quality    ", _
 "(1...7)         ", _
 "gEt color tool  ", _
 "Line tool       ", _
 "[_] transpareNcy", _
 "set bacKground  ", _
 "                ", _
 "filename Entry  ", _
 "<prev page next>", _          ' 90
 "[_] All files   ", _
 " (current path) ", _
 "Load custom pal ", _
 "[_] use Custom  ", _
 "saVe custom pal ", _
 "Load custom map ", _
 "[_] use Custom  ", _
 "vieW color map  ", _
 " vIew palette   ", _
 "current screen: ", _          ' 100
 "width           ", _
 "height          ", _
 "depth           ", _
 "custom scr mode:", _
 "Width           ", _
 "Height          ", _
 "Depth           ", _
 "      Test      ", _
 "change Resolutin", _
 "[_] rEset aspect", _          ' 110
 "[_] Tile mode   ", _
 "tIle editing    ", _
 "cursor h        ", _
 "cursor v        ", _
 " tile size      ", _
 "Width           ", _
 "Height          ", _
 "[_] Align curs x", _
 "                ", _
 "draWing palette ", _          ' 120
 "make all changes", _
 "   pErmanent    ", _
 "[_] Luma smooth ", _
 "[_]chrOma smooth", _
 "[_] Antistatic  ", _
 "strength        ", _
 "strength        ", _
 "Noise reduction ", _
 "[_] Ehb mode    ", _
 "cOpy from palett", _          ' 130
 "[_]show Mask lyr", _
 "[_] draw on Mask", _
 " save As bmp 32 ", _
 "[_] Apply mask  ", _
 " Invert mask    ", _
 "Stretch/shrink  ", _
 "move Border only", _
 "tile #          ", _
 "[_] mouse griD  ", _
 "grId size       ", _          ' 140
 "Fill tool       ", _
 "copy all        ", _
 " selection size ", _
 "width           ", _
 "height          ", _
 " screen coords  ", _
 "X               ", _
 "Y               ", _
 " bitmap coords  ", _
 "X               ", _          ' 150
 "Y               ", _
 "grAdient tools  ", _
 "points          ", _
 "Clear points    ", _
 "Remove point    ", _
 "Plotting tool   ", _
 "Shade it!       ", _
 "show exiF data  ", _
 " <   page     > ", _
 "                ", _          ' 160
 "[_]Paste preview", _
 "f Bias          ", _
 "[_] yuv Matching", _
 "Y bias          ", _
 "org.count       ", _
 "Max error       ", _
 "[_] Dithering   ", _
 "copy To drawing ", _
 "copy From drawng", _
 "[_] aLign curs y", _          ' 170
 "[_] round Down  ", _
 "[_] alt curs Siz", _
 "wIdth           ", _
 "hEight          ", _
 "ordEred         ", _
 "                ", _
 "   640x480x8    ", _
 "   800x600x16   ", _
 "  1024x768x32   ", _
 "  1280x960x32   ", _           ' 180
 "cOlor channels  ", _
 "swap blu<->green", _
 "swap blu<->red  ", _
 "swap blu<->alpha", _
 "swap grn<->red  ", _
 "swap grn<->alpha", _
 "swap red<->alpha", _
 "invert blue     ", _
 "invert green    ", _
 "invert red      ", _           ' 190
 "invert alpha    " _
}

' baction applies to modifiable parameters and checkboxes
' 0 = no action, 1 = render, 2 = recalc, 3+x recalc dependant on checkbox
' 253 = recalc if "use palette" or "use custom (pal)" or "adjust depth" are checked
' 254 = recalc if either "use palette" or "use custom (pal)" is checked
' 255 = check temp file for dimensions of rectangle to paste
dim shared baction(0 to 199) as ubyte => _
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, _
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,6,6,6,6, _
  0,0,0,0,11,11,11,11,11,11,10,10,10,0,10,10,2,2,0,0, _
  0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, _
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,11,0,0, _
  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,0, _
  0,0,0,2,2,2,23,24,0,10,0,2,0,0,2,0,0,0,0,2, _
  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, _
  0,255,10,254,254,0,11,10,0,0,1,253,1,1,1,11,0,0,0,0, _
  0,0,0,0,0,0,0,0,0,0,0,0 }

dim shared bwidth(0 to 199) as ubyte => _
{ 16,8,8,8,8,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,36,16,16,16,32,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,32, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16, _
  38,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,36,16,16,16, _
  16,16,16,16,16,16,16,16,16,16,16,16 }
' button types
'  0 = does nothing     1 = opens a window
'  2 = check box        3 = misc function
'  4 = shows parameter  5 = modifiable parameter
'  6 = part name        7 = editable part name
'  8 =                  9 = item in file list
' 10 = palette colors  11 = EXIF string
' 12 =                 13 =
' 14 = help text       15 =
' 16 =
dim shared btype(0 to 199) as ubyte => _
{ 0,1,1,1,1,3,1,3,3,3,4,4,3,0,3,4,4,4,4,3, _
  2,3,3,3,3,1,5,1,2,5,5,5,5,3,2,5,5,5,5,5, _
  1,1,0,0,5,5,5,2,2,2,5,2,5,0,5,5,2,2,3,2, _
  2,2,4,4,4,4,3,3,3,3,3,3,3,3,3,5,5,5,5,5, _
  5,3,0,5,3,3,2,3,9,3,3,2,3,3,2,3,3,2,3,3, _
  0,4,4,4,0,5,5,5,3,1,2,2,1,4,4,0,5,5,2,10, _
  1,0,3,2,2,2,5,5,1,2,3,2,2,3,2,3,3,3,4,2, _
  5,3,3,0,4,4,0,4,4,0,4,4,1,4,3,3,3,3,1,3, _
  11,2,5,2,5,4,5,2,3,3,2,2,2,5,5,5,14,3,3,3, _
  3,1,3,3,3,3,3,3,3,3,3,3 }
dim shared bparam(0 to 199) as ubyte => _
{ 0,1,2,3,4,0,10,2,3,49,0,1,22,0,4,120,121,2,3,5, _
  0,13,6,7,8,5,52,6,2,53,54,4,5,9,3,6,7,8,9,10, _
  7,8,0,0,11,12,13,10,4,5,15,6,16,0,17,18,7,8,10,9, _
  1,11,20,21,22,23,11,12,14,15,16,17,18,19,20,24,25,26,27,28, _
  29,21,0,30,23,24,12,25,0,1,26,13,27,28,14,32,29,15,30,31, _
  0,38,39,40,0,41,42,43,33,11,16,17,12,46,47,0,48,49,18,0, _
  13,0,34,20,21,22,55,56,14,23,35,25,26,36,27,37,38,39,57,28, _
  58,40,41,0,65,66,0,59,60,0,61,62,16,72,42,43,44,45,17,46, _
  0,30,73,32,74,19,75,33,47,48,34,36,37,76,77,80,0,50,51,52, _
  53,19,54,55,56,57,58,59,60,61,62,63 }
dim shared bkey as string*199 => _
 " fevcqosbt  j -    o" _
 "ktxybdaslxyew.jchrgb" _
 "sp  rgbidfpms whujfa" _
 "c     mprcpolp crgbs" _
 "an  elnk e a lcvlcwi" _
 "     whdtreti   wha " _
 "w eloa  neommaaisb d" _
 "if          a crpsf " _
 " pbmy mdtfldsiee    " _
 " o          "


' install menu bar
btlst(0,0)=2:btlst(0,1)=2:btlst(0,2)=8:btlst(0,3)=1:btlst(0,4)=0
btlst(1,0)=12:btlst(1,1)=2:btlst(1,2)=8:btlst(1,3)=2:btlst(1,4)=0
btlst(2,0)=22:btlst(2,1)=2:btlst(2,2)=8:btlst(2,3)=3:btlst(2,4)=0
btlst(3,0)=32:btlst(3,1)=2:btlst(3,2)=8:btlst(3,3)=4:btlst(3,4)=0
numbuttons=4
findex=0:findold=1

' build an index into window data
x=0:y=0
a99:
winadrs(y)=x:y=y+1
z=windata(x+3)
if z>0 then x=x+4+z:goto a99


bmode=0
if command$(1)="batch" then bmode=1
if command$(1)="BATCH" then bmode=1

tformat=24

' gfx stuff

stats(44)=0:stats(45)=0
stats(41)=320:stats(42)=240:stats(43)=8        ' default values for resolutin

' other defaults that may be overridden by INI file
stats(15)=256           ' default palette size
stats(28)=1             ' default pen size
stats(30)=4             ' default JPEG quality   
bgc=0

xx=19:stats(40)=32
if bmode=1 then
AllocConsole
barg=2:stats(38)=800:stats(39)=600:txtheight=16:goto skipscreen
end if

' load settings from IMGTOOL.INI
ff1=freefile
ki2=exepath+"\IMGTOOL.INI"
open ki2 for binary as #ff1
if err<>0 then goto skipini
if lof(ff1)=0 then
' write default settings if file didn't exist
print #ff1,"' settings file for IMGTOOL"
print #ff1,""
print #ff1,"' screen modes:"
print #ff1,"'    13 - 320x200    14 - 320x240    15 - 400x300"
print #ff1,"'    16 - 512x384    17 - 640x400    18 - 640x480"
print #ff1,"'    19 - 800x600    20 - 1024x768   21 - 1280x1024"
print #ff1,"'"
print #ff1,"' or specify custom mode with 8 digits eg. 11520864"
print #ff1,"''''"
print #ff1,"mode = 19"
print #ff1,""
print #ff1,"'''' color depth: 8,15,16,24, or 32"
print #ff1,"cdep = 32"
print #ff1,""
print #ff1,"' default bitmap size for memory allocation"
print #ff1,"' (larger setting may avoid page faults under DOS)"
print #ff1,"''''"
print #ff1,"bmph = 0"
print #ff1,"bmpv = 0"
print #ff1,""
print #ff1,"' program default settings"
print #ff1,"'"
print #ff1,"'''' JPEG quality - 1 (low) to 7 (high)"
print #ff1,"jpeg = 4"
print #ff1,""
print #ff1,"'''' pen size (radius)"
print #ff1,"pens = 1"
print #ff1,""
print #ff1,"'''' palette size"
print #ff1,"pals = 256"
print #ff1,""
print #ff1,"'''' background color - 0 to 16777215"
print #ff1,"bgco = 0"
goto a102
end if
do
get #ff1,,sstr
if sstr="mode" then gosub getnum:xx=x
if sstr="cdep" then gosub getnum:stats(40)=x
if sstr="bmph" then gosub getnum:stats(44)=x
if sstr="bmpv" then gosub getnum:stats(45)=x
if sstr="jpeg" then gosub getnum:stats(30)=x
if sstr="pens" then gosub getnum:stats(28)=x
if sstr="pals" then gosub getnum:stats(15)=x
if sstr="bgco" then gosub getnum:bgc=x
do
if eof(ff1) then goto a102
get #ff1,,a
loop until a=10
loop
a102:
close #ff1

skipini:

if xx>21 then
yy=(xx\10000):xx=xx-(yy*10000)
screenres yy,xx,stats(40)
else
screen xx,stats(40)
end if
gosub setscreen

skipscreen:

gosub screenresize

maxh=stats(38):maxv=stats(39)           ' default bitmap size
if stats(44)+stats(45)>2 then stats(38)=stats(44):stats(39)=stats(45)

redim shared bmp1(0 to maxy,0 to maxx,0 to 3) as ubyte
redim shared bmp2(0 to maxy,0 to maxx,0 to 3) as ubyte
redim shared lbuf(0 to maxh*4) as ubyte
redim shared oldline(0 to maxh*4) as ubyte
redim shared lbuf2(0 to maxv*3) as ubyte
redim shared cbuf(0 to maxy,0 to lbytes-1) as ubyte
cbp=@cbuf(0,0)
redim shared tyuv(0 to 1,0 to 1,0 to 2) as short

dim shared zigzag(0 to 79) as ubyte => _
{ 0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5, _
  12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28, _
  35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51, _
  58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63, _
  63,63,63,63,63,63,63,63,63,63,63,63,63,63,63,63 }

dim shared itable(0 to 4095) as integer

pi=3.1415926

' build a lookup table to speed up iDCT later
zz=0
for y=0 to 7
for x=0 to 7
z1=1
if x=0 then z1=z1*.707107
if y=0 then z1=z1*.707107
for yy=0 to 7
z3=z1*cos(pi*y*((yy*2)+1)/16)
for xx=0 to 7
z2=z3*cos(pi*x*((xx*2)+1)/16)
itable(zz)=(z2*65536)
zz+=1
next xx
next yy
next x
next y

gosub newfile
bools1=&H40002:bools2=4

' default color space settings
stats(11)=256:stats(12)=256:stats(13)=256:stats(14)=0
stats(29)=255           ' default alpha for paste
stats(4)=100:stats(5)=100       ' default H,V

' default noise reduction strength
stats(55)=1
stats(56)=8

' default tile size
stats(48)=8:stats(49)=8
stats(76)=16:stats(77)=16

' default box color
stats(71)=&HFFFFFF

' default grid pitch
stats(58)=8

stats(72)=0        ' clear gradient points

stats(73)=0        ' default f bias


if bmode=0 then if command$<>"" then ki2=command$:gosub openfile2


uistart:

' sanity check one
if bmp1h<1 then bmp1h=1
if bmp1v<1 then bmp1v=1
if stats(17)<1 then stats(17)=bmp1h
if stats(17)>bmp1h then stats(17)=bmp1h
if stats(18)<1 then stats(18)=bmp1v
if stats(18)>bmp1v then stats(18)=bmp1v


' ------------------------ batch mode -------------------------------
if bmode<>0 then
bools1=(bools1 or 4096)         ' set paste-with-transparency bit
' in batch mode don't bother with UI at all, just process cmd-line args
ki=command$(barg):barg+=1:if ki="" then end
'aa=mid$(ki,1,1):ki2=mid$(ki,2,len(ki)-1)
aa=mid$(ki,1,1):ki2=mid$(ki,2)
if aa="o" then
? "opening file: ";ki2:gosub openfile2
if message<>6 then ? messages(message):goto endbatch
goto uistart
end if
if aa="w" then                                  ' weird stuff for combining G.Z.F. maps
? "appending file: ";ki2
ff1=freefile:open ki2 for binary as #ff1
get #ff1,,s:if s<>&H4D42 then goto endbatch
z=11:get #ff1,z,yy:yy+=1
z=19:get #ff1,z,x
z=23:get #ff1,z,y
gosub dupebmp:extraifd=x:exifptr=bmp1v
maxv=bmp1v+y:gosub resizemem3:gosub redupebmp
redim bmp2(0 to maxv-1,0 to maxh-1,0 to 3) as ubyte
xx=x shl 2
while y>0
y=y-1:get #ff1,yy,bmp1(bmp1v+y,0,0),xx
for z=x to bmp1h-1:*cast(integer ptr,@bmp1(bmp1v+y,z,0))=0:next z
yy+=xx
wend
bmp1v=maxv:bmode=3
goto uistart
end if
if aa="s" then
if bmode<>2 then ? "processing...":gosub dothethings
if bmode=3 then swap bmp1v,exifptr
? "saving file: ";ki2:gosub savefile2
if message<>5 then ? messages(message):goto endbatch
if bmode=3 then 
for y=0 to exifptr-bmp1v-1
for x=0 to extraifd-1
*cast(integer ptr,@bmp1(y,x,0))=*cast(integer ptr,@bmp1(bmp1v+y,x,0))
*cast(integer ptr,@bmp2(y,x,0))=*cast(integer ptr,@bmp2(bmp1v+y,x,0))
next x
next y
bmode=2:bmp1h=extraifd:bmp1v=exifptr-bmp1v
end if
goto uistart
end if
if aa="m" then
? "load color space file: ";ki2
f1=29:goto a375
end if

if aa="c" then f1=39:? "cropping image":goto resizeimg
f1=38           ' needs to be set for resizeimg (stretch/shrink mode)
if aa="r" then ? "resizing image":goto resizeimg
if aa="p" then ? "pasting image":amx=stats(4):amy=stats(5):goto pastetmp
if aa="4" then ? "resize to quarter":newh=(bmp1h shr 1):newv=(bmp1v shr 1):goto resizeimg2

if aa="v" then
'aa=mid$(ki2,1,1):x=valint(mid$(ki2,2,len(ki2)-1))
aa=mid$(ki2,1,1):x=valint(mid$(ki2,2))
if aa="t" then ? "set format to ";x:tformat=x
if aa="a" then ? "set alpha to ";x:stats(29)=x
if aa="q" then ? "set jpeg quality to ";x:stats(30)=x
if aa="v" then ? "set vertical to ";x:stats(5)=x
if aa="h" then ? "set horizontal to ";x:stats(4)=x
if aa="l" then
? "set long side to ";x
'stats(4)=bmp1h:stats(5)=bmp1v:
z1=x
if bmp1v>bmp1h then
stats(5)=x:stats(4)=(z1*bmp1h)\bmp1v
else
stats(4)=x:stats(5)=(z1*bmp1v)\bmp1h
end if
end if
goto uistart
end if

if aa="a" then
aa=mid$(ki2,1,1):x=valint(mid$(ki2,2))
if aa="r" then ? "set red levels to ";x:stats(11)=x
if aa="g" then ? "set grn levels to ";x:stats(12)=x
if aa="b" then ? "set blu levels to ";x:stats(13)=x
if aa="n" then ? "set palette size to ";x:stats(15)=x
if aa="p" then ? "enable palette change":bools1=(bools1 or &H80)
if aa="d" then ? "enable palette dither":bools2=(bools2 or 2)

if aa="c" then ? "enable color space change":bools1=(bools1 or &H100)
if aa="m" then ? "enable custom space":bools1=(bools1 or &H8100)
if aa="e" then ? "enable color space dither":bools1=(bools1 or 16)
if aa="f" then ? "enable floyd-steinberg":bools1=(bools1 or 48)

if aa="a" then ? "enable color adjust":bools1=(bools1 or 8)
if aa="y" then ? "set brightness to ";x:stats(7)=x
if aa="o" then ? "set contrast to ";x:stats(6)=x
goto uistart
end if

? "invalid argument: ";ki

endbatch:
? "A problem occurred. Press any key to exit."
sleep
end


' this gets called when recalc=1, or in batch mode before saving
dothethings:
if (bools1 and &H400000) then goto antistatic
gosub dupebmp
a289:
if (bools1 and &H300000) then gosub noisereduce
if (bools1 and 8) then gosub coloradj
if (bools1 and &H100) then gosub colorspace
stats(19)=0:if (bools1 and &H4080) then gosub palettes
'if bmode<>0 then return
if (bools1 and &H8000000) then goto applymask
a298:             
return

end if
' end of batch mode stuff


if message=6 then                                ' file just loaded...
if (bools1 and 65536) then aspect=1
if (bools1 and 512) then gosub fitscreen
if (bools1 and 2) then gosub centerscreen
end if

' sanity check two
if aspect<.125 then aspect=.125
if aspect>8 then aspect=8
if scale<.0625 then scale=.0625
if scale>16 then scale=16
if scale<>scaleold then
x=(stats(38) shr 1):y=(stats(39) shr 1)
renderh=x-(((x-renderh)/scaleold)*scale)
renderv=y-(((y-renderv)/scaleold)*scale)
end if
if renderh>maxx-1 then renderh=maxx-1
if renderv>maxy-1 then renderv=maxy-1

scaleold=scale
aspectold=aspect

if stats(73)<0 then stats(73)=0

' check tile/pixel mode cursor size/position
if stats(48)<4 then stats(48)=4
if stats(48)>64 then stats(48)=64
if stats(49)<4 then stats(49)=4
if stats(49)>64 then stats(49)=64
if stats(76)<4 then stats(76)=4
if stats(76)>64 then stats(76)=64
if stats(77)<4 then stats(77)=4
if stats(77)>64 then stats(77)=64

if (bools2 and 32) then
stats(78)=stats(76):stats(79)=stats(77)
else
stats(78)=stats(48):stats(79)=stats(49)
end if

' pixel position vs. bitmap edge
if stats(46)+stats(53)>=bmp1h then stats(53)=bmp1h-stats(46)-1
if stats(47)+stats(54)>=bmp1v then stats(54)=bmp1v-stats(47)-1

' pixel position vs. window edge
if stats(53)<0 then stats(53)+=stats(78):stats(46)=stats(46)-stats(78):recalc=1
if stats(53)>=stats(78) then stats(53)=0:stats(46)+=stats(78):recalc=1
if stats(54)<0 then stats(54)+=stats(79):stats(47)=stats(47)-stats(79):recalc=1
if stats(54)>=stats(79) then stats(54)=0:stats(47)+=stats(79):recalc=1

if stats(46)<0 then stats(46)=0
if stats(47)<0 then stats(47)=0
if stats(46)>=bmp1h then stats(46)=bmp1h-1
if stats(47)>=bmp1v then stats(47)=bmp1v-1
if (bools1 and 262144) then stats(46)=(stats(46)\stats(48))*stats(48)
if (bools2 and 4) then stats(47)=(stats(47)\stats(49))*stats(49)

' check RGB values
if stats(25)<0 then stats(25)=0
if stats(25)>255 then stats(25)=255
if stats(26)<0 then stats(26)=0
if stats(26)>255 then stats(26)=255
if stats(27)<0 then stats(27)=0
if stats(27)>255 then stats(27)=255


if recalc=1 then
eindex=0
if (bools1 and &H12704188) then
locate 1,1,0:? "B"
gosub dothethings
if (bools1 and &H2000000) then gosub showmask
if (bools1 and &H10000000) then gosub showgrid
end if
recalc=0
render=1
end if

if recalc=2 then
redraw=1:recalc=0:focusw=-1:focusb=-1
if hidemenu=1 then if stats(40)=8 then if (bools1 and 128) then if stats(15)<257 then gosub displaycustom
end if

if render>0 then
'locate 1,1,0:? "b"
newh=bmp1h*scale*aspect
newv=bmp1v*scale
if renderh+newh<2 then renderh=2-newh
if renderv+newv<2 then renderv=2-newv
bp1=@bmp1(0,0,0)
if (bools1 and &H12704188) then bp1=@bmp2(0,0,0)

if ((scale=1) and (aspect=1)) then gosub definearea2:gosub straightcopy:goto a241

if render=2 then
' fast scrolling for zoomed image without rendering the whole thing again
if renderh<>stats(2) then gosub scrollh
if renderv<>stats(3) then gosub scrollv
goto a241
end if

gosub definearea2
gosub resizex

a241:
gosub clearempty

render=0
redraw=1
end if


if redraw>0 then
stats(0)=bmp1h:stats(1)=bmp1v
fpval(0)=aspect:fpval(1)=scale

penpal(stats(24))=(stats(27) and 255)+((stats(26) and 255) shl 8)+((stats(25) and 255) shl 16)

screenlock
if (redraw or oldmsg)<>2 then gosub copybuffer:oldmsg=0

if hidemenu=0 then
gosub showgui
color tcol(5),tcol(0)
if message>0 then locate 23,1,0:? messages(message);:oldmsg=1
end if
screenunlock
message=0
redraw=0
end if

a18:

gosub readmouse

ki=inkey$

' benchmark mode
if uitool=5 then
if timer>btimer+4 then btimer=timer:bfps=0
if rc=2 then uitool=0
if ki<>"" then uitool=0
'ki2=fname:gosub openfile3:recalc=1
'fname="benchmrk.jpg":tformat=70:gosub savefile:redraw=1
fname="benchmrk.tex":tformat=50:gosub savefile:redraw=1
goto uistart
end if

' check whether ALT has been pressed (pain in the ass)
x=multikey(56)
if x=0 then goto a100
if lastalt<>0 then goto a100
redraw=2:focusb=-1:hidemenu=0
if focusw<>0 then focusw=0:goto a100
focusw=-1
a100:
lastalt=x:if redraw>0 then goto uistart

if ki<>"" then goto a54
if oldmx<>mx then goto a54
if oldmy<>my then goto a54
if mbold<>mb then goto a54
if mwold<>mw then goto a54

sleep 40
if mouserep=1 then lc=1:goto a54
goto a18


a54:

if (mb and 1)=0 then mouserep=0
'scrollb=0

if lc+rc>0 then mxold=mx:myold=my

' compute stats for infowin             
stats(59)=mx
stats(60)=my
stats(61)=(mx-renderh)/(scale*aspect)
stats(62)=(my-renderv)/scale
if stats(61)<0 then stats(61)=0
if stats(62)<0 then stats(62)=0
if stats(61)>=bmp1h then stats(61)=bmp1h-1
if stats(62)>=bmp1v then stats(62)=bmp1v-1
if (bools1 and &H10000000) then
stats(63)=((stats(61)+(stats(58) shr 1))\stats(58))*stats(58)
stats(64)=((stats(62)+(stats(58) shr 1))\stats(58))*stats(58)
else
stats(63)=stats(61)
stats(64)=stats(62)
end if

if ki=chr$(255)+chr$(59) then f2=18:goto openwin        ' F1 help window

if ki=chr$(255)+chr$(60) then gosub fitscreen:gosub centerscreen:goto a89        ' F2 fit screen

if ki=chr$(255)+chr$(61) then f2=15:goto openwin        ' F3 info win

if ki=chr$(255)+chr$(96) then        ' CTRL F3 previous file
gosub dirscanname
a184:
if dirindex>1 then
dirindex=dirindex-1
gosub dirscannumber
gosub openfile2
if message=2 then goto a184                ' unrecognized file?
recalc=1:goto uistart
end if
end if

if ki=chr$(255)+chr$(97) then        ' CTRL F4 next file
gosub dirscanname
a185:
dirindex+=1
gosub dirscannumber
if ki2<>"" then
gosub openfile2
if message=2 then goto a185                ' unrecognized file?
recalc=1:goto uistart
end if
end if

if ki=chr$(255)+chr$(63) then scale=1:scaleold=1:render=1:gosub centerscreen:goto a89        ' F5 actual size

if ki=chr$(255)+chr$(64) then        ' F6 quicksave
ki2=fname:fname="IMGTOOL.BMP"
orgformat=tformat:tformat=32
gosub savefile:fname=ki2
tformat=orgformat
goto a276
end if

if ki=chr$(255)+chr$(65) then 
focusw=-1:focusb=-1
xx=111:goto a282                ' toggle tile mode
end if

if ki=chr$(255)+chr$(66) then f2=5:goto openwin     ' open drawing window

if ki=chr$(255)+chr$(133) then hidemenu=1-hidemenu:recalc=2:goto a89


' debug window
if ki=chr$(255)+chr$(134) then f2=9:goto openwin

' alt-f4 and ctrl-f4
if ki=chr$(255)+"k" then end
if ki=chr$(255)+"a" then if focusw>0 then wid=focusw:gosub removewin:goto a72


if mw<>mwold then
' check for wheel scrolling in file list or EXIF list
gosub searchbutton
if z=-1 then goto a362
xx=btlst(z,3):yy=btype(xx)
zz=mwold-mw
if yy=9 then                         ' file list
findex+=(zz shl 2):if findex<0 then findex=0
end if
if yy=11 then                        ' EXIF list
eindex+=(zz shl 2)
if eindex>=exifptr then eindex=exifptr-1
if eindex<0 then eindex=0
end if
if yy=14 then                        ' help list
hindex+=(zz shl 2)
if hindex>=helpsize then hindex=helpsize-1
if hindex<0 then hindex=0
end if
goto a276
a362:
end if


' how about we check for arrow keys ONCE instead of five different
' times with five copies of this code
lfrt=0:updn=0
if ki=chr$(255)+chr$(72) then updn=-1
if ki=chr$(255)+chr$(75) then lfrt=-1
if ki=chr$(255)+chr$(77) then lfrt=1
if ki=chr$(255)+chr$(80) then updn=1
if lfrt then region=lfrt

' ah but we need to check CTRL+arrows also -_-!
bools1=(bools1 and &H7EFFFFFF)
if ki=chr$(255)+chr$(141) then updn=-1:bools1+=&H1000000
if ki=chr$(255)+chr$(115) then lfrt=-1:bools1+=&H1000000
if ki=chr$(255)+chr$(116) then lfrt=1:bools1+=&H1000000
if ki=chr$(255)+chr$(145) then updn=1:bools1+=&H1000000


' palette colors window controls
if focusw=13 then
stats(24)+=lfrt+(updn shl 4)
if (lfrt or updn) then goto a281
y=0:z=stats(27)+(stats(26) shl 8)+(stats(25) shl 16)
for x=0 to 2
if ki=chr$(49+x) then stats(25+x)=((stats(25+x)+10) and 255):y=1
next x
if ki="!" then stats(25)=((stats(25)+1) and 255):y=1
if ki="@" then stats(26)=((stats(26)+1) and 255):y=1
if ki="#" then stats(27)=((stats(27)+1) and 255):y=1
if ki="b" then stats(25)=0:stats(26)=0:stats(27)=0:y=1
if ki="r" then if (bools2 and 8)=0 then gosub defaultdrawpal:goto a280
' if color changed, bind mode on, pixel edit mode on, then update pixel block
if y=1 then
if (bools1 and &H80000)+(bools2 and 8)<>&H80008 then goto a276
f1=stats(47):f2=stats(47)+stats(79)-1
if f2>=bmp1v then f2=bmp1v-1
h1=stats(46):h2=stats(46)+stats(78)-1
if h2>=bmp1h then h2=bmp1h-1
goto colorswap
end if
end if

' arrow keys menu navigation
if focusw=0 then
if updn=1 then z=focusb:goto a154
if lfrt then focusb+=lfrt:redraw=2
if focusb<0 then focusb=3
if focusb>3 then focusb=0
end if
if focusw>0 then
if updn then
do
focusb+=updn
if focusb<0 then focusb=numbuttons-1
if focusb>numbuttons-1 then focusb=0
loop until btlst(focusb,4)=focusw
redraw=2
end if
end if

' TAB changes window focus
if focusw<>0 then
if ki=chr$(9) then
if focusw=-1 then focusw=0
x=1000
for z=0 to numbuttons-1
if btlst(z,4)>focusw then if btlst(z,4)<x then x=btlst(z,4)
next z
focusw=x:if focusw=1000 then focusw=-1
a155:
focusb=-1:redraw=2
end if
end if

if redraw>0 then goto skipmouselook

if ki=chr$(13) then if focusb<>-1 then z=focusb:goto a154


' check for menu-related keyboard shortcuts
if ki="" then goto a90
if ki=" " then goto a90
a118:
for z=0 to numbuttons-1
if btlst(z,4)=focusw then
xx=btlst(z,3)
if mid$(bkey,xx+1,1)=ki then goto a154
end if
next z
a90:


if (mb and 1)=0 then notool=0

if focusw>-1 then goto skipkeyboard


' pixel edit keyboard controls
if (bools1 and &H80000) then

if ki=" " then stats(71)=(stats(71) xor &HFFFFFF):goto a276        ' toggle box color

' tile movement (CTRL+arrow)
if (bools1 and &H1000000) then
stats(46)+=lfrt*stats(78):stats(47)+=updn*stats(79)
goto a372
end if

' calculate pixel edit box coordinates, since they are used in several routines
f1=stats(47):f2=stats(47)+stats(79)-1
if f2>=bmp1v then f2=bmp1v-1
h1=stats(46):h2=stats(46)+stats(78)-1
if h2>=bmp1h then h2=bmp1h-1

if ki="p" then                                 ' switch to/from palette bind mode
bools2=(bools2 xor 8)
goto a72
end if

if ki="P" then                                 ' build new drawing palette from pixel block
z=0
for yy=f1 to f2
for xx=h1 to h2
x=(*cast(integer ptr,@bmp1(yy,xx,0)) and &HFFFFFF)
for zz=0 to z-1
if penpal(zz)=x then goto a371
next zz                       
penpal(z)=x:z+=1
if z=64 then goto a280        ' max 64 colors
a371:
next xx
next yy
while z<64
penpal(z)=0:z+=1
wend
goto a280        ' make sure current pen is also updated
end if

' pixel cursor movement (or block shift)
if (lfrt or updn) then 
if multikey(&H2A) then goto a365
if multikey(&H36) then
a365:
x=1:y=1:lfrt=0-lfrt:updn=0-updn
if lfrt=-1 then swap h1,h2:x=-1
if updn=-1 then swap f1,f2:y=-1
if f1+updn<0 then f1+=1
if f1+updn>=bmp1v then f1=f1-1
if f2+updn<0 then f2+=1
if f2+updn>=bmp1v then f2=f2-1
for yy=f1 to f2 step y
for xx=h1 to h2 step x
for z=0 to 3
bmp1(yy,xx,z)=bmp1(yy+updn,xx+lfrt,z)
next z
next xx
next yy
goto a72
end if
stats(53)+=lfrt:stats(54)+=updn:goto a72
end if

x=stats(46)+stats(53):y=stats(47)+stats(54)        ' pixel position

if ki="t" then xx=132:goto a282        ' toggle mask mode

' <<<<<<<<< alternate pixel edit controls for drawing on mask layer >>>>>>>>>

if (bools1 and &H4000000) then

if ki="g" then          ' get pixel color (mask mode)
z=bmp1(y,x,3)
stats(25)=z:stats(26)=z:stats(27)=z:goto a276
end if
if ki="h" then          ' put pixel color (mask mode)
bmp1(y,x,3)=(stats(25)+stats(26)+stats(27))\3:goto a276
end if

if ki="H" then          ' replace color (mask mode)
b=bmp1(y,x,3)
for yy=f1 to f2
for xx=h1 to h2
if bmp1(yy,xx,3)=b then bmp1(yy,xx,3)=(stats(25)+stats(26)+stats(27))\3
next xx
next yy
goto a276
end if

if ki="/" then          ' invert mask bits
for yy=f1 to f2
for xx=h1 to h2
bmp1(yy,xx,3)=(bmp1(yy,xx,3) xor 255)
next xx
next yy
goto a276
end if

if ki="n" then          ' paste pixels (mask mode)
ff1=freefile:ki2=exepath+"\IMGTOOL.TM2"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
get #ff1,,xx:get #ff1,,yy
if x+xx>bmp1h then goto a89
if y+yy>bmp1v then goto a89
for z=0 to yy-1
for zz=0 to xx-1
get #ff1,,d0:bmp1(z+y,zz+x,3)=(d0 shr 24)
next zz
next z
close #ff1
goto a372
end if

goto skipnormal
end if

' >>>>>>>>> normal pixel edit controls for NON-mask mode <<<<<<<<<

if ki="g" then          ' get pixel color
if (bools2 and 8)=0 then stats(27)=bmp1(y,x,0):stats(26)=bmp1(y,x,1):stats(25)=bmp1(y,x,2):goto a276
x=(*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF)
z=0
while z<64
if penpal(z)=x then stats(24)=z:goto a281
z+=1
wend
end if

if ki="h" then          ' put pixel color
bmp1(y,x,0)=stats(27):bmp1(y,x,1)=stats(26):bmp1(y,x,2)=stats(25):goto a276
end if

if ki="n" then          ' paste pixels
h=1:goto a374
end if

if ki="N" then          ' paste pixels only with nonzero mask value
h=0
a374:
ff1=freefile:ki2=exepath+"\IMGTOOL.TM2"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
get #ff1,,xx:get #ff1,,yy
if x+xx>bmp1h then goto a89
if y+yy>bmp1v then goto a89
for z=0 to yy-1
for zz=0 to xx-1
get #ff1,,d0
if h=0 then
if (d0 and &HFF000000) then *cast(integer ptr,@bmp1(z+y,zz+x,0))=d0
else
bmp1(z+y,zz+x,0)=d0
bmp1(z+y,zz+x,1)=(d0 shr 8)
bmp1(z+y,zz+x,2)=(d0 shr 16)
end if
next zz
next z
close #ff1
goto a372
end if

if ki="o" then                                  ' outline area
amx=x:amy=y
h2+=1:f2+=1
gosub outline:goto a276
end if

if ki="O" then                                  ' black outline
z=(*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF)
for yy=f1 to f2
for xx=h1 to h2
zz=*cast(integer ptr,@bmp1(yy,xx,0))
if (zz and &HFFFFFF)=z then
if xx>stats(46) then if (*cast(integer ptr,@bmp1(yy,xx-1,0)) and &HFFFFFF)<>z then goto a366
if yy>stats(47) then if (*cast(integer ptr,@bmp1(yy-1,xx,0)) and &HFFFFFF)<>z then goto a366
if xx<h2 then if (*cast(integer ptr,@bmp1(yy,xx+1,0)) and &HFFFFFF)<>z then goto a366
if yy<f2 then if (*cast(integer ptr,@bmp1(yy+1,xx,0)) and &HFFFFFF)<>z then goto a366
goto a367
a366:
zz=(zz and &HFF000000)
end if
a367:
*cast(integer ptr,@bmp2(yy,xx,0))=zz
next xx
next yy
for yy=f1 to f2
for xx=h1 to h2
*cast(integer ptr,@bmp1(yy,xx,0))=*cast(integer ptr,@bmp2(yy,xx,0))
next xx
next yy
goto a276
end if

if (bools2 and 8) then goto skipnormal          ' also skip some stuff in 'bind' mode

if ki="G" then          ' get pixel color and blend with current
for z=0 to 2
stats(27-z)=((bmp1(y,x,z)+stats(27-z)) shr 1)
next z
goto a276
end if

if ki="H" then          ' replace color
z=(*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF)
colorswap:
for yy=f1 to f2
for xx=h1 to h2
if (*cast(integer ptr,@bmp1(yy,xx,0)) and &HFFFFFF)=z then
bmp1(yy,xx,0)=stats(27):bmp1(yy,xx,1)=stats(26):bmp1(yy,xx,2)=stats(25)
end if
next xx
next yy
goto a276
end if

if ki="s" then          ' darken pixel color
for z=0 to 2
b=bmp1(y,x,z):if b<10 then b=10
b=b-10:bmp1(y,x,z)=b
next z
goto a276
end if

if ki="S" then          ' darken area
yy=pcopyv:xx=pcopyh
if yy>y then swap yy,y
if xx>x then swap xx,x
for v=yy to y
for h=xx to x
for z=0 to 2
b=bmp1(v,h,z):if b<10 then b=10
b=b-10:bmp1(v,h,z)=b
next z
next h
next v
goto a276
end if

' RGB color adjustment
for z=0 to 2
if ki=chr$(51-z) then bmp1(y,x,z)+=10:goto a276
next z
if ki="!" then bmp1(y,x,2)+=1:goto a276
if ki="@" then bmp1(y,x,1)+=1:goto a276
if ki="#" then bmp1(y,x,0)+=1:goto a276

skipnormal:

' these controls apply to both normal and mask mode

if ki="-" then stats(24)=stats(24)-1:goto a281
if ki="=" then stats(24)+=1:goto a281

if ki="1" then bmp1(y,x,3)+=10:goto a276
if ki="!" then bmp1(y,x,3)+=1:goto a276
if ki="s" then bmp1(y,x,3)=bmp1(y,x,3)-10:goto a276

' quit pixel art mode
if ki="q" then bools1=(bools1 xor &H80000):goto a372

if ki="v" then pcopyh=x:pcopyv=y:goto a276      ' select 1st corner
if ki="b" then                                  ' copy pixels
yy=pcopyv:xx=pcopyh
if y>yy then swap yy,y
if x>xx then swap xx,x
xx=xx-x+1:yy=yy-y+1
ki2=exepath+"\IMGTOOL.TM2"
gosub copybox2:goto a276
end if

if ki="z" then                                  ' draw line
z1=pcopyh-x:z2=pcopyv-y
i1=abs(z1):if abs(z2)>i1 then i1=abs(z2)
if i1=0 then goto a89
z1=z1/i1:z2=z2/i1
z3=x:z4=y
do
x=z3:y=z4
gosub plotpixel2
z3+=z1:z4+=z2
i1=i1-1
loop until i1=0
goto a276
end if

if ki="m" then                                  ' fill rectangle
yy=pcopyv:xx=pcopyh
if yy>y then swap yy,y
if xx>x then swap xx,x
for v=yy to y
for h=xx to x
if (bools1 and &H4000000) then
bmp1(v,h,3)=(stats(25)+stats(26)+stats(27))\3
else
bmp1(v,h,0)=stats(27):bmp1(v,h,1)=stats(26):bmp1(v,h,2)=stats(25)
end if
next h
next v
goto a276
end if

if ki="|" then                          ' rotate tile 90deg
if stats(78)<>stats(79) then goto a276        ' (only if dimensions are the same)
for y=f1 to f2
for x=h1 to h2
*cast(integer ptr,@bmp2(y-f1,x-h1,0))=*cast(integer ptr,@bmp1(y,x,0))        ' duplicate
next x
next y
for y=f1 to f2
for x=h1 to h2
z=0:if (bools1 and &H4000000) then z=3
do
bmp1(y,x,z)=bmp2(h2-x,y-f1,z):z+=1                ' copy back rotated 
loop until z>2
next x
next y
goto a372
end if

if ki="i" then                          ' flip tile horizontally
if stats(46)+stats(78)>bmp1h then message=18:goto a276                ' "out of bounds"
for y=f1 to f2
for x=0 to (stats(78) shr 1)-1
z=0:if (bools1 and &H4000000) then z=3
do
swap bmp1(y,x+stats(46),z),bmp1(y,h2-x,z):z+=1
loop until z>2
next x
next y
goto a276
end if
if ki="I" then                          ' flip tile vertically
if stats(47)+stats(79)>bmp1v then message=18:goto a276                ' "out of bounds"
for y=0 to (stats(79) shr 1)-1
for x=h1 to h2
z=0:if (bools1 and &H4000000) then z=3
do
swap bmp1(y+stats(47),x,z),bmp1(f2-y,x,z):z+=1
loop until z>2
next x
next y
goto a276
end if

if ki="f" then          ' copy a horizontal line
for z=0 to stats(78)-1
for zz=0 to 3
tline(z,zz)=bmp1(y,stats(46)+z,zz)
next zz
next z
goto a276
end if
if ki="j" then          ' paste a horizontal line
for z=0 to stats(78)-1
zz=0:if (bools1 and &H4000000) then zz=3
do
bmp1(y,stats(46)+z,zz)=tline(z,zz):zz+=1
loop until zz>2
next z
goto a276
end if

if ki="a" then f2=13:goto openwin     ' open palette window

if ki="l" then                                  ' fill area
amx=x:amy=y
h2+=1:f2+=1
gosub fillstuff2:goto a276
end if

goto skipkeyboard
end if


' tile edit keyboard controls
if (bools1 and 131072) then

if ki=" " then stats(71)=(stats(71) xor &HFFFFFF):goto a276        ' toggle box color

' scrolling (CTRL+arrow)
if (bools1 and &H1000000) then
renderh+=lfrt*(0-stats(48))
renderv+=updn*(0-stats(49))
render=2:goto a89
end if

' cursor movement
x=1:if (bools1 and 262144) then x=stats(48)
y=1:if (bools2 and 4) then y=stats(49)
if multikey(&H2A) then x=64:y=64
if multikey(&H36) then x=64:y=64
stats(46)+=lfrt*x:stats(47)+=updn*y
if (lfrt or updn) then goto a72

if ki="2" then scale=2:render=1:goto a89
if ki="4" then scale=4:render=1:goto a89

if ki="p" then          ' toggle paste preview
bools1=(bools1 xor &H40000000)
gosub checktempfile
goto a72
end if

if ki="g" then          ' get block
x=stats(46):y=stats(47):xx=stats(78):yy=stats(79)
gosub copybox:goto a276
end if
if ki="h" then          ' put block
a279: ' set bogus "transparent" color and then jump to the "N" code
h1=-1:goto a285
end if

if ki="v" then tcopyh=stats(46):tcopyv=stats(47):goto a72       ' select 1st
if ki="b" then          ' select 2nd corner (lower right) and copy
x=tcopyh:y=tcopyv
xx=stats(46)+stats(78)-x
yy=stats(47)+stats(79)-y
gosub copybox:goto a276
end if
if ki="n" then goto a279        ' put block (redundant)
        
if ki="e" then          ' pixel art mode
bools1=(bools1 or &H80000)
stats(53)=(stats(78) shr 1)
stats(54)=(stats(79) shr 1)
goto a72
end if

if ki="m" then          ' fill an area with blocks (tiled)
ff1=freefile:ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
get #ff1,,xx:get #ff1,,yy
h=tcopyh:v=tcopyv
hh=stats(46):if hh<h then swap hh,h
vv=stats(47):if vv<v then swap vv,v
hh+=stats(78):vv+=stats(79)
if hh>bmp1h then goto a89
if vv>bmp1v then goto a89
y=0
while v<vv
x=0:h1=h
while h1<hh
z=((y*xx+x)*4)+9
get #ff1,z,c
if (bools1 and &H4000000) then
bmp1(v,h1,3)=(c shr 24)              ' mask mode
else
*cast(integer ptr,@bmp1(v,h1,0))=c     ' normal mode
end if                    
h1+=1:x+=1:if x=xx then x=0
wend
v+=1:y+=1:if y=yy then y=0
wend
close #ff1
goto a372
end if


' skip controls that are unavailable when drawing on mask layer
if (bools1 and &H4000000) then goto skipkeyboard

if ki="H" then          ' replace blocks across entire image
' bail if tile is not aligned to grid
if (bools1 and 262144)=0 then message=15:goto a72
if (bools2 and 4)=0 then message=15:goto a72               ' "invalid rectangle" message
ff1=freefile:ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
get #ff1,,xx:get #ff1,,yy
' bail if tmp block doesn't match cursor size
if xx<>stats(78) then message=15:goto a72
if yy<>stats(79) then message=15:goto a72

xx=xx-1:yy=yy-1
i2=(stats(46) mod stats(78)):i3=(stats(47) mod stats(79))
for f1=i3 to bmp1v-1 step stats(79)
for h1=i2 to bmp1h-1 step stats(78)

if h1=stats(46) then if f1=stats(47) then goto a373        ' skip the reference block

' check whether this block matches the target
for v=0 to yy
for h=0 to xx
if *cast(integer ptr,@bmp1(f1+v,h1+h,0))<>*cast(integer ptr,@bmp1(stats(47)+v,stats(46)+h,0)) then goto a373
next h
next v
' paste the block
z=5:get #ff1,z,c
for v=0 to yy
for h=0 to xx
get #ff1,,*cast(integer ptr,@bmp1(f1+v,h1+h,0))
next h
next v

a373:
next h1
next f1

z=5:get #ff1,z,c        ' do the reference block now
for v=0 to yy
for h=0 to xx
get #ff1,,*cast(integer ptr,@bmp1(stats(47)+v,stats(46)+h,0))
next h
next v
goto a372
end if

if ki="N" then          ' put block with transparency
' use palette color 0 as "transparent"
h1=stats(27)+(stats(26) shl 8)+(stats(25) shl 16)
a285:
ff1=freefile:ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
x=stats(46):y=stats(47)
get #ff1,,xx:get #ff1,,yy
if x+xx>bmp1h then goto a89
if y+yy>bmp1v then goto a89
for v=0 to yy-1
for h=0 to xx-1
get #ff1,,c
if (bools1 and &H4000000) then
bmp1(y+v,x+h,3)=(c shr 24)              ' mask mode
else
if (c and &HFFFFFF)<>h1 then *cast(integer ptr,@bmp1(y+v,x+h,0))=c     ' normal mode
end if
next h
next v
close #ff1
goto a372
end if

if ki="<" then          ' put double-size block
ff1=freefile:ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
x=stats(46):y=stats(47)
get #ff1,,xx:get #ff1,,yy
if x+xx+xx>bmp1h then goto a89
if y+yy+yy>bmp1v then goto a89
for v=0 to yy-1
for h=0 to xx-1
get #ff1,,z
hh=x+h+h:vv=y+v+v
*cast(integer ptr,@bmp1(vv,hh,0))=z
*cast(integer ptr,@bmp1(vv,hh+1,0))=z
*cast(integer ptr,@bmp1(vv+1,hh,0))=z
*cast(integer ptr,@bmp1(vv+1,hh+1,0))=z
next h
next v
close #ff1
goto a372
end if

if ki="w" then z=10:goto a284           ' brighten entire tile
if ki="s" then                          ' darken entire tile
z=-10
a284:
for y=stats(47) to stats(47)+stats(79)-1
for x=stats(46) to stats(46)+stats(78)-1
for yy=0 to 2
xx=z+bmp1(y,x,yy):if xx<0 then xx=0
if xx>255 then xx=255
bmp1(y,x,yy)=xx
next yy
next x
next y
goto a372
end if

goto skipkeyboard
end if

' secret key combo...!
if ki="R" then
gosub pointtranslate3
z=(*cast(integer ptr,@bmp1(amy,amx,0)) and &HFFFFFF)
' replace a color in the entire image
for y=0 to bmp1v-1
for x=0 to bmp1h-1
if z=(*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF) then 
bmp1(y,x,0)=stats(27)           ' normal drawing
bmp1(y,x,1)=stats(26)
bmp1(y,x,2)=stats(25)
end if
next x
next y
goto a372
end if

' arrow key image zoom/scroll
if (bools1 and 1)=0 then
z=-8
if multikey(&H2A) then z=-64
if multikey(&H36) then z=-64
renderh+=lfrt*z:renderv+=updn*z
if (lfrt or updn) then render=(render or 2)
' PGUP/PGDN aspect
if ki=chr$(255)+chr$(73) then aspect=aspect*.95:render=1
if ki=chr$(255)+chr$(81) then aspect=aspect*1.05:render=1
' HOME/END scaling
if ki=chr$(255)+chr$(71) then scale=scale*.95:render=1
if ki=chr$(255)+chr$(79) then scale=scale*1.05:render=1
if render>0 then goto a89
end if

skipkeyboard:

' skip mouse-ui interact if ui is hidden
if hidemenu=1 then goto a89

' click-and-drag scrolling
if (mb and 1)=0 then dragscroll=0:goto a271
if dragscroll>0 then
y=(my-myold)\txtheight
if y<>0 then
findex+=y*totalfiles\12:if findex<0 then findex=0
myold+=y*txtheight
redraw=2
end if
goto a79
end if
if lc=1 then
gosub searchbutton
if z=-1 then goto a271
if btype(btlst(z,3))<>9 then goto a271
if scrollb=0 then goto a271
if (btlst(z,5) and 127)=scrollpos then dragscroll=1:goto skipmouselook
end if
a271:

' right-click-and-drag window movement
if (mb and 2)=0 then winmove=0:goto a158
if winmove>0 then
x=(mx-mxold)\8:y=(my-myold)\txtheight
if ((x<>0) or (y<>0)) then
' need to make a test pass to ensure buttons won't go off screen
for z=0 to numbuttons-1
if btlst(z,4)=winmove then
xx=btlst(z,0):yy=btlst(z,1)
if x+xx<1 then x=1-xx
if x+xx+btlst(z,2)>loword(width) then x=loword(width)-xx-btlst(z,2)
if y+yy<1 then y=1-yy
if y+yy+1>hiword(width) then y=hiword(width)-yy-1
end if
next z
for z=0 to numbuttons-1
if btlst(z,4)=winmove then btlst(z,0)+=x:btlst(z,1)+=y
next z
mxold+=x*8:myold+=y*txtheight
redraw=1
end if
goto a79
end if
if rc=2 then
gosub searchbutton
if z=-1 then goto a158
y=btlst(z,4)
if y>0 then winmove=y:goto skipmouselook
end if
a158:

if lc=1 then
' check for left-click in UI button
gosub searchbutton

if z=-1 then
if (bools1 and 131072)=0 then goto a89

if uitool>0 then goto a89

' check for left-click in pixel edit window
if (bools1 and &H80000) then
gosub checkpixelwin:if x=-1 then goto a89
focusw=-1:focusb=-1
' place pixel cursor
stats(53)=x:stats(54)=y:goto a276
end if

' otherwise click to place tile cursor
gosub pointtranslate3
focusw=-1:focusb=-1:stats(46)=amx:stats(47)=amy:goto a72
end if

notool=1
a154:
' button was clicked, do stuff?
xx=btlst(z,3):wid=btlst(z,4)
yy=btype(xx)

if yy=10 then
' palette colors
stats(24)=btlst(z,5)+(((mx-x) shr 4) and 15)
goto a280
end if

if yy=1 then
' open a new window?
f2=bparam(xx)
openwin:
' check whether window already exists, if so change focus but do not reopen
for z=0 to numbuttons-1
if btlst(z,4)=f2 then focusw=f2:focusb=z:goto a72
next z
x=winadrs(f2)
h=windata(x):v=windata(x+1)
if focusw<>-1 then focusw=0
' check for existing window in same spot
'if numbuttons>0 then
for y=0 to numbuttons-1
if btlst(y,0)<>h then goto a76
if btlst(y,1)<>v then goto a76
wid=btlst(y,4):gosub removewin
a76:
next y
'end if
if focusw=0 then focusw=f2:focusb=-1
' add all buttons specified in the window data to button list
for y=x+4 to x+3+windata(x+3)
f1=windata(y)
btlst(numbuttons,0)=h
btlst(numbuttons,1)=v
btlst(numbuttons,2)=bwidth(f1)
btlst(numbuttons,3)=f1
btlst(numbuttons,4)=f2
numbuttons+=1
v+=1
next y
goto a72
end if


if yy=2 then
' check box
a282:
f1=bparam(xx)

if f1>31 then
h1=(1 shl (f1-32))
bools2=(bools2 xor h1)
goto a361
end if

if f1=13 then findex=0:findold=1
h1=(1 shl f1)
bools1=(bools1 xor h1)
' mutually exclusive check boxes
if h1=16384 then bools1=(bools1 and &H7FFFFF7F)
if h1=128 then bools1=(bools1 and &H7FFFBFFF)

a361:
gosub checkbaction
goto skipmouselook
end if


if yy=3 then
' misc functions
f1=bparam(xx)
if f1=0 then end
if f1=1 then gosub openfile:recalc=1:goto skipmouselook
if f1=2 then gosub savefile:goto a72
if f1=3 then tformat=24:gosub saveasfile:goto a72
if f1=49 then tformat=60:gosub saveasfile:goto a72
if f1=4 then gosub removewin:goto a72

if f1=5 then aspect=1:scale=1:render=1:goto a89

if f1=6 then
' flip X
for v=0 to bmp1v-1
x=0
for h=0 to bmp1h-1
lbuf(x)=bmp1(v,h,0):lbuf(x+1)=bmp1(v,h,1):lbuf(x+2)=bmp1(v,h,2):x+=3
next h
for h=0 to bmp1h-1
x=x-3:bmp1(v,h,0)=lbuf(x):bmp1(v,h,1)=lbuf(x+1):bmp1(v,h,2)=lbuf(x+2)
next h
next v
recalc=1:goto skipmouselook
end if

if f1=7 then
' flip Y
for h=0 to bmp1h-1
x=0
for v=0 to bmp1v-1
lbuf2(x)=bmp1(v,h,0):lbuf2(x+1)=bmp1(v,h,1):lbuf2(x+2)=bmp1(v,h,2):x+=3
next v
for v=0 to bmp1v-1
x=x-3:bmp1(v,h,0)=lbuf2(x):bmp1(v,h,1)=lbuf2(x+1):bmp1(v,h,2)=lbuf2(x+2)
next v
next h
recalc=1:goto skipmouselook
end if

if f1=8 then btimer=timer:bfps=0:uitool=5:recalc=1:goto skipmouselook
' benchmark mode

if f1=9 then
' confirm...

if wid=11 then          ' change screen resolution
a386:
screenres stats(41),stats(42),stats(43)
gosub setscreen
gosub screenresize
redim cbuf(0 to maxy,0 to lbytes-1) as ubyte
cbp=@cbuf(0,0)
render=1:goto skipmouselook
end if

end if

if f1=10 then gosub fitscreen:gosub centerscreen:goto a89

if f1=11 then tformat=16:gosub saveasfile:goto a72
if f1=12 then
' check whether palette or color space is small enough for 8-bit BMP
if (bools1 and &H4080) then if stats(15)<257 then goto a363
if (bools1 and &H100) then if stats(37)<257 then goto a363
message=7:goto a72
a363:
tformat=8:gosub saveasfile:goto a72
end if

if f1=13 then uitool=2:goto a72         ' selection

if uitool=2 then
if f1=14 then           ' crop stuff
if stats(66)<1 then goto skipmouselook
if stats(65)<1 then goto skipmouselook
if stats(67)>stats(69) then swap stats(67),stats(69)
if stats(68)>stats(70) then swap stats(68),stats(70)

for y=0 to stats(66)-1
for x=0 to stats(65)-1

bmp1(y,x,0)=bmp1(y+stats(68),x+stats(67),0)
bmp1(y,x,1)=bmp1(y+stats(68),x+stats(67),1)
bmp1(y,x,2)=bmp1(y+stats(68),x+stats(67),2)

next x
next y

bmp1h=stats(65):bmp1v=stats(66)
uitool=0:recalc=1
goto skipmouselook
end if

if f1=15 then           ' copy stuff
if stats(67)>stats(69) then swap stats(67),stats(69)
if stats(68)>stats(70) then swap stats(68),stats(70)
xx=stats(65):yy=stats(66):x=stats(67):y=stats(68)
gosub copybox
message=17:goto a72                                       ' "copied"
end if
end if

if f1=16 then uitool=3:goto a72         ' paste tool

if ((f1=17) or (f1=18)) then   ' rotate right/left
gosub dupebmp
y=bmp1v-1:x=bmp1h-1

swap bmp1h,bmp1v
maxh=bmp1h:maxv=bmp1v
gosub resizemem3

for v=0 to x
for h=0 to y
if f1=17 then
bmp1(v,h,0)=bmp2(y-h,v,0)
bmp1(v,h,1)=bmp2(y-h,v,1)
bmp1(v,h,2)=bmp2(y-h,v,2)
else
bmp1(v,h,0)=bmp2(h,x-v,0)
bmp1(v,h,1)=bmp2(h,x-v,1)
bmp1(v,h,2)=bmp2(h,x-v,2)
end if
next h
next v
redim bmp2(0 to maxv-1,0 to maxh-1,0 to 3) as ubyte
recalc=1:goto skipmouselook
end if

if f1=19 then uitool=1:goto a72         ' pen

if f1=20 then           ' color selection
stats(24)+=region
a281:
stats(24)=(stats(24) and 63)
a280:
stats(25)=(penpal(stats(24)) shr 16)
stats(26)=((penpal(stats(24)) shr 8) and 255)
stats(27)=(penpal(stats(24)) and 255)
goto a276
end if

if f1=21 then gosub newfile:goto skipmouselook

if f1=22 then tformat=70:gosub saveasfile:goto a72

if f1=23 then uitool=4:goto a72         ' get color
if f1=24 then uitool=6:stats(31)=-1:goto a72         ' line

if f1=25 then           ' set background color
bgc=(stats(25) shl 16)+(stats(26) shl 8)+stats(27)
render=2:goto a89
end if

if f1=26 then   ' file list page prev/next
findex+=region*14:if findex<0 then findex=0
goto a276
end if

if f1=27 then   ' current path
wtitle="    FILE LIST - enter path    "
gosub stringentry
chdir(ki2):findex=0:findold=1:goto a72
end if

if f1=28 then wtitle="  LOAD PAL - enter filename   ":message=12:goto a275
if f1=29 then   ' load custom pal or color map
wtitle="  COLOR MAP - enter filename  ":message=14
a275:
gosub stringentry
if ki2="" then message=1:goto a72
a375:
ff1=freefile
open ki2 for binary access read as #ff1
if err<>0 then message=9:goto a72
y=lof(ff1):if y=0 then message=2:goto a72
if y>196608 then message=3:goto a72                     ' "too large" message
if (f1 and 1) then
stats(37)=y\3
for x=0 to stats(37)-1:get #ff1,,cspace(x,0),3:next x
close #ff1:if (bools1 and &H8100)=&H8100 then recalc=1
else
stats(15)=y\3
for x=0 to stats(15)-1
get #ff1,,b:get #ff1,,g:get #ff1,,r
bpal(x)=(b shr 2)+((g and 252) shl 4)+((r and 252) shl 10)
next x
close #ff1:if (bools1 and 16384) then recalc=1
if (bools1 and 128) then bools1=(bools1 and &H7FFFFF7F):recalc=1
end if
goto a72
end if

if (f1 and 254)=30 then   ' view custom color map or palette
x=31:y=35:xx=288:yy=164:gosub drawbox
'line (31,35)-(288,35),&HFFFFFF
'line (31,164)-(288,164),&HFFFFFF
'line (31,35)-(31,164),&HFFFFFF
'line (288,35)-(288,164),&HFFFFFF

yy=stats(15)
if (bools1 and 64) then if numzone>1 then yy=yy*numzone

for z=0 to 4095
x=((z shr 7) shl 3)+32:y=(z and 127)+36
if (f1 and 1) then
zz=bpal(((z*yy) shr 12))
zz=((zz and 63) shl 2)+((zz and 4032) shl 4)+((zz and &H3F000) shl 6)
else
zz=*cast(integer ptr,@cspace(((z*stats(37)) shr 12),0))
end if
line (x,y)-(x+7,y),zz
next z
sleep
ki=inkey$
goto a72
end if

if f1=32 then   ' save custom pal
wtitle="  SAVE PAL - enter filename   "
gosub stringentry
if ki2="" then message=1:goto a72
kill ki2:ff1=freefile
open ki2 for binary as #ff1
if err<>0 then message=9:goto a72
for x=0 to stats(15)-1
z=bpal(x)
b=((z and 63) shl 2)
g=((z shr 4) and 252)
r=((z shr 10) and 252)
put #ff1,,b:put #ff1,,g:put #ff1,,r
next x
close #ff1
message=13:goto a72                              ' "palette saved" message
end if

if f1=33 then           ' test new screen mode
screenres stats(41),stats(42),stats(43)
screeninfo x,y,z
cls
? "screen test:"
? "attempted to set mode ";stats(41);",";stats(42);",";stats(43)
? "resulted in ";x;",";y;",";z
? "press any key to continue..."
sleep 10000
ki=inkey$
screenres stats(38),stats(39),stats(40)
gosub setscreen2
if stats(40)=8 then gosub setpal8
goto a72
end if

if f1=34 then           ' make color changes permanent
gosub redupebmp
bools1=(bools1 and &H7FFFCE77)
goto a72
end if

if f1=35 then           ' copy palette to custom color map
for x=0 to stats(15)-1
cspace(x,0)=((bpal(x) and 63) shl 2)
cspace(x,1)=((bpal(x) shr 4) and 252)
cspace(x,2)=((bpal(x) shr 10) and 252)
next x
stats(37)=stats(15)
message=14:goto a276                        ' "color map loaded"
end if

if f1=36 then tformat=32:gosub saveasfile:goto a72

if f1=37 then           ' invert mask layer
for v=0 to bmp1v-1
for h=0 to bmp1h-1
bmp1(v,h,3)=255-bmp1(v,h,3)
next h
next v
a372:
recalc=1:goto a89
end if


if (f1 and &HFE)=38 then           ' resize (stretch/shrink or move borders)
resizeimg:
newh=stats(4):newv=stats(5)
resizeimg2:

gosub dupebmp
bp1=@bmp2(0,0,0)
maxh2=maxh*4

' now redim bmp1 (+lbuf) which will receive the modified data
maxh=newh:maxv=newv
gosub resizemem3

if f1=39 then
' move border only (center old image in new image)
xx=bmp1h:h1=0:h2=((newh-xx) shr 1):if xx>newh then xx=newh:h2=0:h1=((bmp1h-newh) shr 1)
yy=bmp1v:v1=0:v2=((newv-yy) shr 1):if yy>newv then yy=newv:v2=0:v1=((bmp1v-newv) shr 1)
for y=0 to yy-1
for x=0 to xx-1
*cast(integer ptr,@bmp1(y+v2,x+h2,0))=*cast(integer ptr,@bmp2(y+v1,x+h1,0))
next x
next y
else
' stretch/shrink
h1=0:v1=0:h2=newh-1:v2=newv-1
render=0:gosub resizex2
end if

redim bmp2(0 to newv-1,0 to newh-1,0 to 3) as ubyte

bmp1h=newh:bmp1v=newv
recalc=1:goto skipmouselook
end if

if f1=40 then uitool=7:goto a72         ' fill tool

if f1=41 then                ' copy all
x=0:y=0:xx=bmp1h:yy=bmp1v
gosub copybox
message=17:goto a72                     ' "copied"
end if

if f1=42 then stats(72)=0:message=19:goto a72         ' clear gradient points

if f1=43 then                                         ' remove one
stats(72)=stats(72)-1:if stats(72)<0 then stats(72)=0
message=20:goto a72                                  
end if

if f1=44 then uitool=8:goto a72

if f1=45 then                ' fill an area with gradient
if stats(72)=0 then message=21:goto a72               ' "no points defined"
' calculate distance/angle between each point and each other point
for z=0 to stats(72)-1
for zz=z+1 to stats(72)-1
'if z=zz then graddist(z,zz)=0:goto a337
x=gradh(zz)-gradh(z):y=gradv(zz)-gradv(z)
'gradist(z,zz)=sqr(x*x+y*y)
z1=sqr(x*x+y*y):if z1=0 then message=22:goto a72      ' "redundant points"
'gradang=asin(y/z1)

' calculate ratios so we can rotate points later to simplify math

gradcr(z,zz)=x/z1                ' cosine ratio (adjacent over hypotenuse)
gradsr(z,zz)=y/z1                ' sine ratio (opposite over hypotenuse)

gradsr(z,zz)=0-gradsr(z,zz)

'a337:
next zz
next z
amx=gradh(0):amy=gradv(0)
bools1=(bools1 or &H20000000)
gosub fillstuff
bools1=(bools1 and &H5FFFFFFF)

' restore color setting

x=penpal(stats(24))
stats(27)=(x and 255)
stats(26)=((x shr 8) and 255)
stats(25)=((x shr 16) and 255)

recalc=1:goto skipmouselook
end if

if f1=46 then   ' EXIF/help page prev/next
if wid=15 then
eindex+=region*14
if eindex>=exifptr then eindex=exifptr-1
if eindex<0 then eindex=0
end if
if wid=18 then
hindex+=region*14
if hindex>=helpsize then hindex=helpsize-1
if hindex<0 then hindex=0
end if
goto a276
end if

if f1=47 then         ' copy palette palette to drawing palette
x=stats(15):if x>64 then x=64
for y=0 to x-1
penpal(y)=((bpal(y) shl 2) and &HFC)+((bpal(y) shl 4) and &HFC00)+((bpal(y) shl 6) and &HFC0000)
next y
goto a276
end if

if f1=48 then         ' copy palette palette from drawing palette
if stats(15)>64 then stats(15)=64
x=stats(15)
for y=0 to x-1
bpal(y)=((penpal(y) shr 2) and &H3F)+((penpal(y) shr 4) and &HFC0)+((penpal(y) shr 6) and &H3F000)
next y
goto a276
end if

' setting of pre-defined screen modes
if f1=50 then stats(41)=640:stats(42)=480:stats(43)=8:goto a386
if f1=51 then stats(41)=800:stats(42)=600:stats(43)=16:goto a386
if f1=52 then stats(41)=1024:stats(42)=768:stats(43)=32:goto a386
if f1=53 then stats(41)=1280:stats(42)=960:stats(43)=32:goto a386

' color channel swaps
if f1<54 then goto a387
if f1>59 then goto a387
for v=0 to bmp1v-1
for h=0 to bmp1h-1
if f1=54 then swap bmp1(v,h,0),bmp1(v,h,1)
if f1=55 then swap bmp1(v,h,0),bmp1(v,h,2)
if f1=56 then swap bmp1(v,h,0),bmp1(v,h,3)
if f1=57 then swap bmp1(v,h,1),bmp1(v,h,2)
if f1=58 then swap bmp1(v,h,1),bmp1(v,h,3)
if f1=59 then swap bmp1(v,h,2),bmp1(v,h,3)
next h
next v
recalc=1:goto skipmouselook
a387:

' color channel inversion
if f1<60 then goto a388
if f1>63 then goto a388
z=(f1 and 3)
for v=0 to bmp1v-1
for h=0 to bmp1h-1
bmp1(v,h,z)=255-bmp1(v,h,z)
next h
next v
recalc=1:goto skipmouselook
a388:


end if


if yy=5 then
' modifiable value

color tcol(3),tcol(4)
a86:
f1=btlst(z,0)+btlst(z,2)-7
y=btlst(z,1)
locate y,f1,0:? "_      "
z1=0:a=0:f2=8:nextbox=0:z3=1
a84:
gosub readmouse
if lc=1 then goto a85
ki2=inkey$
if ki2="" then sleep 30:goto a84
if ki2=chr$(13) then goto a85
locate y,f1+a,0
if ((asc(ki2)>47) and (asc(ki2)<58)) then z1=(z1*10)+(asc(ki2)-48):a+=1:? ki2
if ki2="." then a+=1:? ki2:f2=a
if ki2="-" then a+=1:? ki2:z3=-1
if ki2=chr$(27) then goto a72            ' ESCape key
if ki2=chr$(9) then nextbox=1:goto a85 ' TAB key
if a<7 then goto a84                      

a85:
if f2<a then z1=z1/10:f2+=1:goto a85
h1=bparam(xx)
if h1<120 then 
stats(h1)=z1*z3
else
fpval(h1-120)=z1*z3
end if

gosub checkbaction

if nextbox=1 then
' continue data entry in next Type 5 button (if any)
if z=numbuttons-1 then goto a72
zz=z
for z=zz+1 to numbuttons-1
xx=btlst(z,3)
if btype(xx)=5 then goto a86
next z
end if

goto skipmouselook
end if


if yy=9 then
' clicked on a file name in the file list
x=(btlst(z,5) and 127)
' or was it a scroll bar?
if scrollb=1 then
if x=0 then if findex>0 then findex=findex-1:mouserep=1:goto a276
if x=13 then findex+=1:mouserep=1:goto a276
if x<scrollpos then findex=findex-14
if x>scrollpos then findex+=14
if findex<0 then findex=0
goto a276
end if

if btlst(z,5)>127 then goto a72
ki2=dirfiles(x):lastattr=dirattr(x)
if (lastattr and 16) then chdir(ki2):findex=0:findold=1:goto a72
gosub openfile2:recalc=1:goto skipmouselook

'locate 30,30,0:? x,y,findex,findex2:sleep
end if


a72:
redraw=1

a276:
redraw=(redraw or 2)

a89:
end if

' done with menu processing, now mouse tools

if notool=1 then goto skipmouselook


' pen tool
if uitool=1 then
if (mb and 1) then

if (bools1 and &H80000) then
gosub checkpixelwin:if x=-1 then goto a351
x+=stats(46):y+=stats(47)
gosub plotpixel2
redraw=2:goto skipmouselook
end if

a351:
gosub pointtranslate2
for y=0-stats(28) to stats(28)
if y+amy<0 then goto a239
if y+amy>=bmp1v then goto a263
for x=0-stats(28) to stats(28)
if x+amx<0 then goto a238
if x+amx>=bmp1h then goto a239
if ((x*x)+(y*y))>(stats(28)*stats(28)) then goto a238
gosub plotpixel
a238:
next x
a239:
next y
a263:
recalc=1
end if
if rc=2 then uitool=0:redraw=1
goto skipmouselook
end if

' selection
if uitool=2 then
if rc=2 then uitool=0:goto a234
if lc=1 then
amxold=mx:amyold=my
stats(67)=stats(61):stats(68)=stats(62)
goto a236
end if
if (mb and 1) then
a236:
amx=mx:amy=my
stats(69)=stats(61):stats(70)=stats(62)
stats(65)=abs(stats(69)-stats(67))
stats(66)=abs(stats(70)-stats(68))
a234:                
redraw=1
end if
goto skipmouselook
end if


' click-to-paste
if uitool=3 then
redraw=1
if rc=2 then uitool=0:goto a234
if lc=1 then 
gosub pointtranslate2
pastetmp:
ff1=freefile
ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then message=9:goto a234
get #ff1,,xx:get #ff1,,yy
if yy<1 then goto a237
if xx<1 then goto a237

if amy+yy>bmp1v then yy=bmp1v-amy
x=xx:if amx+x>bmp1h then x=bmp1h-amx

z=9:get #ff1,z,h1       ' get first color and use as "transparent"
h1=(h1 and &HFFFFFF):if (bools1 and 4096)=0 then h1=-1
for y=0 to yy-1
if ((stats(29)=255) and (h1=-1)) then
' opaque paste
get #ff1,z,bmp1(amy+y,amx,0),(x*4)
else
' transparent paste
seek #ff1,z
for h=0 to x-1
get #ff1,,zz
if (zz and &HFFFFFF)<>h1 then
for c=0 to 2
b=bmp1(amy+y,amx+h,c)
bmp1(amy+y,amx+h,c)=((((zz and 255)*(stats(29)+1))+(b*(255-stats(29)))) shr 8)
zz=(zz shr 8)
next c
end if
next h
end if
z+=(xx shl 2)
next y

recalc=1
a237:
close #ff1
end if
goto skipmouselook
end if


' get color
if uitool=4 then
if (mb and 1) then
gosub pointtranslate3
stats(27)=bmp1(amy,amx,0)
stats(26)=bmp1(amy,amx,1)
stats(25)=bmp1(amy,amx,2)
recalc=1
end if
if rc=2 then uitool=0:redraw=1
goto skipmouselook
end if


' line tool
if uitool=6 then
if (mb and 1) then
gosub pointtranslate2
' set beginning point
if stats(31)=-1 then stats(31)=amx:stats(32)=amy:amxold=mx:amyold=my:goto skipmouselook
' upon setting end point, draw the line

z1=amx-stats(31):z2=amy-stats(32)
i1=abs(z1):if abs(z2)>i1 then i1=abs(z2)
if i1=0 then goto a267
z1=z1/i1:z2=z2/i1
z3=stats(31):z4=stats(32)

do
amx=z3:amy=z4
for y=0-stats(28) to stats(28)
if y+amy>=bmp1v then goto a264
if y+amy<0 then goto a265
for x=0-stats(28) to stats(28)
if x+amx>=bmp1h then goto a265
if x+amx<0 then goto a266
if ((x*x)+(y*y))>(stats(28)*stats(28)) then goto a266
gosub plotpixel
a266:
next x
a265:
next y
a264:
z3+=z1:z4+=z2
i1=i1-1
loop until i1=0
a267:
recalc=1:stats(31)=-1
end if
if rc=2 then uitool=0:redraw=1
if stats(31)>-1 then redraw=1
goto skipmouselook
end if

' click-to-fill
if uitool=7 then
if (mb and 1) then
gosub pointtranslate3                 
gosub fillstuff
end if
if rc=2 then uitool=0:redraw=1
goto skipmouselook
end if

' gradient plotter
if uitool=8 then
if lc=1 then 
gosub pointtranslate2
gradh(stats(72))=amx
gradv(stats(72))=amy
gradc(stats(72))=stats(27)+(stats(26) shl 8)+(stats(25) shl 16)
stats(72)+=1:redraw=2
end if
if rc=2 then uitool=0:redraw=1
goto skipmouselook
end if


' mouselook
a123:
if (bools1 and 1)=0 then
if (mb and 3)=3 then
aspect=aspectold+(mx-mxold)/stats(38)
render=1
goto skipmouselook
end if
if (mb and 1) then
renderh=renderh+(mx-mxold)*2
renderv=renderv+(my-myold)*2
render=(render or 2)
end if
if (mb and 2) then
scale=scaleold+(mx-mxold)/stats(38)
render=1
end if
end if

skipmouselook:

mxold=mx:myold=my
'scaleold=scale
'aspectold=aspect
a79:

' update infowin if it exists
for x=0 to numbuttons-1
if btlst(x,4)=15 then redraw=redraw or 2:goto a335
next x
a335:

goto uistart


copybuffer:

asm
        cld
        mov esi,dword ptr [cbp]
        mov edi,dword ptr [scrp]
        mov eax,dword ptr [stats+156]
        mul dword ptr [lbytes]
        mov ecx,eax
        shr ecx,2
        rep movsd
end asm

return


showgui:

'for x=1 to 30
'pindex2(x)=pindex(x)
'next x

' debug window
stats(20)=focusw:stats(21)=focusb:stats(22)=bools1:stats(23)=(fre shr 10)

palindex=0
scrollpos=0
findex2=0
eindex2=eindex
hindex2=hindex

' tile number
stats(57)=(stats(47) shr 3)*(bmp1h shr 3)+(stats(46) shr 3)

' selection tool
if uitool=2 then x=amxold:y=amyold:xx=amx:yy=amy:i1=tcol(10):gosub drawbox2

' line tool
if uitool=6 then if stats(31)>-1 then line (amxold,amyold)-(mx,my),tcol(10)

' gradient plotter
if uitool=8 then
for z=0 to stats(72)-1
x=gradh(z)*scale*aspect+renderh
xx=0:if x>(stats(38) shr 1) then xx=stats(38)-1
y=gradv(z)*scale+renderv
line (x,y)-(xx,y),gradc(z)
next z
end if

color tcol(5),tcol(0)
locate 1,3,0:? "current file: ";mid$(fname,1,24)
locate 3,3,0


if uitool=3 then                ' paste preview
x=mx:y=my
if (bools1 and &H40000000) then
if pastex<1 then goto a352
if pastey<1 then goto a352
xx=(pastex-1)*scale*aspect+x
yy=(pastey-1)*scale+y
goto a353
end if
end if
a354:


if (bools1 and 131072) then
locate 3,1,0:? "[tile edit]";:locate 3,13,0
' corner marker
x=tcopyh*scale*aspect+renderh
xx=(tcopyh+stats(78)-1)*scale*aspect+renderh
y=tcopyv*scale+renderv
yy=(tcopyv+stats(79)-1)*scale+renderv
line (x,y)-(xx,yy),stats(71)
line (xx,y)-(x,yy),stats(71)

' tile cursor / paste preview
x=stats(46)*scale*aspect+renderh
y=stats(47)*scale+renderv

if (bools1 and &H40000000) then
if pastex<1 then goto a352
if pastey<1 then goto a352
xx=(stats(46)+pastex-1)*scale*aspect+renderh
yy=(stats(47)+pastey-1)*scale+renderv
goto a353
end if
a352:

xx=(stats(46)+stats(78)-1)*scale*aspect+renderh
yy=(stats(47)+stats(79)-1)*scale+renderv
'z=scale*aspect*128
'x=((stats(46)*z) shr 7)+renderh
'xx=(((stats(46)+stats(78)-1)*z) shr 7)+renderh
'z=scale*128
'y=((stats(47)*z) shr 7)+renderv
'yy=(((stats(47)+stats(79)-1)*z) shr 7)+renderv
a353:
gosub drawbox3
end if


if uitool=1 then ? "pen (R-click to cancel)";
if uitool=2 then ? "selection (R-click to cancel)";
if uitool=3 then ? "paste (R-click to cancel)";
if uitool=4 then ? "get color (R-click to cancel)";
if uitool=6 then ? "line tool (R-click to cancel)";
if uitool=7 then ? "fill tool (R-click to cancel)";
if uitool=8 then ? "gradient plotter (R-click to cancel)";
if uitool=5 then bfps+=1:if timer>btimer then ? "FPS (R-click to end) ";bfps/(timer-btimer)

if (bools1 and 524288) then gosub drawpixelwin

' if we changed windows, go to the first button in the window
if ((focusw>-1) and (focusb=-1)) then
for z=0 to numbuttons-1
if btlst(z,4)=focusw then focusb=z:goto a152
next z
focusw=-1       ' non-existent window?
a152:
end if


' draw buttons
for z=0 to numbuttons-1
x=btlst(z,0):y=btlst(z,1)
xx=btlst(z,2):yy=btlst(z,3)

locate y,x,0

if btype(yy)=10 then
' palette colors
btlst(z,5)=palindex
for h1=palindex to palindex+15
f1=penpal(h1)
if (bools1 and &H4000000) then f1=(((f1 and 255)+((f1 shr 8) and 255)+((f1 shr 16) and 255))\3)*&H10101

if stats(40)=8 then f1=((f1 shr 6) and 3)+((f1 shr 10) and 60)+((f1 shr 16) and 192)
color f1,f1:? "  ";
if h1=stats(24) then
x=((x-1) shl 3)+((h1 and 15) shl 4):xx=x+15
y=(y-1)*txtheight:yy=y+txtheight-1
gosub drawbox3
end if
next h1

if (bools2 and 8) then 
color tcol(0),tcol(5)
if palindex=0 then ? "b";
if palindex=16 then ? "i";
if palindex=32 then ? "n";
if palindex=48 then ? "d";
end if

palindex+=16
goto a80
else
'c=tcol(0):c2=tcol(2)
'if btype(yy)=1 then c2=tcol(7)
'if btype(yy)=2 then c2=tcol(5)
'if btype(yy)=3 then c2=tcol(6)
'if btype(yy)=6 then c2=tcol(9)
'if btype(yy)=7 then c2=tcol(8)
'if btype(yy)=11 then c2=tcol(9)

c=tcol(0):c2=tcol(buttcol(btype(yy)))

end if


if focusb=z then swap c,c2
color c,c2
if yy=92 then
ki2=curdir+space$(32)
? mid$(ki2,1,xx);
else
? mid$(btext(yy),1,xx);
end if

if btype(yy)=2 then
' show checkbox state
f1=bparam(yy)
if f1<32 then
h1=(bools1 and (1 shl f1))
else
h1=(bools2 and (1 shl (f1-32)))
end if
if h1 then locate y,x+1,0:? "X";
goto a80
end if


if ((btype(yy)=4) or (btype(yy)=5)) then
if btype(yy)=5 then color tcol(3),tcol(4)

' display a numeric value...
i1=bparam(yy):z2=1000000:h1=0
if i1<120 then
z1=stats(i1)
else
z1=fpval(i1-120)
end if
if z1<0 then z1=abs(z1):z2=100000:h1=1:blah(0)=asc("-")

if z1>=z2*10 then locate y,x+9,0:? "big num";:goto a80

' compute digits
z3=0:i2=0
do
i3=0
a156:
if z1>=z3+z2 then i3+=1:z3+=z2:i2=1:if i3<9 then goto a156
i1=z2:z2=z2/10
if i2=1 then blah(h1)=48+i3:h1+=1:if h1=7 then goto a75
if i1=1 then
if z1=z3 then goto a75
blah(h1)=asc("."):i2=1:h1+=1:if h1=7 then goto a75
end if
loop
a75:
if i2=0 then blah(h1)=48:h1+=1

' write digits to screen
i1=x+xx
for i2=0 to 6
i1=i1-1:a=32
if h1>0 then h1=h1-1:a=blah(h1)
locate y,i1,0:? chr$(a);
next i2
goto a80
end if


'if ((btype(yy)=6) or (btype(yy)=7)) then
' display part name and number
'e=pindex2(btlst(z,4))
'a=e\10
'locate y,x+1,0
'? chr$(48+a);chr$(48+e-(a*10));" ";partnames(e);
'btlst(z,5)=e
'e+=1:if e=100 then e=0
'pindex2(btlst(z,4))=e
'goto a80
'end if

if btype(yy)=9 then
' show file names from current directory
btlst(z,5)=findex2
locate y,x,0

a270:
if findex2=0 then
' do we need to scan the directory and build a file list?
if findex=findold then goto dirdone
findold=findex
imgtype=0:if (bools1 and 8192) then imgtype=4
totalfiles=0
nextfilespec:
ki2=dir(imgspecs(imgtype),&H27,lastattr)
nextfileitem:
if ki2="" then
imgtype+=1:if imgtype=4 then imgtype+=1
if imgtype=5 then ki2=dir("*.*",&H37,lastattr):goto nextfileitem
if imgtype=6 then goto dirdone
goto nextfilespec
end if
if imgtype=5 then if (lastattr and 16)=0 then goto skipitem
totalfiles+=1
i2=totalfiles-findex
if i2>14 then goto skipitem     ' keep scanning, to determine file count
if i2>0 then dirfiles(i2-1)=ki2:dirattr(i2-1)=lastattr
skipitem:
ki2=dir(lastattr)
goto nextfileitem
dirdone:
end if

if totalfiles=0 then ? " << file list empty >>          ";:goto a80
if findex>=totalfiles then findex=totalfiles-1:goto a270

if findex+findex2>=totalfiles then
btlst(z,5)=(btlst(z,5) or 128)
ki2=space$(36)
else
ki2=mid$(dirfiles(findex2),1,36)
if (dirattr(findex2) and 16) then mid$(ki2,30,7)=" <DIR> "
end if

' last character of the string is used for showing scroll bar
aa=chr$(178)
if findex2=0 then aa=chr$(24)
if findex2=1+((findex*12)\totalfiles) then aa=chr$(219):scrollpos=findex2
if findex2=13 then aa=chr$(25)
mid$(ki2,36,1)=aa
? ki2;
findex2+=1

goto a80
end if

if btype(yy)=11 then
' show EXIF data strings
btlst(z,5)=eindex2
locate y,x,0

if eindex2<exifptr then
labelstr="$"+hex$(exiftype(eindex2))
' check for known tag
x=exiftype(eindex2)
y=0                      
while knowntags(y)<>0
if knowntags(y)=x then labelstr=tagnames(y):exit while
y+=1
wend

? labelstr;exifstr(eindex2);

else
? space$(38);
end if

eindex2+=1

goto a80
end if

if btype(yy)=14 then                ' help text 'buttons'
btlst(z,5)=hindex2
locate y,x,0
if hindex2<helpsize then
? helptext(hindex2);
else
? space$(36);
end if
hindex2+=1
goto a80
end if


a80:

' draw box around highlighted button
if focusb=z then
x=(x shl 3)-8:xx=x+(xx shl 3)-1
y=(y-1)*txtheight:yy=y+txtheight-1
i1=c:gosub drawbox2
'h1=(x shl 3)-8:h2=h1+(xx shl 3)-1
'v=(y-1)*txtheight:vv=v+txtheight-1
'line (h1,v)-(h1,vv),c
'line (h1,v)-(h2,v),c
'line (h1,vv)-(h2,vv),c
'line (h2,v)-(h2,vv),c
end if

next z

return



openfile:
wtitle="    OPEN  - enter filename    "
gosub stringentry

openfile2:
if bmode=0 then locate 1,1,0:? "L"
openfile3:
if ki2="" then message=1:return
'if fileexists(ki2)=0 then message=25:return
ff1=freefile
open ki2 for binary access read as #ff1
if err<>0 then message=9:return

message=4                              ' initialize with "data decode" error message

get #ff1,,s
if s=&H4D42 then goto bmpload
if s=&HD8FF then goto startparse2
if s=&H5089 then goto pngload
if s=&H544E then goto texload

message=2:goto a122

bmpload:

x=11:get #ff1,x,yy:yy+=1    ' get offset where bitmap begins in file
x=19:get #ff1,x,bmp1h
x=23:get #ff1,x,bmp1v

gosub resizemem

get #ff1,,s:get #ff1,,s

if s=8 then
' 8-bit BMP
xx=55
get #ff1,xx,ccount(0),256                ' use ccount to temporarily hold palette
xx=(bmp1h+3) and &HFFFC

for y=bmp1v-1 to 0 step -1
get #ff1,yy,lbuf(0),xx
yy+=xx
for x=0 to bmp1h-1
z=lbuf(x)
*cast(integer ptr,@bmp1(y,x,0))=(ccount(z) and &HFFFFFF)
next x
next y

goto a224
end if

if s=16 then
' 16-bit BMP
xx=(bmp1h+bmp1h+3) and &HFFFC

for y=bmp1v-1 to 0 step -1
get #ff1,yy,lbuf(0),xx
yy+=xx
z=0
for x=0 to bmp1h-1
zz=*cast(ushort ptr,@lbuf(z))
*cast(integer ptr,@bmp1(y,x,0))=((zz and 31) shl 3)+((zz and 992) shl 6)+((zz and 31744) shl 9)
z+=2
next x
next y

goto a224
end if

if s=24 then
' 24-bit BMP
xx=((bmp1h*3)+3) and &HFFFC

for y=bmp1v-1 to 0 step -1
get #ff1,yy,lbuf(0),xx
yy+=xx
z=0
for x=0 to bmp1h-1
*cast(integer ptr,@bmp1(y,x,0))=(*cast(integer ptr,@lbuf(z)) and &HFFFFFF)
z+=3
next x
next y

goto a224
end if

' 32-bit BMP
xx=bmp1h shl 2
for y=bmp1v-1 to 0 step -1
get #ff1,yy,bmp1(y,0,0),xx
yy+=xx
next y


a224:
tformat=s
a181:
message=6                ' "file loaded"
fname=ki2
a122:
   '? "loading ended"
close #ff1
return


texload:

x=9:get #ff1,x,yy                ' texflags
get #ff1,,s:bmp1h=s
get #ff1,,s:bmp1v=s

gosub resizemem

if (yy and 256) then             ' compressed tex
bbytes=0
bp1=@bmp1(0,0,0)
f0=((bmp1h*bmp1v) shl 2)+bp1

get #ff1,,blah(0),4

gosub texgetbyte:*bp1=a:bp1+=1
gosub texgetbyte:*bp1=a:bp1+=1
gosub texgetbyte:*bp1=a:bp1+=1
gosub texgetbyte:*bp1=a:bp1+=1

tex101:
gosub texgetbyte
x=bp1:x=(x and 3)                           ' byte position

if a=blah(x) then
gosub texgetbyte
if a=0 then goto tex103
if a=1 then a=blah(x):goto tex102
x=a
gosub texgetbyte
y=(x and 63)+2                          ' count
x=((((x and 192) shl 2)+a) shl 2)       ' offset
bp2=bp1-x-4
while y>0
*bp1=*bp2:bp1+=1:bp2+=1
y=y-1
wend

else
tex102:
*bp1=a:bp1+=1
end if

if bp1<f0 then goto tex101

tex103:        ' DONE
s=50
goto a224
end if


'if (yy and 256) then             ' compressed tex
'bbits=0:bbytes=4096
'h=0:v=0
'
'a391:
'for plane=0 to 2
'
'if plane=0 then hh=h:vv=v
'
'for x=0 to 255                   ' read code lengths for huffman table
'wbits=4:gosub texreadhbits:llengths(x)=xx
'   '? #ff2,"sym ";x;" length ";xx
'next x
'
'   '? #ff2,"pLaNe"
'
'' build tables for quick decoding
'xx=0:x=0:z=0
'for y=1 to 15
'ptl(y)=0
'for w=0 to 255
'if llengths(w)=y then
'ptl(y)+=1:pcode(y)=z:z+=1           ' increase count and store (numerically) highest code value at this length
'ptable(x)=w:x+=1
'   '? #ff2,"table sym ";w;" code ";z-1
'end if
'next w
'z+=z
'next y
'
'' decode pixels
'a=0:f0=0:h=hh:v=vv
'do
'xx=0:x=-1
'for y=1 to 15
'gosub texreadhbit
'   '? #ff2,"code ";xx;" length ";y;" ptl ";ptl(y);" pcode ";pcode(y);"  x ";x
'if ptl(y)<>0 then
'x+=ptl(y)
'if xx<=pcode(y) then x+=xx-pcode(y):goto a390
'end if
'next y
'? "decode error!":sleep:goto a122
'a390:
'a+=ptable(x)
'bmp1(v,h,plane)=a
'f0+=1
'h+=1:if h=bmp1h then h=0:v+=1:if v=bmp1v then exit do
'loop until f0=32768
'
'next plane
'if v<>bmp1v then goto a391
'
's=50
'goto a224
'end if

yy=(yy and 6)                    ' uncompressed tex
xx=bmp1h

if yy=0 then
xx=xx*3
for y=0 to bmp1v-1
get #ff1,,lbuf(0),xx
z=0
for x=0 to bmp1h-1
*cast(integer ptr,@bmp1(y,x,0))=(*cast(integer ptr,@lbuf(z)) and &HFFFFFF)
z+=3
next x
next y
end if

if yy=2 then
xx=xx*4
for y=0 to bmp1v-1
get #ff1,,bmp1(y,0,0),xx
next y
end if

if yy=4 then
for y=0 to bmp1v-1
get #ff1,,lbuf(0),xx
for x=0 to bmp1h-1
z=lbuf(x)
*cast(integer ptr,@bmp1(y,x,0))=z*&H010101
next x
next y
end if

s=50
goto a224


removewin:
' close a window (remove all of its buttons)
if wid=focusw then focusw=-1:focusb=-1
i1=0

a74:
if i1=numbuttons then return
if btlst(i1,4)<>wid then i1+=1:goto a74

numbuttons=numbuttons-1
'if numbuttons>i1 then
for i2=i1 to numbuttons-1
btlst(i2,0)=btlst(i2+1,0)
btlst(i2,1)=btlst(i2+1,1)
btlst(i2,2)=btlst(i2+1,2)
btlst(i2,3)=btlst(i2+1,3)
btlst(i2,4)=btlst(i2+1,4)
btlst(i2,5)=btlst(i2+1,5)
next i2
'end if
goto a74


saveasfile:
wtitle="    SAVE  - enter filename    "
gosub stringentry
savefile2:
if ki2="" then message=1:return
fname=ki2

savefile:

if tformat=0 then message=26:return        ' "can't save this format"

if (bools1 and &H12000000) then gosub dothethings        ' don't save grid or mask layer!

kill fname:ff1=freefile
open fname for binary as #ff1
if err<>0 then message=9:return

if tformat>69 then goto savejpeg
if tformat>49 then goto savetex

if tformat=32 then zz=bmp1h shl 2
if tformat=24 then zz=bmp1h*3
if tformat=16 then zz=bmp1h+bmp1h
if tformat=8 then zz=bmp1h
zz=(zz+3) and &HFFFC
xx=zz*bmp1v

' write BMP header
y=0:if tformat=8 then y=1024
aa = "B": PUT #ff1, , aa
aa = "M": PUT #ff1, , aa
x=xx+54+y:PUT #ff1, , x                   ' file length
x=0: PUT #ff1, , x                      ' reserved
x=54+y:PUT #ff1, , x                   ' offset where bitmap starts in file
x=40: PUT #ff1, , x                     ' subheader length
PUT #ff1, , bmp1h
PUT #ff1, , bmp1v
s = 1: PUT #ff1, , s                      ' "color planes" set to 1
s = tformat: PUT #ff1, , s                      ' bits per pixel
x = 0: PUT #ff1, , x                      ' compression method (none)
PUT #ff1, , xx                          ' size of naked bitmap
x = &HEC4: PUT #ff1, , x: PUT #ff1, , x     ' pixels per meter H/V
x = 0: PUT #ff1, , x                      ' colors in palette (0=determined by bitdepth)
x = 0: PUT #ff1, , x                      ' number of "important" colors

if tformat=8 then            ' write palette for 8-bit BMPs
if (bools1 and &H4080) then
a=0                                ' use contents of bpal
for z=0 to 255
b=((bpal(z) and 63) shl 2)
g=((bpal(z) shr 4) and 252)
r=((bpal(z) shr 10) and 252)
put #ff1,,b:put #ff1,,g:put #ff1,,r:put #ff1,,a
next z
else
put #ff1,,cspace(0,0),1024         ' use contents of cspace
end if
end if


for y=bmp1v-1 to 0 step -1
z=0

if tformat=32 then
if (bools1 and &H704188) then
put #ff1,,bmp2(y,0,0),zz
else
put #ff1,,bmp1(y,0,0),zz
end if
goto a297
end if
if tformat=24 then
for x=0 to bmp1h-1
if (bools1 and &H704188) then
lbuf(z)=bmp2(y,x,0):lbuf(z+1)=bmp2(y,x,1):lbuf(z+2)=bmp2(y,x,2)
else
lbuf(z)=bmp1(y,x,0):lbuf(z+1)=bmp1(y,x,1):lbuf(z+2)=bmp1(y,x,2)
end if
z+=3
next x
end if
if tformat=16 then
for x=0 to bmp1h-1
if (bools1 and &H704188) then
lbuf(z)=(bmp2(y,x,0) shr 3)+((bmp2(y,x,1) shl 2) and 224)
lbuf(z+1)=(bmp2(y,x,1) shr 6)+((bmp2(y,x,2) shr 1) and 124)
else
lbuf(z)=(bmp1(y,x,0) shr 3)+((bmp1(y,x,1) shl 2) and 224)
lbuf(z+1)=(bmp1(y,x,1) shr 6)+((bmp1(y,x,2) shr 1) and 124)
end if
z+=2
next x
end if
if tformat=8 then
if (bools1 and &H4080) then                 ' assign colors based on bpal
c=stats(15):if (bools1 and 64) then if numzone>1 then c=c*numzone
if c>256 then c=256
for x=0 to bmp1h-1
yy=((((bmp2(y,x,2) shr 2) shl 12)+((bmp2(y,x,1) shr 2) shl 6)+(bmp2(y,x,0) shr 2)) and &HFFFFFF)
for z=0 to c-1
if bpal(z)=yy then goto a232
next z
a232:
lbuf(x)=z
next x
else
for x=0 to bmp1h-1
yy=(*cast(integer ptr,@bmp2(y,x,0)) and &HFFFFFF)
for z=0 to stats(37)-1
if *cast(integer ptr,@cspace(z,0))=yy then goto a364
next z
a364:
lbuf(x)=z
next x
end if
end if

put #ff1,,lbuf(0),zz
a297:
next y

close #ff1
message=5                ' "file saved"
return



stringentry:
color tcol(0),tcol(2)
locate 7,5,0:? wtitle
locate 8,5,0:? space$(30)
locate 9,5,0:? space$(30)
color tcol(0),tcol(1)
locate 6,4,0:? space$(32)
locate 7,4,0:? " ":locate 7,35,0:? " "
locate 8,4,0:? " ":locate 8,35,0:? " "
locate 9,4,0:? " ":locate 9,35,0:? " "
locate 10,4,0:? space$(32)
color tcol(3),tcol(4)
locate 8,6,0:? space$(28)
locate 8,6,0:input ki2
return



readmouse:
lc=0:rc=0
oldmx=mx:oldmy=my:mwold=mw:mbold=mb
if getmouse(stats(33),stats(34),stats(35),stats(36))<>0 then return
mx=stats(33):my=stats(34):mw=stats(35):mb=stats(36)
lc=((mb and (not mbold)) and 1)
rc=((mb and (not mbold)) and 2)
return


getnum:        ' decimal numbers
x=0:y=0
a101:
if eof(ff1) then return
get #ff1,,a
if a=13 then return
if a=asc("$") then goto a103
if ((a>47) and (a<58)) then x=(x*10)+(a-48):y+=1:goto a101
if y=0 then goto a101
return

a103:          ' hex numbers
if eof(ff1) then return
get #ff1,,a
if a<48 then return
a=a-48
if a>9 then a=a-7
if a>15 then a=a-32
x=(x shl 4)+a
goto a103



searchbutton:
for z=0 to numbuttons-1
x=(btlst(z,0) shl 3)-8:y=(btlst(z,1)-1)*txtheight
if mx<x then goto a71
if my<y then goto a71
if my>=y+txtheight then goto a71
if mx>x+(btlst(z,2) shl 3) then goto a71
region=-1:if mx>x+(btlst(z,2) shl 2) then region=1
scrollb=0:if mx>x+(btlst(z,2) shl 3)-8 then scrollb=1
return
a71:
next z
z=-1
return


definearea2:
stats(2)=renderh:stats(3)=renderv
definearea:
h2=maxx-stats(2):if h2>newh-1 then h2=newh-1
v2=maxy-stats(3):if v2>newv-1 then v2=newv-1
definearea3:
h1=0-stats(2):if h1<0 then h1=0
v1=0-stats(3):if v1<0 then v1=0
return


resizex:
maxh2=maxh*4

resizex2:
if newh<2 then return
if newv<2 then return

rh=bmp1h*512\newh
rv=bmp1v*512\newv
sh=newh*512\bmp1h
sv=newv*512\bmp1v

for y=v1 to v2

asm
.balign 16
end asm

yc=(y+1)*rv

if render=0 then
xptr=@bmp1(y,0,0):zz=32
else
xptr=@cbuf(y+stats(3),(stats(2)+h1)*pbytes):zz=stats(40)
end if

'for x=h1 to h2

'iy=y*rv
'd0=0:d1=0:d2=0
'xc=(x+1)*rh

'a21:
'ix=x*rh
'c0=0:c1=0:c2=0
'a20:
'i2=bmp1((iy shr 9),(ix shr 9),0)
'i1=bmp1((iy shr 9),(ix shr 9),1)
'i0=bmp1((iy shr 9),(ix shr 9),2)
'if (ix and &HFFFFFE00)=(xc and &HFFFFFE00) then
'z=((xc-ix) and 511)
'ix=ix+rh
'else
'z=(512-(ix and 511))
'ix=ix+z
'end if
'c0+=i0*z:c1+=i1*z:c2+=i2*z
'if ix<xc then goto a20

asm
        push ebp
        cld
        mov eax,dword ptr [h1]
        mov dword ptr [x],eax
        imul eax,dword ptr [rh]
        mov dword ptr [xc],eax
        mov edi,dword ptr [xptr]
a228:
        mov eax,dword ptr [y]
        imul eax,dword ptr [rv]
        mov dword ptr [iy],eax

        mov eax,dword ptr [xc]
        mov dword ptr [ix],eax
        add eax,dword ptr [rh]
        mov dword ptr [xc],eax

        xor eax,eax
        mov dword ptr [d0],eax
        mov dword ptr [d1],eax
        mov dword ptr [d2],eax
a227:
        xor eax,eax
        mov dword ptr [c0],eax
        mov dword ptr [c1],eax
        mov dword ptr [c2],eax
        mov edx,dword ptr [ix]
        mov esi,dword ptr [iy]
        shr esi,9
        imul esi,dword ptr [maxh2]
        add esi,dword ptr [bp1]
a166:
        mov ebx,edx
        shr ebx,9
        mov ebp,dword ptr [esi+ebx*4]
        and ebp,0xFFFFFF

        mov ecx,dword ptr [xc]
        add edx,512
        mov eax,ecx
        shr ecx,9
        sub eax,edx
        and eax,511
        cmp ecx,ebx
        je a167
        mov eax,edx
        not eax
        and eax,511
        and edx,0xFFFFFE00
        inc eax
a167:

        mov ecx,ebp
        movzx ebx,cl
        imul ebx,eax
        add dword ptr [c2],ebx
        movzx ebx,ch
        imul ebx,eax
        shr ecx,16
        add dword ptr [c1],ebx
        imul ecx,eax
        add dword ptr [c0],ecx
        cmp edx,dword ptr [xc]
        jl a166

        mov ebx,dword ptr [sh]
        mov eax,dword ptr [c0]
        imul eax,ebx
        shr eax,18
        mov dword ptr [c0],eax
        mov eax,dword ptr [c1]
        imul eax,ebx
        shr eax,18
        mov dword ptr [c1],eax
        mov eax,dword ptr [c2]
        imul eax,ebx
        shr eax,18
        mov dword ptr [c2],eax

        mov ebx,0xFFFFFE00
        mov eax,dword ptr [iy]
        mov ecx,ebx
        mov edx,dword ptr [yc]
        and ebx,eax
        and ecx,edx
        cmp ebx,ecx
        jne a225
        sub edx,eax
        and edx,511
        add dword ptr [iy],512
        jmp a226
a225:
        mov edx,512
        and eax,511
        sub edx,eax
        add dword ptr [iy],edx
a226:
        mov eax,dword ptr [c0]
        imul eax,edx
        add dword ptr [d0],eax
        mov eax,dword ptr [c1]
        imul eax,edx
        add dword ptr [d1],eax
        mov eax,dword ptr [c2]
        imul eax,edx
        add dword ptr [d2],eax
        mov eax,dword ptr [iy]
        cmp eax,dword ptr [yc]
        jl a227

        mov edx,dword ptr [zz]
        mov ebx,dword ptr [sv]
        cmp edx,32
        jne a244

        ' output 32-bit pixel
' SHLD is not faster...
        mov eax,dword ptr [d0]
        imul eax,ebx
        shr eax,2
        mov ecx,dword ptr [d1]
        imul ecx,ebx
        shr ecx,10
        mov ah,ch
        mov ecx,dword ptr [d2]
        imul ecx,ebx
        shr ecx,18
        mov al,cl
        stosd

a242:
        inc dword ptr [x]
        mov eax,dword ptr [h2]
        cmp eax,dword ptr [x]
        jae a228
        jmp a243

a244:
        cmp edx,8
        jne a245
        ' output 8-bit pixel
        mov eax,dword ptr [d0]
        imul eax,ebx
        shr eax,24
        mov ecx,dword ptr [d1]
        shl eax,4
        imul ecx,ebx
        shr ecx,22
        add eax,ecx
        mov ecx,dword ptr [d2]
        shl eax,2
        imul ecx,ebx
        shr ecx,24
        add eax,ecx
        stosb
        jmp a242
a245:
        cmp edx,15
        jne a246
        ' output 15-bit pixel
        mov eax,dword ptr [d0]
        imul eax,ebx
        shr eax,21
        mov ecx,dword ptr [d1]
        shl eax,5
        imul ecx,ebx
        shr ecx,21
        add eax,ecx
        mov ecx,dword ptr [d2]
        shl eax,5
        imul ecx,ebx
        shr ecx,21
        add eax,ecx
        stosw
        jmp a242
a246:
        cmp edx,16
        jne a254
        ' output 16-bit pixel
        mov eax,dword ptr [d0]
        imul eax,ebx
        shr eax,21
        mov ecx,dword ptr [d1]
        shl eax,6
        imul ecx,ebx
        shr ecx,20
        add eax,ecx
        mov ecx,dword ptr [d2]
        shl eax,5
        imul ecx,ebx
        shr ecx,21
        add eax,ecx
        stosw
        jmp a242
a254:
        ' output 24-bit pixel
        mov eax,dword ptr [d0]
        imul eax,ebx
        shr eax,18
        stosb
        mov eax,dword ptr [d1]
        imul eax,ebx
        shr eax,18
        stosb
        mov eax,dword ptr [d2]
        imul eax,ebx
        shr eax,18
        stosb
        jmp a242

a243:
        pop ebp
end asm

'c0=((c0*sh) shr 18)
'c1=((c1*sh) shr 18)
'c2=((c2*sh) shr 18)
'if (iy and &HFFFFFE00)=(yc and &HFFFFFE00) then
'z=((yc-iy) and 511)
'iy=iy+rv
'else
'z=(512-(iy and 511))
'iy=iy+z
'end if
'd0+=c0*z:d1+=c1*z:d2+=c2*z
'if iy<yc then goto a21

'cbuf(y+renderv,x+renderh)=(((d0*sv) shr 2) and &HFF0000)+(((d1*sv) shr 10) and &HFF00)+((d2*sv) shr 18)

'next x

next y
return


coloradj:
' stats 6 - contrast, 7 - bright, 10,9,8 r,g,b add
x=stats(6)+128:y=stats(7)+128
for v=0 to bmp1v-1
for h=0 to bmp1h-1
for plane=0 to 2
c0=bmp2(v,h,plane)
c0=(((c0-128)*x) shr 7)+y+stats(10-plane)
if c0>255 then c0=255
if c0<0 then c0=0
bmp2(v,h,plane)=c0
next plane
next h
next v
return


colorspace:

' skip colorspace conversion if palette dithering is on
if (bools2 and 2)+(bools1 and &H80)=&H82 then return


if (bools1 and 2048) then
' ---------------- greyscale -----------------------
x=stats(11):if x<stats(12) then x=stats(12)
if x<stats(13) then x=stats(13)
yy=255\(x-1):i1=(yy shr 2):i2=(yy shr 1):i3=i1+i2

if (bools1 and 48)<>48 then     ' simple dither or none
if (bools1 and 16)=0 then i1=i2:i3=i2
for v=0 to bmp1v-1
for h=0 to bmp1h-1
bd=bmp2(v,h,0):gd=bmp2(v,h,1):rd=bmp2(v,h,2)
y=((bd*30+gd*149+rd*77) shr 8)
if ((v+h) and 1) then
y=((y+i1)\yy)*yy
else
y=((y+i3)\yy)*yy
end if
bmp2(v,h,0)=y:bmp2(v,h,1)=y:bmp2(v,h,2)=y
next h
next v
else                            ' Floyd Steinberg dither
for v=0 to bmp1v-1
for h=0 to bmp1h-1
bd=bmp2(v,h,0):gd=bmp2(v,h,1):rd=bmp2(v,h,2)
bmp2(v,h,0)=((bd*30+gd*149+rd*77) shr 8)
next h
next v

xc=maxh-1:yc=maxv-1
plane=0
for v=0 to bmp1v-1
for h=0 to bmp1h-1
c0=bmp2(v,h,0)
i0=((c0+i2)\yy)*yy
bmp2(v,h,0)=i0:bmp2(v,h,1)=i0:bmp2(v,h,2)=i0
gosub floyds
next h
next v
end if

return
end if


' ------------------------------- RGBi and custom -------------------------------
gosub setupcs

if (bools1 and 16)=0 then        ' no dithering
for v=0 to bmp1v-1
for h=0 to bmp1h-1
gosub findrgbi
bmp2(v,h,0)=i0:bmp2(v,h,1)=i1:bmp2(v,h,2)=i2
next h
next v
return
end if

if (bools1 and 48)=16 then       ' simple dithering
for v=0 to bmp1v-1
for h=0 to bmp1h-1
gosub findrgbi
d0=c0-i0:d1=c1-i1:d2=c2-i2
y=255:gosub dithershuffle
gosub findrgbi2
bmp2(v,h,0)=i0:bmp2(v,h,1)=i1:bmp2(v,h,2)=i2
next h
next v
return
end if

xc=maxh-1:yc=maxv-1             ' Floyd Steinberg dither
for v=0 to bmp1v-1
for h=0 to bmp1h-1
gosub findrgbi
bmp2(v,h,0)=i0:bmp2(v,h,1)=i1:bmp2(v,h,2)=i2
plane=0:gosub floyds
c0=c1:i0=i1:plane=1:gosub floyds
c0=c2:i0=i2:plane=2:gosub floyds
next h
next v
return


findrgbi:
c0=bmp2(v,h,0):c1=bmp2(v,h,1):c2=bmp2(v,h,2)
findrgbi2:

' c0/1/2 have the target color
' cpy(0/1/2) have color component step size in current color space
' iy has step size of intensity bit
' f0/1/2 have the target color after depth is truncated

if (bools1 and 32768) then goto findcustom
f0=(c0\cpy(0))*cpy(0):f1=(c1\cpy(1))*cpy(1):f2=(c2\cpy(2))*cpy(2)
i0=f0:i1=f1:i2=f2
if (bools2 and 16) then                ' round-down mode?
if (xx and 8)=0 then return            ' and also with intensity bit?
if f0+iy>c0 then return
if f1+iy>c1 then return
if f2+iy>c2 then return
i0+=iy:i1+=iy:i2+=iy:return
end if
' normal mode 
x=f0+cpy(0):if x<256 then if (x-c0)<(c0-f0) then i0=x
x=f1+cpy(1):if x<256 then if (x-c1)<(c1-f1) then i1=x
x=f2+cpy(2):if x<256 then if (x-c2)<(c2-f2) then i2=x
if (xx and 8) then
rd=((c0-i0)*(c0-i0))+((c1-i1)*(c1-i1))+((c2-i2)*(c2-i2))
f0+=iy:f1+=iy:f2+=iy
x=f0+cpy(0):if x<256 then if (x-c0)<(c0-f0) then f0=x
x=f1+cpy(1):if x<256 then if (x-c1)<(c1-f1) then f1=x
x=f2+cpy(2):if x<256 then if (x-c2)<(c2-f2) then f2=x
gd=((c0-f0)*(c0-f0))+((c1-f1)*(c1-f1))+((c2-f2)*(c2-f2))
if gd<rd then i0=f0:i1=f1:i2=f2
end if

'bmp2(v,h,0)=i0:bmp2(v,h,1)=i1:bmp2(v,h,2)=i2
return

findcustom:
rd=200000

if (bools2 and 16) then        ' round-down mode
for x=0 to stats(37)-1
f0=c0-cspace(x,0):if f0<0 then f0=255
f1=c1-cspace(x,1):if f1<0 then f1=255
f2=c2-cspace(x,2):if f2<0 then f2=255
gd=(f0*f0)+(f1*f1)+(f2*f2)
if gd<rd then rd=gd:i0=cspace(x,0):i1=cspace(x,1):i2=cspace(x,2)
next x
else

for x=0 to stats(37)-1         ' normal mode
f0=c0-cspace(x,0):gd=f0*f0
if gd<rd then
f1=c1-cspace(x,1):if f1<0 then f1=0-f1
f2=c2-cspace(x,2)
gd+=((f1+1)*f1)+(f2*f2)
if gd<rd then rd=gd:i0=cspace(x,0):i1=cspace(x,1):i2=cspace(x,2)
end if
next x
end if

'bmp2(v,h,0)=i0:bmp2(v,h,1)=i1:bmp2(v,h,2)=i2
return


floyds:
if h<xc then
d0=(((c0-i0)*7) shr 4)+bmp2(v,h+1,plane):if d0>255 then d0=255
if d0<0 then d0=0
bmp2(v,h+1,plane)=d0
end if
if v<yc then
if h>0 then
d0=(((c0-i0)*3) shr 4)+bmp2(v+1,h-1,plane):if d0>255 then d0=255
if d0<0 then d0=0
bmp2(v+1,h-1,plane)=d0
end if
d0=(((c0-i0)*5) shr 4)+bmp2(v+1,h,plane):if d0>255 then d0=255
if d0<0 then d0=0
bmp2(v+1,h,plane)=d0
if h<xc then
d0=((c0-i0) shr 4)+bmp2(v+1,h+1,plane):if d0>255 then d0=255
if d0<0 then d0=0
bmp2(v+1,h+1,plane)=d0
end if
end if
return


setupcs:
cpy(0)=510:cpy(1)=510:cpy(2)=510
x=1:xx=7
if (bools1 and 1024) then x=2:xx=15
if stats(13)>1 then cpy(0)=(255\((stats(13)*x)-1))*x
if stats(12)>1 then cpy(1)=(255\((stats(12)*x)-1))*x
if stats(11)>1 then cpy(2)=(255\((stats(11)*x)-1))*x
iy=(cpy(1) shr 1)
return


palettes:

pzone=0

' building palette from image, or using predefined?
if (bools1 and 16384) then
if stats(15)=0 then return
' predefined = apply palette the dumb, slow way
for v=0 to bmp1v-1
for h=0 to bmp1h-1

x=colormatch(stats(15),0,(bmp2(v,h,2) shr 2),(bmp2(v,h,1) shr 2),(bmp2(v,h,0) shr 2))

'b=bmp2(v,h,0):g=bmp2(v,h,1):r=bmp2(v,h,2)       ' this is faster
''x=*cast(integer ptr,@bmp2(v,h,0)):b=(x and 255):g=((x shr 8) and 255):r=(x shr 16)
'd0=200000
'for z=0 to stats(15)-1
'bd=((bpal(z) and 63) shl 2)-b
'gd=((bpal(z) shr 4) and 252)-g:if gd<0 then gd=0-gd
'rd=((bpal(z) shr 10) and 252)-r
'd1=(rd*rd)+((gd+1)*gd)+(bd*bd)
'if d1<d0 then d0=d1:x=z:if d0<16 then goto a274
'next z
'a274:

bmp2(v,h,0)=((bpal(x) and 63) shl 2)
bmp2(v,h,1)=((bpal(x) shr 4) and 252)
bmp2(v,h,2)=((bpal(x) shr 10) and 252)
next h
next v
return
end if

zoneh1=0:zonev1=0
zoneh2=bmp1h-1:zonev2=bmp1v-1

' multi-palette mode?
if (bools1 and 64) then
' stats(17) and stats(18) are zone size
numzone=((bmp1v+stats(18)-1)\stats(18))*((bmp1h+stats(17)-1)\stats(17))
if numzone*stats(15)>131072 then message=24:return        ' "too many palettes"
anotherpal:
zoneh2=zoneh1+stats(17)-1:if zoneh2>=bmp1h then zoneh2=bmp1h-1
zonev2=zonev1+stats(18)-1:if zonev2>=bmp1v then zonev2=bmp1v-1
end if


' count colors
clear ccount(0),0,1048576

if (bools2 and 2)+(bools1 and &H100)=&H102 then
' if palette dithering is enabled then colorspace conversion (if any) didn't
' run yet because we need to refer back to an unmodified version of bmp2
' to do the dithering
' so we convert colorspace here, while doing the count
gosub setupcs

for v=zonev1 to zonev2
for h=zoneh1 to zoneh2
gosub findrgbi
x=(i0 shr 2)+((i1 shr 2) shl 6)+((i2 shr 2) shl 12)
ccount(x)+=1
'*cast(integer ptr,@bmp2(v,h,0))=x
next h
next v

else
for v=zonev1 to zonev2
for h=zoneh1 to zoneh2
x=(bmp2(v,h,0) shr 2)+((bmp2(v,h,1) shr 2) shl 6)+((bmp2(v,h,2) shr 2) shl 12)
ccount(x)+=1
if (bools2 and 2)=0 then *cast(integer ptr,@bmp2(v,h,0))=x
next h
next v
end if


' build list sorted by frequency
c=pzone
for x=0 to 262143
z=ccount(x)
if z=0 then goto a170
bpal(c)=x:bcount(c)=z
if c=pzone then c+=1:goto a170
y=c:c+=1:if c=262144 then message=23:return                ' "too many colors"
a169:
if bcount(y)>bcount(y-1) then
swap bcount(y),bcount(y-1):swap bpal(y),bpal(y-1)
if y>1 then y=y-1:goto a169
end if
a170:
next x

' clear out unused portion of bpal
for x=c to 262143:bpal(x)=0:next x

' repurpose ccount to hold frequency additions for substitute colors
' AND reassignments for deleted colors
clear ccount(0),0,1048576

' EHB mode?
if (bools1 and &H800000) then
if stats(19)>131071 then message=16:bools1=(bools1 and &H7F7FFFFF):goto a294        ' "EHB fail"
stats(15)=(stats(15) shr 1)
end if
a294:

stats(19)=c:if c<=stats(15) then goto a176

'? "derp?"
'for x=0 to c-1
'if bpal(x)=0 then ? x,bcount(x)
'next x
'sleep

' color reduction
d0=2+stats(73)
a172:
mindist=2000000000
for z=c-1 to pzone+1 step -1

zz=colormatch(z,d0,((bpal(z) shr 12) and 63),((bpal(z) shr 6) and 63),(bpal(z) and 63))
if cmd0<d0 then goto a171
if cmd0<mindist then mindist=cmd0

'b=(bpal(z) and 63):g=((bpal(z) shr 6) and 63):r=((bpal(z) shr 12) and 63)
'for zz=0 to z-1
'bd=(bpal(zz) and 63)-b
'gd=((bpal(zz) shr 6) and 63)-g:if gd<0 then gd=0-gd
'rd=((bpal(zz) shr 12) and 63)-r
'if (rd*rd)+((gd+1)*gd)+(bd*bd)<d0 then goto a171
'a173:
'next zz

a175:
next z
'd0+=1
d0=mindist+1
goto a172

a171:
' cut color z and reassign to zz

'if (bools2 and 2) then        ' if dithering is on, split the counts between two colors
'bd=((bpal(z) and 63) shl 1)-(bpal(zz) and 63)
'if bd>63 then bd=63
'if bd<0 then bd=0
'gd=((bpal(z) shr 5) and 126)-((bpal(zz) shr 6) and 63)
'if gd>63 then gd=63
'if gd<0 then gd=0
'rd=((bpal(z) shr 11) and 126)-((bpal(zz) shr 12) and 63)
'if rd>63 then rd=63
'if rd<0 then rd=0
'bd=colormatch(z,d0,rd,gd,bd)
''ccount(zz)+=((bcount(z)+ccount(z)) shr 1)
'ccount(zz)+=(bcount(z) shr 1)
'y=zz:gosub adjustrank
''ccount(bd)+=((bcount(z)+ccount(z)) shr 1)
'ccount(bd)+=(bcount(z) shr 1)
'y=bd:gosub adjustrank
'end if

yy=ccount(z):f0=z            ' save for later
ccount(z)=bpal(zz)
ccount(zz)+=bcount(z)

' move color zz up in the ranking if necessary
y=zz
gosub adjustrank

' move color z outside the ranked list
c=c-1
if z<c then
x=bpal(z):xx=bcount(z):y=ccount(z)
while z<c
bpal(z)=bpal(z+1):bcount(z)=bcount(z+1):ccount(z)=ccount(z+1):z+=1
wend
bpal(c)=x:bcount(c)=xx:ccount(c)=y
end if

' check whether color (now c) was a substitute
if yy>0 then
for x=c+1 to stats(19)-1
' check reassigned colors for potential re-reassignment...
if ccount(x)=bpal(c) then

y=colormatch(c,3,((bpal(x) shr 12) and 63),((bpal(x) shr 6) and 63),(bpal(x) and 63))

'b=(bpal(x) and 63):g=((bpal(x) shr 6) and 63):r=((bpal(x) shr 12) and 63)
'd2=200000
'for xx=0 to c-1
'bd=(bpal(xx) and 63)-b
'gd=((bpal(xx) shr 6) and 63)-g:if gd<0 then gd=0-gd
'rd=((bpal(xx) shr 12) and 63)-r
'd1=(rd*rd)+((gd+1)*gd)+(bd*bd)
'if d1<d2 then d2=d1:y=xx:if d2<3 then goto a296
'next xx
'a296:

' color x will now be reassigned to y, add its freq to ccount(y)
ccount(x)=bpal(y):ccount(y)+=bcount(x)

' move color y up in the ranking if necessary
if y>f0 then f0+=1
gosub adjustrank
if y>f0 then f0=f0-1
end if
next x
end if

noresub:
if f0>c then ? "HUMBUG":sleep

' restart color reduction if palette is still too large
if c>pzone+stats(15) then z=f0:goto a175

a176:

' repurpose bcount to hold color translation table
for x=0 to 262143:bcount(x)=x:next x
for x=c to stats(19)-1:bcount(bpal(x))=ccount(x):next x


' create "dark" palette if using EHB mode
if (bools1 and &H800000) then
for x=pzone to pzone+stats(15)-1
bpal(x+stats(15))=((bpal(x) and &H3EFBE) shr 1)
next x
stats(15)+=stats(15)
' and reassign colors agaaaaaaaaaain
for x=0 to 262143
if bcount(x)<>x then
y=colormatch(pzone+stats(15),0,((x shr 12) and 63),((x shr 6) and 63),(x and 63))
bcount(x)=bpal(y)

'b=(x and 63):g=((x shr 6) and 63):r=((x shr 12) and 63)
'd2=200000
'for xx=0 to stats(15)-1
'bd=(bpal(xx) and 63)-b
'gd=((bpal(xx) shr 6) and 63)-g:if gd<0 then gd=0-gd
'rd=((bpal(xx) shr 12) and 63)-r
'd1=(rd*rd)+((gd+1)*gd)+(bd*bd)
'if d1<d2 then d2=d1:y=xx:if d2=0 then goto a295
'next xx
'a295:
'bcount(x)=bpal(y)
end if
next x
end if


' apply new palette to image
if (bools2 and 2)=0 then
for v=zonev1 to zonev2           ' the fast, easy way
for h=zoneh1 to zoneh2
z=*cast(integer ptr,@bmp2(v,h,0))
zz=bcount(z)
bmp2(v,h,0)=((zz and 63) shl 2)
bmp2(v,h,1)=((zz shr 4) and 252)
bmp2(v,h,2)=((zz shr 10) and 252)
next h
next v
else
for v=zonev1 to zonev2           ' or with dithering
for h=zoneh1 to zoneh2
z=*cast(integer ptr,@bmp2(v,h,0))

c0=((z shr 2) and 63)
c1=((z shr 10) and 63)
c2=((z shr 18) and 63)

zz=bpal(colormatch(pzone+stats(15),0,c2,c1,c0))

d0=c0-(zz and 63)
d1=c1-((zz shr 6) and 63)
d2=c2-((zz shr 12) and 63)

y=63:gosub dithershuffle2

zz=bpal(colormatch(pzone+stats(15),0,c2,c1,c0))
bmp2(v,h,0)=((zz and 63) shl 2)
bmp2(v,h,1)=((zz shr 4) and 252)
bmp2(v,h,2)=((zz shr 10) and 252)
next h
next v
end if


' might need to loop for multi-palette mode
if (bools1 and 64) then
zoneh1+=stats(17):if zoneh1>=bmp1h then zoneh1=0:zonev1+=stats(18)
if zonev1>=bmp1v then
' done with image, now combine palettes into one big palette
' (this will help with viewing palette and saving)
for x=1 to numzone
y=(131072\numzone)*x
z=stats(15)*x
for xx=0 to stats(15)-1
bpal(z+xx)=bpal(y+xx)
next xx
next x
' also subtract pzone from stats(19) so org.count is not totally insane
stats(19)=stats(19)-pzone
return
end if
pzone+=(131072\numzone)
goto anotherpal
end if

' or not
return


adjustrank:
xx=ccount(y)+bcount(y)
a174:
if y=pzone then return
if xx>bcount(y-1)+ccount(y-1) then
swap bpal(y),bpal(y-1):swap bcount(y),bcount(y-1):swap ccount(y),ccount(y-1)
y=y-1:goto a174
end if
return


dithershuffle:
if stats(80)<>0 then
d0=(((v and 1) shl 1)-(h and 1) and 3)*stats(80)
c0+=d0:c1+=d0:c2+=d0
goto a376
end if

dithershuffle2:
if ((v+h) and 1) then
if d0>0 then d0=0
if d1>0 then d1=0
if d2>0 then d2=0
else
if d0<0 then d0=0
if d1<0 then d1=0
if d2<0 then d2=0
end if
c0+=d0:c1+=d1:c2+=d2
a376:
if c0<0 then c0=0
if c1<0 then c1=0
if c2<0 then c2=0
if c0>y then c0=y
if c1>y then c1=y
if c2>y then c2=y
return


dirscanname:
dirindex=0:imgtype=0
a180:
if imgtype=4 then dirindex=0:return
ki2=dir(imgspecs(imgtype),&H27)
do
if ki2="" then imgtype+=1:goto a180
if ki2=fname then dirindex+=1:return
ki2=dir()
dirindex+=1
loop

dirscannumber:
x=0:imgtype=0
a182:
if imgtype=4 then return
ki2=dir(imgspecs(imgtype),&H27)
do
if ki2="" then imgtype+=1:goto a182
x+=1
if x=dirindex then return
ki2=dir()
loop


fitscreen:
if bmp1h+bmp1v<2 then return
z1=stats(38)/(bmp1h*aspect):z2=stats(39)/bmp1v
if z1<z2 then z2=z1
render=1:scale=z2:scaleold=scale
return

centerscreen:
renderh=((stats(38)-(bmp1h*scale*aspect)) shr 1)
renderv=((stats(39)-(bmp1v*scale)) shr 1)
render=(render or 2)
return


scrollv:

if renderv-stats(3)>maxy then renderv=stats(3)+maxy
if stats(3)-renderv>maxy then renderv=stats(3)-maxy

h1=stats(2):if h1<0 then h1=0
v1=renderv:if v1<0 then v1=0
h2=newh+stats(2)-1:if h2>maxx then h2=maxx
v2=newv+renderv-1:if v2>maxy then v2=maxy

yy=stats(3)-renderv
fillhole=0
if stats(3)>renderv then if v2+yy>maxy then v2=maxy-yy:fillhole=1
if stats(3)<renderv then if v1+yy<0 then v1=0-yy:fillhole=1

z=1:zz=maxy:if yy<0 then swap v1,v2:z=-1:zz=0

i1=v2

f1=h1*pbytes:f2=(h2+1)*pbytes-f1:xx=0        ' fixed some occasional wrong pixel columns???
for y=v1 to v2 step z
'for x=h1*pbytes to h2*pbytes
'cbuf(y,x)=cbuf(y+yy,x)
'next x
xptr=@cbuf(y,f1):yptr=@cbuf(y+yy,f1)        ' source and destination addresses, f2 is count
gosub fastmemcopy
next y

stats(3)=renderv

if fillhole=0 then return

gosub definearea

if yy>0 then v1=i1-renderv
if yy<0 then v2=i1-renderv

goto resizex


scrollh:

if renderh-stats(2)>maxx then renderh=stats(2)+maxx
if stats(2)-renderh>maxx then renderh=stats(2)-maxx

h1=renderh:if h1<0 then h1=0
v1=stats(3):if v1<0 then v1=0
h2=newh+renderh-1:if h2>maxx then h2=maxx
v2=newv+stats(3)-1:if v2>maxy then v2=maxy

xx=stats(2)-renderh
fillhole=0
if stats(2)>renderh then if h2+xx>maxx then h2=maxx-xx:fillhole=1
if stats(2)<renderh then if h1+xx<0 then h1=0-xx:fillhole=1

i1=h1:i2=h2

if xx>0 then
f1=h1*pbytes:f2=(h2+1)*pbytes-f1           ' fixed some occasional wrong pixel columns???
'f1=h1*pbytes:f2=h2*pbytes-f1
else
'f1=(h2+1)*pbytes:f2=f1-(h1*pbytes)         ' this one causes a crash?
f1=h2*pbytes:f2=f1-(h1*pbytes)
end if

z=xx*pbytes
for y=v1 to v2
xptr=@cbuf(y,f1):yptr=@cbuf(y,f1+z)        ' source and destination addresses, f2 is count
gosub fastmemcopy

'if xx>0 then
'for x=h1*pbytes to h2*pbytes
'cbuf(y,x)=cbuf(y,x+z)
'next x
'else
'for x=h2*pbytes to h1*pbytes step -1
'cbuf(y,x)=cbuf(y,x+z)
'next x
'end if
next y

stats(2)=renderh

if fillhole=0 then return

gosub definearea

if xx>0 then h1=i2-renderh
if xx<0 then h2=i1-renderh

goto resizex


startparse2:
' decode a JPEG
rstint=0
exifptr=0

startparse:

get #ff1,,s
'? hex$(s):sleep

if s=&HD8FF then goto startparse     'start marker
if s=&HD9FF then goto a122           'end of image
if s=&HC2FF then goto a122           'progressive scan :(

if s=&HE1FF then                     'EXIF
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
get #ff1,,y:x=x-4
if y<>&H66697845 then exiftype(exifptr)=0:exifstr(exifptr)="'Exif' header mismatch":exifptr+=1:goto skipchunk2
get #ff1,,s:get #ff1,,s:x=x-4
if s<>&H4949 then exiftype(exifptr)=0:exifstr(exifptr)="endianness error":exifptr+=1:goto skipchunk2
get #ff1,,s:x=x-2
if s<>42 then exiftype(exifptr)=0:exifstr(exifptr)="the answer to everything?":exifptr+=1:goto skipchunk2
get #ff1,,y

' skip ahead to IFDs
for xx=9 to y:get #ff1,,a:x=x-1:next xx

' dump the whole thing to an array
x=x-6
get #ff1,,exifdump(0),x

x=0:extraifd=0

a357:
if x>65500 then goto a358
yy=*cast(ushort ptr,@exifdump(x)):x+=2               ' number of entries in IFD

' process one IFD
while yy>0                           
y=*cast(ushort ptr,@exifdump(x)):x+=2                ' tag ID
s=*cast(ushort ptr,@exifdump(x)):x+=2                ' type
xx=*cast(uinteger ptr,@exifdump(x)):x+=4             ' count

if x>65500 then goto a358
if s<1 then goto a358
if s>12 then
a358:
exiftype(exifptr)=0:exifstr(exifptr)="EXIF parsing error":exifptr+=1:goto startparse
end if

exiftype(exifptr)=y

if typesize(s)*xx<5 then
if y=&H8769 then extraifd=*cast(ushort ptr,@exifdump(x)):goto a360
exifstr(exifptr)="$"+hex$(*cast(uinteger ptr,@exifdump(x)))
if s=1 then exifstr(exifptr)=str$(*cast(uinteger ptr,@exifdump(x)))
if s=3 then exifstr(exifptr)=str$(*cast(ushort ptr,@exifdump(x)))
if s=4 then exifstr(exifptr)=str$(*cast(uinteger ptr,@exifdump(x)))
if s=6 then exifstr(exifptr)=str$(*cast(byte ptr,@exifdump(x)))
if s=8 then exifstr(exifptr)=str$(*cast(short ptr,@exifdump(x)))
if s=9 then exifstr(exifptr)=str$(*cast(integer ptr,@exifdump(x)))
if s=11 then exifstr(exifptr)=str$(*cast(single ptr,@exifdump(x)))

else
exifstr(exifptr)="--"
zz=*cast(uinteger ptr,@exifdump(x))-8
if s=2 then
if xx>26 then xx=26
for z=1 to xx
mid$(exifstr(exifptr),z)=chr$(exifdump(zz)):zz+=1
next z
end if
if s=5 then exifstr(exifptr)=str$(*cast(uinteger ptr,@exifdump(zz))\*cast(uinteger ptr,@exifdump(zz+4)))
if s=10 then exifstr(exifptr)=str$(*cast(integer ptr,@exifdump(zz))\*cast(integer ptr,@exifdump(zz+4)))
if s=12 then exifstr(exifptr)=str$(*cast(double ptr,@exifdump(zz)))
end if

exifptr+=1
a360:
x+=4
yy=yy-1
wend

x=*cast(uinteger ptr,@exifdump(x))           ' location of next IFD
if x=0 then x=extraifd:extraifd=0
if x=0 then goto startparse
x=x-8
goto a357
end if

if s=&HDDFF then                  'restart interval
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
get #ff1,,a:rstint=a:get #ff1,,a:rstint=(rstint shl 8)+a
goto startparse
end if

if s=&HDBFF then                     'quantization table
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
a209:
'get #ff1,,a:b=(a and 15)        ' table number
get #ff1,,a:b=(a and 3)        ' better idea
        ' (bit 4 indicates 16-bit table, but only 8-bit is supported)
get #ff1,,qtable(b,0),64         ' quantization values in zigzag order
if x>67 then x=x-65:goto a209
goto startparse
end if

if s=&HC4FF then                     'huffman table
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
a208:
'get #ff1,,a:b=(a and 15)        ' table number
get #ff1,,a:b=(a and 3)        ' better idea
if (a and 16) then b+=4
get #ff1,,htl(b,0),16
zz=0
for y=0 to 15
for z=1 to htl(b,y)
get #ff1,,htable(b,zz):zz+=1:if zz>256 then goto a122
next z
next y
' build huffman code table
xx=0:zz=0
for y=0 to 15
for z=0 to htl(b,y)-1
hcode(b,zz)=xx:zz+=1:xx+=1
next z
xx+=xx
next y
if x>zz+19 then x=x-zz-17:goto a208
goto startparse
end if

if s=&HC0FF then                     'baseline DCT JPEG header
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
get #ff1,,sambits       ' bits per sample
get #ff1,,a:v=a:get #ff1,,a:v=(v shl 8)+a       ' number of lines
get #ff1,,a:h=a:get #ff1,,a:h=(h shl 8)+a       ' number of pixels/line

' resize memory bitmaps
bmp1h=h:bmp1v=v
maxh=bmp1h+16:maxv=bmp1v+16
gosub resizemem2

get #ff1,,cnum          ' number of components
for y=0 to cnum-1
get #ff1,,a             ' component identifier
get #ff1,,cr(a)         ' component resolution (h is the high nibble)
get #ff1,,cq(a)         ' quantization table selection
next y
goto startparse
end if

if s=&HDAFF then                     'start of scan           
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a       ' header length
get #ff1,,a             ' number of components in scan
for y=0 to a-1
get #ff1,,b             ' component identifier
get #ff1,,g
ced(b)=(g shr 4)        ' DC entropy coding huffman table
ced(b+4)=(g and 15)+4     ' AC entropy coding huffman table
next y
get #ff1,,a             ' start of spectral selection (?)
get #ff1,,a             ' end of spectral selection (?)
get #ff1,,a             ' approximation bit positions (?)


' intitialize data buffers (so that monochrome JPGs don't have random color)
clear blk4(1,0),0,1536


' start decompressing blocks

bbits=0:bbytes=4096:blksdone=0
for y=1 to 4:olddc(y)=0:next y

ybh=(cr(1) shr 4):ybv=(cr(1) and 15)

for bv=0 to v-1 step (ybv shl 3)
for bkh=0 to h-1 step (ybh shl 3)

for dbuf=1 to ybh*ybv
bcom=1
gosub decodeblk
next dbuf

if cnum>1 then
bcom=2:dbuf=5
gosub decodeblk
bcom=3:dbuf=6
gosub decodeblk
end if

asm
.balign 16
end asm

dbuf=0
for yy=1 to ybv
bvo=((yy-1) shl 3)+bv
for xx=1 to ybh
dbuf+=1
bho=((xx-1) shl 3)+bkh
for y=0 to 7

'for x=0 to 7
'if x+bho>maxh-1 then goto a204
'i0=blk4(dbuf,x+(y shl 3))
'if cnum<2 then i1=0:i2=0:goto a207
'if ybh=1 then
'z=x
'else
'z=(x shr 1)+((xx-1) shl 2)
'end if
'if ybv=1 then
'z+=(y shl 3)
'else
'z+=(((y shr 1)+((yy-1) shl 2)) shl 3)
'end if
'i1=blk4(5,z)-128
'i2=blk4(6,z)-128
'' convert to RGB
'a207:
'c2=1.402*i2+i0
'c1=i0-.34414*i1-.71414*i2
'c0=1.772*i1+i0
'if c0<0 then c0=0
'if c0>255 then c0=255
'if c1<0 then c1=0
'if c1>255 then c1=255
'if c2<0 then c2=0
'if c2>255 then c2=255
'bmp1(y+bvo,x+bho,0)=c0
'bmp1(y+bvo,x+bho,1)=c1
'bmp1(y+bvo,x+bho,2)=c2
'a204:
'next x

        bp1=@bmp1(bvo+y,bho,0)
asm
        push ebp
        cld
        ' calculate addresses and stuff
        mov edi,dword ptr [bp1]

        movzx eax,byte ptr [dbuf]
        dec eax
        shl eax,3
        add eax,dword ptr [y]
        shl eax,5
'        add eax,offset _BLK4
        add eax,offset blk4
        mov esi,eax

        mov ebx,dword ptr [y]
        mov al,byte ptr [ybv]
        cmp al,1
        je a193
        mov eax,dword ptr [yy]
        dec eax
        shr ebx,1
        shl eax,2
        add ebx,eax
a193:
        shl ebx,5
        mov dword ptr [z],ebx

        xor ebp,ebp
a194:
        ' load a Y value
        lodsd
'        sar eax,10
'        add eax,32768
        add eax,0x2000000
        jns a231
        xor eax,eax
a231:

        ' calculate chroma components address
        mov dl,byte ptr [ybh]
        cmp dl,1
        je a195
        mov edx,dword ptr [xx]
        dec edx
        shl edx,3
        add edx,ebp
'        lea edx,[ebp+edx*8-8]
        shr edx,1
        jmp a196
a195:
        mov edx,ebp
a196:
        shl edx,2
        add edx,dword ptr [z]

        ' load chroma values
        mov ebx,dword ptr [blk4+1024+edx]
        mov ecx,dword ptr [blk4+1280+edx]
        sar ebx,12
        sar ecx,12

        ' calculate B
        mov edx,5742
        imul edx,ecx
        add edx,eax
        sar edx,18
        jns a197
        xor edx,edx
a197:
        cmp edx,255
        jna a198
        mov edx,255
a198:
        push edx

        ' calculate G
        imul ecx,-2925
        mov edx,-1409
        imul edx,ebx
        add ecx,eax
        add edx,ecx
        sar edx,18
        jns a199
        xor edx,edx
a199:
        cmp edx,255
        jna a220
        mov edx,255
a220:

        ' calculate R
        mov ecx,7258
        imul ecx,ebx
        add ecx,eax
        sar ecx,18
        jns a221
        xor ecx,ecx
a221:
        cmp ecx,255
        jna a222
        mov ecx,255
a222:

        pop eax
        shl eax,8
        add eax,edx
        shl eax,8
        add eax,ecx

        stosd
        
        inc ebp
        cmp ebp,8
        jne a194
        pop ebp
end asm

next y
a223:
next xx
next yy

blksdone+=1
if blksdone=rstint then
blksdone=0:bbits=0:bbytes+=2
for y=1 to 4:olddc(y)=0:next y
end if

next bkh
next bv

tformat=70
goto a181
end if

if (s and 255)<>255 then goto a122

skipchunk:
get #ff1,,a:x=a:get #ff1,,a:x=(x shl 8)+a
skipchunk2:
for y=3 to x:get #ff1,,a:next y
goto startparse


decodeblk:

'? "bcom ";bcom;" dbuf ";dbuf;" bv ";bv;" bkh ";bkh

' get DC coefficient
i3=ced(bcom)
gosub readcode

yptr=@blk4(dbuf,0)

olddc(bcom)+=m

i2=cq(bcom)

m=olddc(bcom)*qtable(i2,0)*32768
'for y=0 to 63
'blk4(dbuf,y)=m
'next y
asm
        mov eax,dword ptr [m]
        mov edi,dword ptr [yptr]
        mov ecx,64
        rep stosd
end asm


' get AC coefficients
i3=ced(bcom+4):z=1

a206:
gosub readcode

if x=0 then return
z+=(x shr 4)

m=m*qtable(i2,z)
f2=(zigzag(z) shl 6)
z+=1
'for y=0 to 63
'blk4(dbuf,y)+=m*itable(y+f2)
'next y
xptr=@itable(f2)
asm
        mov ebx,dword ptr [m]
        mov esi,dword ptr [xptr]
        mov edi,dword ptr [yptr]
        add esi,256
        add edi,256
        mov ecx,-64
        .balign 16
a235:
        mov eax,dword ptr [esi+ecx*4]
        imul eax,ebx
'        mov eax,ebx
'        imul eax,dword ptr [esi+ecx*4]
        add dword ptr [edi+ecx*4],eax
        inc ecx
        jnz a235
end asm


if z<64 then goto a206
a205:

return


asm
.balign 16
end asm

'readbit:
'if bbits=0 then
'if bbytes>4095 then get #ff1,,filebuf():bbytes=bbytes-4096
'a=filebuf(bbytes):bbits=8:bbytes+=1
'if a=255 then bbytes+=1       ' skip next byte (even if it is in next buffer)
'end if
'xx+=xx+(a shr 7)
'a+=a:bbits=bbits-1
'return

nextbyte:
if bbytes>4095 then get #ff1,,filebuf():bbytes=bbytes-4096
a=filebuf(bbytes):bbits=8:bbytes+=1
if a=255 then bbytes+=1       ' skip next byte (even if it is in next buffer)
return

readcode:
xx=0:yy=0:zz=0:m=0
do
if bbits=0 then gosub nextbyte
xx+=xx+(a shr 7):a+=a:bbits=bbits-1

x=htl(i3,yy)
if x>0 then
if xx>hcode(i3,zz+x-1) then zz+=x:goto a288
do
if xx=hcode(i3,zz) then goto a201
zz+=1
loop
'x=x-1
'loop until x=0
'x=0:return       ' FUBAR if we get here, so...?
end if
a288:

yy+=1
loop until yy=16
x=0:return       ' FUBAR if we get here, so...?

a201:
x=htable(i3,zz)

if (x and 15) then

if bbits=0 then gosub nextbyte
m=-2:if (a and 128) then m=1
a+=a:bbits=bbits-1

for y=2 to (x and 15)
if bbits=0 then gosub nextbyte
m+=m+(a shr 7):a+=a:bbits=bbits-1
next y
if m<0 then m+=1

end if
return


pointtranslate3:
amx=stats(61):amy=stats(62)
return

pointtranslate2:
amx=stats(63):amy=stats(64)
return


copybox:
ki2=exepath+"\IMGTOOL.TMP"
copybox2:
message=15                        ' "invalid rectangle"
if xx<1 then return
if yy<1 then return
if x+xx>bmp1h then return
if y+yy>bmp1v then return
ff1=freefile
open ki2 for binary as #ff1
if err<>0 then message=9:return
put #ff1,,xx:put #ff1,,yy
pastex=xx:pastey=yy
for z=0 to yy-1
put #ff1,,bmp1(z+y,x,0),(xx*4)
next z
close #ff1:message=0
return


dupebmp:
for v=0 to bmp1v-1
gosub fastlinecopy
next v
return

redupebmp:
for v=0 to bmp1v-1
xptr=@bmp1(v,0,0):yptr=@bmp2(v,0,0)
asm
        cld
        mov esi,dword ptr [yptr]
        mov edi,dword ptr [xptr]
        mov ecx,dword ptr [bmp1h]
        rep movsd
end asm
next v
return


straightcopy:

for y=v1 to v2
xptr=@cbuf(y+stats(3),(h1+stats(2))*pbytes)
yptr=@bmp1(y,h1,0):if (bools1 and &H12704188) then yptr=@bmp2(y,h1,0)

'if stats(40)=32 then
'for x=h1 to h2
'*xptr=*yptr
'xptr+=1:yptr+=1
'next x
'end if

asm
        cld
        mov esi,dword ptr [yptr]
        mov edi,dword ptr [xptr]
        mov ecx,dword ptr [h2]
        sub ecx,dword ptr [h1]
        mov ebx,dword ptr [stats+160]
        cmp ebx,32
        jne a247
        rep movsd
        jmp a248
a247:
        cmp ebx,16
        jne a252
a253:
        lodsd
        shr ah,2
        shr eax,3
        shl ax,5
        shr eax,5
        stosw
        dec ecx
        jnz a253
        jmp a248
a252:
        cmp ebx,15
        jne a249
a250:
        lodsd
        shr ah,3
        shr eax,3
        shl ax,6
        shr eax,6
        stosw
        dec ecx
        jnz a250
        jmp a248
a249:
        cmp ebx,8       ' render to 8-bit
        jne a251
a240:
        lodsd
        shr ah,4
        shr eax,6
        shl ax,10
        shr eax,10
        stosb
        dec ecx
        jnz a240
        jmp a248
a251:
        ' render to 24-bit
        lodsd
        stosb
        shr eax,8
        stosw
        dec ecx
        jnz a251

a248:

end asm

next y
return


clearempty:
' fill unoccupied areas of framebuffer with blackness (or background color)

bgc2=bgc
if stats(40)=16 then bgc2=((bgc shr 8) and &HF800)+((bgc shr 5) and &H7E0)+((bgc shr 3) and &H1F)
if stats(40)=15 then bgc2=((bgc shr 9) and &H7C00)+((bgc shr 6) and &H3E0)+((bgc shr 3) and &H1F)
if stats(40)=8 then bgc2=((bgc shr 16) and &HC0)+((bgc shr 10) and &H3C)+((bgc shr 6) and &H03)

x=stats(38)

if stats(3)>0 then
for y=0 to stats(3)-1
yptr=@cbuf(y,0):gosub clearbg
next y
end if

if stats(3)+newv<stats(39) then
for y=stats(3)+newv to maxy
yptr=@cbuf(y,0):gosub clearbg
next y
end if

v=stats(3):if v<0 then v=0
yy=stats(3)+newv:if yy>maxy then yy=maxy

if stats(2)>0 then
x=stats(2)
for y=v to yy
yptr=@cbuf(y,0):gosub clearbg
next y
end if

if stats(2)+newh<stats(38) then
z=stats(2)+newh:zz=z*pbytes
x=stats(38)-z
for y=v to yy
yptr=@cbuf(y,zz):gosub clearbg
next y
end if

return


clearbg:

asm
        cld
        mov edi,dword ptr [yptr]
        mov ecx,dword ptr [x]
        mov eax,dword ptr [bgc2]
        mov ebx,dword ptr [stats+160]        ' stats(40) = color depth
        cmp ebx,8
        jne a268
        rep stosb        
        jmp a273   
a268:
        cmp ebx,24
        jne a269
        mov edx,eax
        shr edx,16
a277:
        stosw
        mov byte ptr [edi],dl
        inc edi
        dec ecx
        jnz a277
        jmp a273   
a269:
        cmp ebx,32
        jne a272
        rep stosd
        jmp a273   
a272:
        rep stosw
a273:
end asm

return


displaycustom:

' set palette
for z=0 to 255
b=((bpal(z) and 63) shl 2)
g=((bpal(z) shr 4) and 252)
r=((bpal(z) shr 10) and 252)
palette z,r,g,b
next z

gosub definearea3
h2=maxx-stats(2):if h2>bmp1h-1 then h2=bmp1h-1
v2=maxy-stats(3):if v2>bmp1v-1 then v2=bmp1v-1

' render stuff using custom palette
c=stats(15):if c>256 then c=256
for y=v1 to v2
for x=h1 to h2

yy=((bmp2(y,x,2) shr 2) shl 12)+((bmp2(y,x,1) shr 2) shl 6)+(bmp2(y,x,0) shr 2)
for z=0 to c-1
if bpal(z)=yy then goto a255
next z
a255:
cbuf(y+stats(3),x+stats(2))=z

next x
next y

screenlock
gosub copybuffer
screenunlock

sleep

gosub setpal8
render=1
return


setpal8:
for x=0 to 255
palette x,(x\64)*85,((x and 60) shr 2)*17,(x and 3)*85
next x
return


checkbaction:
v=baction(xx):redraw=2
if v=0 then return
if v=1 then render=1
if v=2 then recalc=1

if v<253 then if (bools1 and (1 shl (v-3))) then recalc=1

if v=253 then if (bools1 and &H4180) then recalc=1            ' palette or custom palette or any colorspace
if v=254 then if (bools1 and &H4080) then recalc=1            ' palette or custom palette
if v=255 then v=0:goto checktempfile

return


newfile:
exifptr=0
renderh=0:renderv=0
scale=1:aspect=1:scaleold=1
recalc=1
uitool=0
hidemenu=0
bools1=(bools1 and &H7FFFFE77)

bmp1h=stats(38):bmp1v=stats(39)
gosub resizemem
clear bmp1(0,0,0),0,maxv*maxh*4

amx=0:amxold=0:amy=0:amyold=0

fname="default.bmp"
message=8                ' "bitmap cleared"
return


savejpeg:

' build quantization table according to quality setting
if stats(30)<1 then stats(30)=1
if stats(30)>7 then stats(30)=7
for v=0 to 1
for y=0 to 63
if stats(30)=7 then 
qtable2(v,y)=qtable4(v,y)
else
qtable2(v,y)=(qtable3(v,y) shl 1)\stats(30)
end if
next y
next v

' write headers

s=&HD8FF:put #ff1,,s
s=&HE0FF:put #ff1,,s
s=&H1000:put #ff1,,s
s=&H464A:put #ff1,,s:s=&H4649:put #ff1,,s       ' JFIF
s=&H0100:put #ff1,,s:s=&H0101:put #ff1,,s
s=&H6400:put #ff1,,s:s=&H6400:put #ff1,,s       ' 100dpi
s=&H0000:put #ff1,,s

for y=0 to 1
s=&HDBFF:put #ff1,,s:s=&H4300:put #ff1,,s       ' quantization tables
a=y:put #ff1,,a
put #ff1,,qtable2(y,0),64
next y


' write some other info for format-71 (uncompressed, nonstandard jpg)
if tformat=71 then
s=&HC0FF:put #ff1,,s
s=bmp1h:put #ff1,,s
s=bmp1v:put #ff1,,s
y=0:put #ff1,,y
end if


' estimate necessary size of output data buffer
ebsize=bmp1h*bmp1v\(18-stats(30))
redim encbuf(0 to ebsize) as integer


' Pass 1... convert to YUV, do DCT
' and gather data for building custom huffman table

clear hcount(0,0),0,8224
huffptr=0
olddc(1)=0:olddc(2)=0:olddc(3)=0

for bv=0 to bmp1v-8 step 8
for bkh=0 to bmp1h-8 step 8

' load block and convert to YUV
z=0
for v=0 to 7
bp1=@bmp1(bv+v,bkh,0)
if (bools1 and &H704188) then bp1=@bmp2(bv+v,bkh,0)
for h=0 to 7
b=*bp1:bp1+=1:g=*bp1:bp1+=1:r=*bp1:bp1+=2
blk4(1,z)=(((7471*b)+(38469*g)+(19595*r)) shr 16)-128
blk4(4,z)=(((32767*b)-(21692*g)-(11075*r)) shr 16)
blk4(5,z)=(((32767*r)-(27444*g)-(5318*b)) shr 16)
z+=1
next h
next v

bcom=1:dbuf=1:b=0
gosub encodeblk

bcom=2:dbuf=4:b=1
gosub encodeblk
bcom=3:dbuf=5:b=1
gosub encodeblk

next bkh
next bv

if tformat=71 then message=5:return                ' indicate success...


' build huffman tables

clear htl(0,0),0,128
clear htable(0,0),0,2048

for i0=0 to 3

' how many symbols?
y=0
for x=0 to 255
if hcount(i0,x)>0 then y+=1
next x

' start assigning codes
zz=hcount(i0,256)
yy=2:xx=0:z=0
a256:
zz=(zz shr 1)
if y>yy then
for x=0 to 255
if hcount(i0,x)>zz then hcount(i0,x)=0:htl(i0,z)+=1:htable(i0,xx)=x:xx+=1:y=y-1:yy=yy-1
next x
z+=1:yy+=yy
goto a256
end if

' add any remaining symbols at current code length
if y>0 then
for x=0 to 255
if hcount(i0,x)>0 then htl(i0,z)+=1:htable(i0,xx)=x:xx+=1
next x
end if

' write table to file
s=&HC4FF:put #ff1,,s
s=19+xx:a=(s shr 8):put #ff1,,a:a=(s and 255):put #ff1,,a
a=(i0 and 1):if (i0 and 2) then a+=16
put #ff1,,a
put #ff1,,htl(i0,0),16
put #ff1,,htable(i0,0),xx

' build code table (needed for encoding later)
xx=0:zz=0
for y=0 to 15
for z=0 to htl(i0,y)-1
hlength(i0,htable(i0,zz))=y+1
hcode(i0,htable(i0,zz))=xx
xx+=1:zz+=1
next z
xx+=xx
next y

next i0


s=&HC0FF:put #ff1,,s            ' baseline DCT JPEG header
s=&H1100:put #ff1,,s            ' header length
a=8:put #ff1,,a                 ' sample bits
a=(bmp1v shr 8):put #ff1,,a:a=(bmp1v and 248):put #ff1,,a       ' vres
a=(bmp1h shr 8):put #ff1,,a:a=(bmp1h and 248):put #ff1,,a       ' hres
a=3:put #ff1,,a                 ' color components

a=1:put #ff1,,a                 ' component ID
a=17:put #ff1,,a                ' component resolution
a=0:put #ff1,,a                 ' quant table selection
a=2:put #ff1,,a                 ' component ID
a=17:put #ff1,,a                ' component resolution
a=1:put #ff1,,a                 ' quant table selection
a=3:put #ff1,,a                 ' component ID
a=17:put #ff1,,a                ' component resolution
a=1:put #ff1,,a                 ' quant table selection

s=&HDAFF:put #ff1,,s            ' start of scan
s=&H0C00:put #ff1,,s            ' header length
a=3:put #ff1,,a                 ' number of components

a=1:put #ff1,,a                 ' component ID
a=0:put #ff1,,a                 ' huffman table selection
                                ' (DC=top nibble, AC=bottom nibble)
a=2:put #ff1,,a                 ' component ID
a=17:put #ff1,,a                 ' huffman table selection
a=3:put #ff1,,a                 ' component ID
a=17:put #ff1,,a                 ' huffman table selection

a=0:put #ff1,,a                 ' ??
a=63:put #ff1,,a                ' ??
a=0:put #ff1,,a                 ' ??

' Pass 2... encode and write the data

'locate 10,10,0:? huffptr;"          "

bbits=0:bbytes=0
for x=0 to huffptr-1
z=encbuf(x):b=(z shr 24):xx=(z and 65535)
if b=15 then wbits=((z shr 16) and 255):goto a262
wbits=hlength(b,xx):xx=hcode(b,xx)
a262:
gosub writebits3
next x

gosub writelast
close #ff1

' deallocate the memory that was used for temporary encoding buffer
redim encbuf(0 to 1) as integer
ebsize=1

message=5        ' "file saved"
return


encodeblk:
' DCT (format 71)
if tformat=71 then
if bcom=1 then
for z=0 to 63
x=0:zz=(z shl 6)
for y=0 to 63
x+=blk4(dbuf,y)*itable(y+zz)
next y
y=qtable71(b,zigzag2(z))*4        ':if z=0 then y=1
blk(zigzag2(z))=(x shr 18)\y
next z

z=0
while z<64

s=blk(z)

if z=0 then s=blk(0)-olddc(bcom):olddc(bcom)=blk(0):goto a370
if s<>0 then
a370:
if s<64 then a=s:put #ff1,,a:goto a368
if s>&HFFBF then a=(s and 255):put #ff1,,a:goto a368
a=(s and 63)+64:put #ff1,,a
a=((s shr 6) and 255):put #ff1,,a
goto a368
end if

a=128
while blk(z+1)=0
a+=1:z+=1:if z=63 then goto a369
wend
a369:
put #ff1,,a

a368:
z+=1
wend
end if
goto a259
end if

' DCT (normal)
for z=0 to 63
xptr=@blk4(dbuf,0):yptr=@itable(z shl 6)
asm
        cld
        mov esi,dword ptr [xptr]
        mov ebx,dword ptr [yptr]
        add esi,256
        add ebx,256
        mov ecx,-64
        xor edx,edx
a261:
        mov eax,dword ptr [esi+ecx*4]
        imul eax,[ebx+ecx*4]
        add edx,eax
        inc ecx
        jnz a261
        mov dword ptr [x],edx
end asm
blk(zigzag2(z))=(x shr 18)\qtable2(b,zigzag2(z))
next z


' DC coefficient
x=blk(0)-olddc(bcom):olddc(bcom)=blk(0)
m=0
if x=0 then gosub writecode:goto a258
y=abs(x)
do:m+=1:y=(y shr 1):loop until y=0
gosub writecode
if x<0 then x+=(1 shl m)-1
xx=x:wbits=m:gosub writebits
a258:


' AC coefficients
b+=2

zz=1
for z=1 to 63
x=blk(z)
if x<>0 then
a260:
if z-zz>15 then zz+=16:m=240:gosub writecode:goto a260
y=abs(x):m=0
do:m+=1:y=(y shr 1):loop until y=0
if x<0 then x+=(1 shl m)-1
m+=((z-zz) shl 4)
zz=z+1:gosub writecode
xx=x:wbits=(m and 15):gosub writebits
end if
next z

if zz<64 then m=0:gosub writecode

a259:
return


writecode:
hcount(b,m)+=1:hcount(b,256)+=1
encbuf(huffptr)=(b shl 24)+m:huffptr+=1
goto writebits2

writebits:
encbuf(huffptr)=&HF000000+(wbits shl 16)+(xx and 65535):huffptr+=1
writebits2:
if huffptr<ebsize then return
ebsize+=262144
redim preserve encbuf(0 to ebsize) as integer
return

writebits3:                          ' writes MSb first, as MSb (preserves xx)
if wbits=0 then return
wbits=wbits-1:a+=a
if (xx and (1 shl wbits)) then a+=1
bbits+=1
if bbits=8 then
bbits=0
a257:
filebuf(bbytes)=a:bbytes+=1
if bbytes=4096 then put #ff1,,filebuf():bbytes=0
if a=255 then a=0:goto a257
a=0
end if
goto writebits3

writelast:                           ' (this routine and the above are for JPEG encoding)
if bbits>0 then filebuf(bbytes)=(a shl (8-bbits)):bbytes+=1
if bbytes>0 then put #ff1,,filebuf(0),bbytes
return


resizemem:
maxh=bmp1h:maxv=bmp1v
resizemem2:
redim bmp2(0 to maxv-1,0 to maxh-1,0 to 3) as ubyte
resizemem3:
redim bmp1(0 to maxv-1,0 to maxh-1,0 to 3) as ubyte
redim lbuf(0 to maxh*4) as ubyte
redim oldline(0 to maxh*4) as ubyte
redim lbuf2(0 to maxv*3) as ubyte

*cast(integer ptr,@lbuf(0))=0
*cast(integer ptr,@oldline(0))=0

stats(46)=0:stats(47)=0

return


'texreadhbits:
'xx=0
'while wbits>0
'gosub texreadhbit
'wbits=wbits-1
'wend
'return
'
'texreadhbit:
'if bbits=0 then
'if bbytes=4096 then get #ff1,,filebuf():bbytes=0
'dbits=filebuf(bbytes):bbytes+=1:bbits=8
'end if
'xx+=xx+(dbits and 1):dbits=(dbits shr 1):bbits=bbits-1
'return
'
'
'texwritehbits:                       ' writes MSb first, as LSb (preserves xx)
'if wbits=0 then return
'wbits=wbits-1
'if ((xx shr wbits) and 1) then dbits+=(1 shl bbits)
'bbits+=1
'if bbits=8 then
'bbits=0:filebuf(bbytes and 4095)=dbits:bbytes+=1
'if (bbytes and 4095)=0 then put #ff1,,filebuf()
'dbits=0
'end if
'goto texwritehbits


texputbyte3:
a=*bp1                        ' load the byte from bitmap pointer
bcount(a)=bp1:bp1+=1          ' record address where byte was seen
texputbyte:
filebuf(bbytes and 4095)=a:bbytes+=1
if (bbytes and 4095)=0 then put #ff1,,filebuf()
return

texgetbyte:
if (bbytes and 4095)=0 then get #ff1,,filebuf()
a=filebuf(bbytes and 4095):bbytes+=1
return


savetex:

' write header

y=&H5845544E:put #ff1,,y
put #ff1,,y                                ' data size (don't know yet)
y=&H101:put #ff1,,y                        ' flags (set bit 8 to indicate it is compressed)
s=bmp1h:put #ff1,,s                        ' width
s=bmp1v:put #ff1,,s                        ' height

'bbits=0:bbytes=0:dbits=0
bbytes=0

bp1=@bmp1(0,0,0)
if (bools1 and &H704188) then bp1=@bmp2(0,0,0)

f0=((bmp1v*bmp1h) shl 2)+bp1

clear bcount(0),0,4096             ' use bcount to store symbol frequencies

bp2=bp1
while bp2<f0
bcount(*bp2)+=1:bp2+=1
bcount(*bp2+256)+=1:bp2+=1
bcount(*bp2+512)+=1:bp2+=1
bcount(*bp2+768)+=1:bp2+=1
wend

i0=1000000000
i1=i0:i2=i0:i3=i0                  ' find least common value for each byte position
for x=0 to 255
if bcount(x)<i0 then i0=bcount(x):blah(0)=x
if bcount(x+256)<i1 then i1=bcount(x+256):blah(1)=x
if bcount(x+512)<i2 then i2=bcount(x+512):blah(2)=x
if bcount(x+768)<i3 then i3=bcount(x+768):blah(3)=x
next x

f0=((bmp1v*bmp1h) shl 2)

' encode the data

put #ff1,,blah(0),4

clear bcount(0),0,1024             ' now use bcount to store byte-last-seen-at addresses

gosub texputbyte3
gosub texputbyte3
gosub texputbyte3
gosub texputbyte3

d1=4        ' number of bytes transferred to output thus far

tex203:

if d1>=f0 then goto texcompdone

' search for matches

x=(d1 and -4):if x>4096 then x=4096
bd=0

z=bcount(*bp1)
'bcount(*bp1)=bp1
y=bp1-x
if cast(uinteger,z)<cast(uinteger,y) then goto searchdone        ' skip search, nothing to find

z=bp1-z
'while x>0
while x>=z

if *cast(integer ptr,bp1)<>*cast(integer ptr,bp1-x) then goto tex206

y=4

comparelp:
bp2=bp1+y:a=*bp2
bp2=bp2-x
if *bp2<>a then goto tex205
y+=1:if y=65 then goto tex205
if y=x then goto tex205
if d1+y<f0 then goto comparelp

tex205:
if y>bd then gd=x:bd=y:if y=65 then goto searchdone
tex206:
x=x-4
wend

searchdone:

x=bp1:x=blah(x and 3)

if bd<4 then
gosub texputbyte3                           ' write a literal byte
if a=x then a=1:gosub texputbyte            ' (and a 1 if it happens to be the doodad)
d1+=1:goto tex203
end if

a=x:gosub texputbyte                        ' doodad
x=((gd-4) shr 2)
y=((x shr 2) and 192)+bd-2
a=y:gosub texputbyte                        ' count and top 2 bits of offset
a=x:gosub texputbyte                        ' bottom 8 bits of offset

for x=1 to bd
bcount(*bp1)=bp1:bp1+=1
next x

'bp1+=bd
d1+=bd
goto tex203


texcompdone:

x=bp1:a=blah(x and 3):gosub texputbyte      ' doodad
a=0:gosub texputbyte                        ' end-of-data

' write last bytes (if any)
x=(bbytes and 4095)
if x<>0 then put #ff1,,filebuf(0),x

bbytes+=4
y=5:put #ff1,y,bbytes        ' update data size in the header

close #ff1
message=5        ' "file saved"
return


'a389:
'for plane=0 to 2
'
'if plane=0 then hh=h:vv=v
'
'clear bcount(0),0,1024             ' use bcount to store symbol frequencies
'
'' count symbol frequencies for 32K pixels on a plane
'z=0:f0=0:h=hh:v=vv
'do
'a=bmp1(v,h,plane)
'bcount((a-z) and 255)+=1:z=a
'f0+=1
'h+=1:if h=bmp1h then h=0:v+=1:if v=bmp1v then exit do
'loop until f0=32768
'
'clear ptl(0),0,32                  ' number of codes at each length
'clear ptable(0),0,512              ' symbol value associated with each code
'
'' how many unique symbols?
'y=0
'for x=0 to 255
'if bcount(x)<>0 then y+=1
'next x
'
'' start assigning codes
'zz=f0
'yy=2:xx=0:z=1                      ' z starts at 1 here, unlike jpeg, because of reasons
'a377:
'zz=(zz shr 1)
'if y>yy then
'for x=0 to 255
'if bcount(x)>zz then bcount(x)=0:ptl(z)+=1:ptable(xx)=x:xx+=1:y=y-1:yy=yy-1
'next x
'z+=1:yy+=yy
'goto a377
'end if
'
'' add any remaining symbols at current code length
'if y>0 then
'for x=0 to 255
'if bcount(x)>0 then ptl(z)+=1:ptable(xx)=x:xx+=1
'next x
'end if
'
'   '? #ff2,"plane"
'
'' build code table (needed for encoding later)
'clear llengths(0),0,256
'xx=0:zz=0
'for y=1 to 15                      ' y starts at 1 here, unlike jpeg, because of reasons
'for z=0 to ptl(y)-1
'llengths(ptable(zz))=y                  ' length of code for each symbol
'pcode(ptable(zz))=xx                    ' code for each symbol
'   '? #ff2,"table sym ";ptable(zz);" code ";xx
'xx+=1:zz+=1
'next z
'xx+=xx
'next y
'
'' write huffman table
'for x=0 to 255
'wbits=4:xx=llengths(x):gosub texwritehbits
'   '? #ff2,"sym ";x;" length ";llengths(x)
'next x
'
'' encode pixels
'z=0:f0=0:h=hh:v=vv
'do
'a=bmp1(v,h,plane):z=((a-z) and 255)
'  '? "sym ";z;" len ";llengths(z);" code ";pcode(z)
'wbits=llengths(z):xx=pcode(z):gosub texwritehbits
'z=a
'f0+=1
'h+=1:if h=bmp1h then h=0:v+=1:if v=bmp1v then exit do
'loop until f0=32768
'
'next plane
'if v<>bmp1v then goto a389
'
'
'' write last bits (if any)
'x=(bbytes and 4095)
'if bbits>0 then filebuf(x)=a:x+=1:bbytes+=1
'if x<>0 then put #ff1,,filebuf(0),x
'
'y=5:put #ff1,y,bbytes        ' update data size in the header
'
'close #ff1
'message=5        ' "file saved"
'return


pngload:
asm
        mov dword ptr [stackloc],esp             ' need this to escape from pnggetbyte
end asm

x=5:get #ff1,x,y

windex=0:psh=-1:psv=0:zz=0:bbytes=4096

a300:
gosub getbigend:l=x
gosub getsstr

if sstr="PLTE" then
bp1=@pngpal(0,0):y=l:if y>768 then y=768
for x=1 to y:gosub pnggetbyte:*bp1=dbits:bp1+=1:next x
for x=0 to 255:swap pngpal(x,0),pngpal(x,2):next x
l=l-y
end if

if sstr="IHDR" then
gosub getbigend:bho=x:bmp1h=x
gosub getbigend:bmp1v=x
if ((bmp1h<1) or (bmp1v<1)) then goto a122
gosub resizemem
gosub pnggetbyte:bitdepth=dbits
if bitdepth=4 then bho=(bho shr 1)
gosub pnggetbyte:colrtype=dbits        ' 0=gray, 2=color, 3=palettized, 4=gray+alpha, 6=RGBA
cnum=1
if colrtype=2 then cnum=3
if colrtype=4 then cnum=2
if colrtype=6 then cnum=4
'gosub pnggetbyte        	        	' compression=0
'gosub pnggetbyte        	        	' filter=0
'gosub pnggetbyte        	        	' interlace=0
l=l-10
  '? "Found IHDR: width=";bho;" height=";bmp1v;" bits=";bitdepth;" color=";colrtype
end if

if sstr="IDAT" then
  '? "Found IDAT: size=";l
gosub pnggetbyte     ' compression method and info (&H78)
gosub pnggetbyte     ' check bits and flags
l=l-2
bbits=0
tformat=0            ' clear this, since we can't save PNG

startinflate:
gosub readhbit:lastblk=(xx and 1)
c=2:gosub readlbits:blktype=xx

  '? "block: type=";blktype;" last=";lastblk;" ";

if blktype=1 then ? "error: static mode":goto a122         	    ' no static huffman tables

if blktype=0 then                                        ' uncompressed block
gosub getbigend:blklen=(x shr 16):bbits=0
while blklen>0
gosub pnggetbyte:w=dbits:l=l-1
gosub storebyte
blklen=blklen-1
wend
end if

if blktype=2 then                                        ' normal compressed block
c=5:gosub readlbits:f0=xx+256          ' +257
c=5:gosub readlbits:f1=xx              ' +1
c=4:gosub readlbits:f2=xx+3            ' +4
  '? "compressed block: f0=";f0;" f1=";f1;" f2=";f2;" ";
clear clengths(0),0,19
clear lreverse(0),0,32768
clear dreverse(0),0,32768

' build huffman table so we can build huffman tables
for y=0 to f2
c=3:gosub readlbits
clengths(ccorder(y))=xx           ':? "read 3-bit code: ";xx;" for symbol ";ccorder(y)
next y
z=0
for y=1 to 7
for x=0 to 18
if clengths(x)=y then ccodes(x)=z:z+=1  ':? "ccode ";x;" has code ";z-1
next x
z+=z
next y

' decode and build the literal/length table
clear llengths(0),0,286
gosub buildtable
for y=1 to 15
for x=0 to 285
' use ccount to record the symbol associated with the huffman code
if llengths(x)=y then lreverse(z)=y:ccount(z)=x:z+=1
next x
z+=z
next y

' debugging crap
'for x=0 to 285
'for y=0 to 285
'if lreverse(y)>0 then if ccount(y)=x then ? "table sym ";x;" code ";y:goto derpherp
'next y
'derpherp:
'next x

' decode and build the distance table
clear llengths(0),0,30
f0=f1:gosub buildtable
for y=1 to 15
for x=0 to 29
' use bcount to record the symbol associated with the huffman code
if llengths(x)=y then dreverse(z)=y:bcount(z)=x:z+=1
next x
z+=z
next y

' debugging crap
'for x=0 to 29
'for y=0 to 29
'if dreverse(y)>0 then if bcount(y)=x then ? "dist sym ";x;" code ";y:goto derpherp
'next y
'derpherp:
'next x

' now decode some actual data
a307:
xx=0
for yy=1 to 15                                        ' max code length is 15 bits...
gosub readhbit
if lreverse(xx)=yy then w=ccount(xx):goto a306
next yy
? "unmatched lit/copy code":goto a122
a306:
  '? "sym ";w;" len ";yy;" code ";xx
if w<256 then gosub storebyte:goto a307
if w>256 then
xx=0
if w<>285 then c=((w-261) shr 2):gosub readlbits
clen=ltable(w)+3+xx
  '? "copy length ";clen;
xx=0
for yy=1 to 15
gosub readhbit
if dreverse(xx)=yy then w=bcount(xx):goto a308
next yy
? "unmatched dist code":goto a122
a308:
c=((w-2) shr 1):gosub readlbits
cd=dtable(w)+xx
  '? " distance ";cd
for y=1 to clen
w=wdata(((windex-cd) and 32767)):gosub storebyte
next y
goto a307
end if

end if

  '? "end code"

if lastblk=0 then goto startinflate
gosub getbigend:crc32=x        ' zlib "ADLER32" ???
l=l-4
end if

if sstr="IEND" then goto a181

for x=1 to l:gosub pnggetbyte:next x
gosub getbigend:crc32=x
goto a300


buildtable:
y=0
do
xx=0:yy=1
do
gosub readhbit      ':? xx;" ";
for w=0 to 18
if clengths(w)=yy then if ccodes(w)=xx then goto a302
next w
yy+=1:if yy=16 then return
loop
a302:
  '? "buildtable read bits ";yy;" code ";xx;" = value ";w
if w=16 then c=2:gosub readlbits:for x=-2 to xx:llengths(y)=zz:y+=1:next x:goto a303
if w=17 then c=3:gosub readlbits:for x=-2 to xx:llengths(y)=0:y+=1:next x:goto a303
if w=18 then c=7:gosub readlbits:for x=-10 to xx:llengths(y)=0:y+=1:next x:goto a303
llengths(y)=w:y+=1:zz=w
a303:
loop until y>f0
z=0
return


getsstr:
bp1=@sstr
gosub pnggetbyte:*bp1=dbits:bp1+=1
gosub pnggetbyte:*bp1=dbits:bp1+=1
gosub pnggetbyte:*bp1=dbits:bp1+=1
gosub pnggetbyte:*bp1=dbits
return

getbigend:
gosub pnggetbyte:x=dbits
gosub pnggetbyte:x=(x shl 8)+dbits
gosub pnggetbyte:x=(x shl 8)+dbits
gosub pnggetbyte:x=(x shl 8)+dbits
return

pnggetbyte:
if bbytes=4096 then
if eof(ff1) then                ' unexpected EOF?
asm
        mov esp,dword ptr [stackloc]
end asm
goto a122
end if
get #ff1,,filebuf():bbytes=0
end if
dbits=filebuf(bbytes):bbytes+=1:bbits=8
return

readlbits:                            ' read LSb first, becomes LSb
xx=0:lbits=0
do
if c<1 then return
c=c-1
if bbits=0 then
if l=0 then gosub nextchunk
l=l-1:gosub pnggetbyte
end if
xx+=((dbits and 1) shl lbits):lbits+=1
dbits=(dbits shr 1):bbits=bbits-1
loop

readhbit:                             ' read LSb first, becomes MSb
if bbits=0 then
if l=0 then gosub nextchunk
l=l-1:gosub pnggetbyte
end if
xx+=xx+(dbits and 1):dbits=(dbits shr 1):bbits=bbits-1
return


nextchunk:
' reached the end of a PNG chunk while we were in the middle of decoding...
' skip ahead to the next chunk so we can get back to work
a301:
gosub getbigend:crc32=x:gosub getbigend:l=x:gosub getsstr
if sstr<>"IDAT" then
for x=1 to l:gosub pnggetbyte:next x
goto a301
end if
return


storebyte:
wdata(windex)=w:windex=((windex+1) and 32767)

' if 16bpp then we skip low (2nd) byte of each word, and a byte at beginning of each (except first) line
if bitdepth=18 then bitdepth=16:return

if psh=-1 then filter=w:psh=0:px=0:hh=0:return

if bitdepth=17 then bitdepth=16:return
if bitdepth=16 then bitdepth=17

if psh<cnum then
pa=0:pc=0
else
pa=lbuf(psh-cnum):pc=oldline(psh-cnum)
end if

pb=oldline(psh)
if filter=1 then w+=pa
if filter=2 then w+=pb
if filter=3 then w+=((pa+pb) shr 1)
if filter=4 then
paeth=pa+pb-pc
pdiff=abs(pa-paeth)
if abs(pb-paeth)<pdiff then pdiff=abs(pb-paeth):pa=pb
if abs(pc-paeth)<pdiff then pa=pc
w+=pa
end if
lbuf(psh)=w

px+=1
if px=cnum then
w=(w and 255)
px=0:xptr=cast(integer ptr,@bmp1(psv,hh,0))
select case colrtype        ' 0=gray, 2=color, 3=palettized, 4=gray+alpha, 6=RGBA
case 0:*xptr=w*&H10101
case 2:*xptr=(lbuf(psh-2) shl 16)+(lbuf(psh-1) shl 8)+w
case 3
if bitdepth=4 then
*xptr=(*cast(integer ptr,@pngpal((w shr 4),0)) and &HFFFFFF):xptr+=1:hh+=1
*xptr=(*cast(integer ptr,@pngpal((w and 15),0)) and &HFFFFFF)
else
*xptr=(*cast(integer ptr,@pngpal(w,0)) and &HFFFFFF)
end if
case 4:*xptr=lbuf(psh-1)*&H10101+(w shl 24)
case 6:*xptr=(lbuf(psh-3) shl 16)+(lbuf(psh-2) shl 8)+lbuf(psh-1)+(w shl 24)
end select
hh+=1
end if

psh+=1
if psh=bho*cnum then
psh=-1:psv+=1
if bitdepth=17 then bitdepth=18
' if we already filled the whole BMP then exit successfully
if psv=bmp1v then
asm
        pop eax
end asm
goto a181
end if
' copy current line to oldline
xptr=@oldline(0):yptr=@lbuf(0)
asm
        cld
        mov ecx,dword ptr [maxh]
'        inc ecx
        mov esi,dword ptr [yptr]
        mov edi,dword ptr [xptr]
        rep movsd
end asm
end if
return


screenresize:
pbytes=1
if stats(40)=15 then pbytes=2
if stats(40)=16 then pbytes=2
if stats(40)=24 then pbytes=3
if stats(40)=32 then pbytes=4
lbytes=stats(38)*pbytes

maxx=stats(38)-1:maxy=stats(39)-1

if stats(40)=8 then
gosub setpal8
for x=0 to 15
tcol(x)=((tcolrgb(x) and &HC00000) shr 16)+((tcolrgb(x) and &HF000) shr 10)+((tcolrgb(x) and 255) shr 6)
next x
else
for x=0 to 15:tcol(x)=tcolrgb(x):next x
end if

return


setscreen:
screeninfo stats(38),stats(39),stats(40)
setscreen2:
scrp=screenptr
if stats(39)>400 then width (stats(38)\8),(stats(39)\16)
txtheight=stats(39)\hiword(width)
return


drawbox3:
i1=stats(71):goto drawbox2
drawbox:
i1=&HFFFFFF
drawbox2:
line (x,y)-(xx,y),i1
line (x,yy)-(xx,yy),i1
line (x,y)-(x,yy),i1
line (xx,y)-(xx,yy),i1
return


drawpixelwin:
' determine magnification factor for block
stats(50)=(stats(38) shr 1)\stats(78)
y=(stats(39) shr 1)\stats(79)
if stats(50)>y then stats(50)=y
stats(51)=((stats(38)-(stats(50)*stats(78))) shr 1)
stats(52)=((stats(39)-(stats(50)*stats(79))) shr 1)

x=stats(51)-1:y=stats(52)-1
xx=stats(50)*stats(78)+x+1
yy=stats(50)*stats(79)+y+1
gosub drawbox

for yy=0 to stats(79)-1
if stats(47)+yy>=bmp1v then goto a287

for xx=0 to stats(78)-1
if stats(46)+xx>=bmp1h then goto a286
b=bmp1(stats(47)+yy,stats(46)+xx,0)
g=bmp1(stats(47)+yy,stats(46)+xx,1)
r=bmp1(stats(47)+yy,stats(46)+xx,2)
if (bools1 and &H4000000) then           ' drawing on mask layer?
r=((r+g+b) shr 2)+64
b=bmp1(stats(47)+yy,stats(46)+xx,3):g=b
if b>0 then r=b
end if

for zz=1 to stats(50)
scrp2=scrp
scrp2+=((y+zz)*stats(38)+(xx*stats(50))+stats(51))*pbytes

for z=1 to stats(50)
select case stats(40)
case 8:*scrp2=(b shr 6)+((g shr 2) and 60)+(r and 192)
case 15:*scrp2=(b shr 3)+((g shl 2) and 224):scrp2+=1:*scrp2=(g shr 6)+((r shr 1) and 124)
case 16:*scrp2=(b shr 3)+((g shl 3) and 224):scrp2+=1:*scrp2=(g shr 5)+(r and 248)
case else
*scrp2=b:scrp2+=1:*scrp2=g:scrp2+=1:*scrp2=r
if stats(40)=32 then scrp2+=1
end select
scrp2+=1
next z
next zz

next xx
a286:
y+=stats(50)
next yy
a287:

' draw pixel cursor
x=stats(53)*stats(50)+stats(51):y=stats(54)*stats(50)+stats(52)
xx=stats(50)+x-1:yy=stats(50)+y-1
gosub drawbox3

' mark selection rectangle corner (if inside window)
x=pcopyh-stats(46):y=pcopyv-stats(47)
if x<0 then goto a336
if y<0 then goto a336
if x>=stats(78) then goto a336
if y>=stats(79) then goto a336
'i1=stats(71)
x=x*stats(50)+stats(51):y=y*stats(50)+stats(52)
xx=stats(50)+x-1:yy=stats(50)+y-1
line (x,y)-(xx,yy),i1
line (xx,y)-(x,yy),i1
a336:

return


fastlinecopy:
xptr=@bmp1(v,0,0):yptr=@bmp2(v,0,0)
'for h=0 to bmp1h-1
'*xptr=*yptr
'xptr+=1:yptr+=1
'next h
asm
        cld
        mov esi,dword ptr [xptr]
        mov edi,dword ptr [yptr]
        mov ecx,dword ptr [bmp1h]
        rep movsd
end asm
return


antistatic:

' copy first and last lines
v=0:gosub fastlinecopy
v=bmp1v-1:gosub fastlinecopy

' start processing 
for v=1 to bmp1v-2

' copy first pixel
bmp2(v,0,0)=bmp1(v,0,0):bmp2(v,0,1)=bmp1(v,0,1):bmp2(v,0,2)=bmp1(v,0,2)

for h=1 to bmp1h-2
for plane=0 to 2

d0=bmp1(v,h,plane)

d1=0:d2=255
for y=-1 to 1
yy=v+y
for x=-1 to 1
if (x or y)<>0 then
c0=bmp1(yy,h+x,plane)
if c0>d1 then d1=c0
if c0<d2 then d2=c0
end if
next x
next y
if d0>d1 then d0=d1
if d0<d2 then d0=d2
bmp2(v,h,plane)=d0
next plane
next h

' copy last pixel
h=bmp1h-1
bmp2(v,h,0)=bmp1(v,h,0):bmp2(v,h,1)=bmp1(v,h,1):bmp2(v,h,2)=bmp1(v,h,2)

next v
goto a289


noisereduce:

' first convert to yuv
redim shared tyuv(0 to bmp1v-1,0 to bmp1h-1,0 to 2) as short

for v=0 to bmp1v-1
for h=0 to bmp1h-1
b=bmp2(v,h,0):g=bmp2(v,h,1):r=bmp2(v,h,2)
tyuv(v,h,0)=(((7471*b)+(38469*g)+(19595*r)) shr 10)
tyuv(v,h,1)=(((32767*b)-(21692*g)-(11075*r)) shr 10)
tyuv(v,h,2)=(((32767*r)-(27444*g)-(5318*b)) shr 10)
next h
next v

' then process image

for v=0 to bmp1v-1
for h=0 to bmp1h-1

c0=tyuv(v,h,0)
c1=tyuv(v,h,1)
c2=tyuv(v,h,2)

' luma smoothing
if (bools1 and &H100000) then

'if h<2 then goto a292
'if h>bmp1h-3 then goto a292
'if v<2 then goto a292
'if v>bmp1v-3 then goto a292
'd0=0
'for y=-1 to 1
'for x=-1 to 1
'd0+=tyuv(v+y,h+x,0)
'next x
'next y
'c0=((((d0-c0) shr 3)+c0) shr 1)
'a292:

rd=stats(55):if rd<1 then rd=1
if rd>20 then rd=20
z=0:d0=0
v1=v-rd:if v1<0 then v1=0
v2=v+rd:if v2>=bmp1v then v2=bmp1v-1
rd=-1
for y=v1 to v2
rd+=1:if y>v then rd=rd-2
h1=h-rd:if h1<0 then h1=0
h2=h+rd:if h2>=bmp1h then h2=bmp1h-1
for x=h1 to h2
d0+=tyuv(y,x,0):z+=1
next x
next y
c0=d0\z

end if


' chroma smoothing
if (bools1 and &H200000) then
rd=stats(56):if rd<1 then rd=1
if rd>20 then rd=20
z=0:d1=0:d2=0
v1=v-rd:if v1<0 then v1=0
v2=v+rd:if v2>=bmp1v then v2=bmp1v-1
rd=-1
for y=v1 to v2
rd+=1:if y>v then rd=rd-2
h1=h-rd:if h1<0 then h1=0
h2=h+rd:if h2>=bmp1h then h2=bmp1h-1
for x=h1 to h2
d1+=tyuv(y,x,1):d2+=tyuv(y,x,2):z+=1
next x
next y
c1=d1\z
c2=d2\z
end if

' convert back to rgb
x=(c0 shl 12)
i0=(((c2*5742)+x) shr 18)
i1=((x-(c1*1409)-(c2*2925)) shr 18)
i2=(((c1*7258)+x) shr 18)

if i0>255 then i0=255
if i0<0 then i0=0
if i1>255 then i1=255
if i1<0 then i1=0
if i2>255 then i2=255
if i2<0 then i2=0

bmp2(v,h,0)=i2:bmp2(v,h,1)=i1:bmp2(v,h,2)=i0

next h
next v

redim shared tyuv(0 to 1,0 to 1,0 to 2) as short

return


showmask:

' set pixels in final image if aux bit(s) are set in original pixel data

for v=0 to bmp1v-1
for h=0 to bmp1h-1
x=bmp1(v,h,3)
if x then bmp2(v,h,0)=x:bmp2(v,h,1)=x:bmp2(v,h,2)=x
next h
next v

return


plotpixel:
if (bools1 and &H4000000) then           ' drawing on mask layer?
bmp1(y+amy,x+amx,3)=(stats(25)+stats(26)+stats(27))\3
return
end if
bmp1(y+amy,x+amx,0)=stats(27)           ' normal drawing
bmp1(y+amy,x+amx,1)=stats(26)
bmp1(y+amy,x+amx,2)=stats(25)
return


plotpixel2:

if (bools1 and &H20000000) then          ' gradient color calculation
stats(25)=0:stats(26)=0:stats(27)=0
u=0
gradflatc=0:graddist=100000

graddiv=0
gradblu=0:gradgrn=0:gradred=0

' init list
for i0=0 to stats(72)-1:gradact(i0)=0:next i0

' blacklist irrelevant points
for i0=0 to stats(72)-1
for i1=i0+1 to stats(72)-1

r=i0:g=i1

' rotate coordinates
z1=gradh(i0)*gradcr(i0,i1)-gradv(i0)*gradsr(i0,i1)        ' X of first point
z2=gradh(i1)*gradcr(i0,i1)-gradv(i1)*gradsr(i0,i1)        ' X of second point
z3=x*gradcr(i0,i1)-y*gradsr(i0,i1)                        ' X of pixel to be filled

if z1>z2 then swap z1,z2:swap r,g

z1=z3-z1:z2=z2-z3

if z1<0 then gradact(g)=1
if z2<0 then gradact(r)=1

next i1
next i0

' count remaining points
i1=0
for i0=0 to stats(72)-1
if gradact(i0)=0 then i1+=1
next i0

if i1=1 then 
for i0=0 to stats(72)-1
if gradact(i0)=0 then
u=gradc(i0)
stats(27)=(u and 255)
stats(26)=((u shr 8) and 255)
stats(25)=((u shr 16) and 255)
goto a348
end if
next i0
? "epic fail1":goto a348
end if      

if i1=2 then
for i0=0 to stats(72)-1
if gradact(i0) then goto a341
for i1=i0+1 to stats(72)-1
if gradact(i1) then goto a342
' rotate coordinates
z1=gradh(i0)*gradcr(i0,i1)-gradv(i0)*gradsr(i0,i1)        ' X of first point
z2=gradh(i1)*gradcr(i0,i1)-gradv(i1)*gradsr(i0,i1)        ' X of second point
z3=x*gradcr(i0,i1)-y*gradsr(i0,i1)                        ' X of pixel to be filled
c=gradc(i0):u=gradc(i1):if z1>z2 then swap z1,z2:swap c,u
z1=z3-z1:z2=z2-z3
'if z1<1 then z1=1
'if z2<1 then z2=1
z3=z1+z2
stats(27)=(((u and 255)*z1)+((c and 255)*z2))/z3
stats(26)=((((u shr 8) and 255)*z1)+(((c shr 8) and 255)*z2))/z3
stats(25)=((((u shr 16) and 255)*z1)+(((c shr 16) and 255)*z2))/z3
goto a348
a342:
next i1                     
a341:
next i0
? "epic fail2":goto a348
end if

' three or more points... ugh...
z1=0:z2=0:z3=0
graddiv=0

for u=0 to stats(72)-1
if gradact(u)=1 then goto a344

' calculate distance
i0=gradh(u)-x:i1=gradv(u)-y
z4=sqr(i0*i0+i1*i1)

c=gradc(u)

stats(27)=(c and 255)
stats(26)=((c shr 8) and 255)
stats(25)=((c shr 16) and 255)

if z4=0 then goto a348

z4=1/z4
z1+=stats(27)*z4
z2+=stats(26)*z4
z3+=stats(25)*z4

graddiv+=z4

a344:
next u

stats(27)=z1/graddiv
stats(26)=z2/graddiv
stats(25)=z3/graddiv

a348:
end if

if (bools1 and &H4000000) then           ' drawing on mask layer?
bmp1(y,x,3)=(stats(25)+stats(26)+stats(27))\3
return
end if
bmp1(y,x,0)=stats(27)           ' normal drawing
bmp1(y,x,1)=stats(26)
bmp1(y,x,2)=stats(25)
return


applymask:

' blend pixels from original and bmp2 depending on mask layer

for v=0 to bmp1v-1
for h=0 to bmp1h-1
x=bmp1(v,h,3)
if x then
bmp2(v,h,0)=((((256-x)*bmp2(v,h,0))+(x*bmp1(v,h,0))) shr 8)
bmp2(v,h,1)=((((256-x)*bmp2(v,h,1))+(x*bmp1(v,h,1))) shr 8)
bmp2(v,h,2)=((((256-x)*bmp2(v,h,2))+(x*bmp1(v,h,2))) shr 8)
end if
next h
next v

goto a298


fastmemcopy:    ' xx should be positive unless we are doing reverse copy
asm
        cld
        cmp dword ptr [xx],0
        jge a334
        std
a334:
        mov esi,dword ptr [yptr]
        mov edi,dword ptr [xptr]
        mov ecx,dword ptr [f2]
        mov eax,esi
        mov ebx,edi
        and bl,3
        and al,3
        jnz a299
        cmp bl,0
        jnz a299

a332:
        mov edx,ecx

        ' dword-aligned addresses :)
        and dl,3
        shr ecx,2
        jz a330
        rep movsd
        jmp a330

a299:   ' non-dword-aligned addresses :(
        cmp al,bl
        jne a333
        ' we can make them dword-aligned
        movsb
        dec al
        jz a332
        movsb
        dec al
        jz a332
        movsb
        jmp a332
a333:
        ' or maybe we can't
        rep movsb
        jmp a331

a330:   ' copy last bytes if end wasn't dword-aligned
        cmp dl,0
        jz a331
        xor ecx,ecx
        mov cl,dl
        rep movsb
a331:
        cld
end asm        
return


showgrid:
y=0
while y<bmp1v
x=0
while x<bmp1h
z=*cast(integer ptr,@bmp2(y,x,0))
*cast(integer ptr,@bmp2(y,x,0))=(z xor &HFFFFFF)
x+=stats(58)
wend
y+=stats(58)
wend
return


fillstuff:  
h1=0            ' left edge limit
h2=bmp1h        ' right edge limit
f1=0            ' top edge limit
f2=bmp1v        ' bottom edge limit

fillstuff2:
' use bit mask to distinguish between RGB planes and mask layer
snapmask=&HFFFFFF:if (bools1 and &H4000000) then snapmask=&HFF000000
xx=(*cast(integer ptr,@bmp1(amy,amx,0)) and snapmask)

' search up
y=amy:z=amx
do  
zz=-1:yy=y-1:if y=f1 then zz=-2
gosub fillsearchright
gosub fillsearchleft
y=yy:z=zz
loop until z<0

' search down
y=amy+1:z=amx
while y<f2
zz=-1:yy=y+1:if yy=f2 then zz=-2
gosub fillsearchright
gosub fillsearchleft
y=yy:z=zz:if z<0 then exit while
wend

recalc=1
return


fillsearchright:
x=z
do
if x>=h2 then return
if (*cast(integer ptr,@bmp1(y,x,0)) and snapmask)<>xx then return
gosub plotpixel2
if zz=-1 then if (*cast(integer ptr,@bmp1(yy,x,0)) and snapmask)=xx then zz=x
x+=1
loop

fillsearchleft:
x=z
do   
x=x-1
if x<h1 then return
if (*cast(integer ptr,@bmp1(y,x,0)) and snapmask)<>xx then return
gosub plotpixel2
if zz=-1 then if (*cast(integer ptr,@bmp1(yy,x,0)) and snapmask)=xx then zz=x
loop



outline:
xx=(*cast(integer ptr,@bmp1(amy,amx,0)) and &HFFFFFF)

' search up
y=amy:z=amx
do  
zz=-1:yy=y-1:if y=f1 then zz=-2
gosub outsearchright
gosub outsearchleft
y=yy:z=zz
loop until z<0

' search down
y=amy+1:z=amx
while y<f2
zz=-1:yy=y+1:if yy=f2 then zz=-2
gosub outsearchright
gosub outsearchleft
y=yy:z=zz:if z<0 then exit while
wend

recalc=1
return


outsearchright:
if z>=h2 then return
x=z
do
if zz<>-2 then
if (*cast(integer ptr,@bmp1(yy,x,0)) and &HFFFFFF)=xx then
if zz=-1 then zz=x
else
bmp1(y,x,0)=stats(27):bmp1(y,x,1)=stats(26):bmp1(y,x,2)=stats(25)
end if        
end if

x+=1
if x>=h2 then return
if (*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF)<>xx then
x=x-1:bmp1(y,x,0)=stats(27):bmp1(y,x,1)=stats(26):bmp1(y,x,2)=stats(25)
return
end if
loop

outsearchleft:
x=z
do   
x=x-1
if x<h1 then return
if (*cast(integer ptr,@bmp1(y,x,0)) and &HFFFFFF)<>xx then
x+=1:bmp1(y,x,0)=stats(27):bmp1(y,x,1)=stats(26):bmp1(y,x,2)=stats(25)
return
end if

if zz<>-2 then
if (*cast(integer ptr,@bmp1(yy,x,0)) and &HFFFFFF)=xx then
if zz=-1 then zz=x
else
bmp1(y,x,0)=stats(27):bmp1(y,x,1)=stats(26):bmp1(y,x,2)=stats(25)
end if
end if
loop


checkpixelwin:
if mx<stats(51) then goto a350
if my<stats(52) then goto a350
x=(mx-stats(51))\stats(50):y=(my-stats(52))\stats(50)
if x>=stats(78) then goto a350
'if y>=stats(79) then goto a350
if y<stats(79) then return

a350:
x=-1
return


checktempfile:
redraw=1
ff1=freefile:ki2=exepath+"\IMGTOOL.TMP"
open ki2 for binary as #ff1
if err<>0 then return
get #ff1,,pastex:get #ff1,,pastey
close #ff1
return


defaultdrawpal:
for x=0 to 63
penpal(x)=&H55*(x and 3)+&H5500*((x shr 2) and 3)+&H550000*(x shr 4)
next x
return


function colormatch (byval testrange as long,byval thresh as long, _
                byval cmred as ubyte,byval cmgrn as ubyte,byval cmblu as ubyte) as long
dim as long cmx,cmy,cmd1,cdr,cdg,cdb
dim as long ccy,ccu,ccv

' changing to =any makes no speed difference (?)
'dim as long cmx=any,cmd1=any,cdr=any,cdg=any,cdb=any
'dim as long ccy=any,ccu=any,ccv=any,cmy

cmd0=200000

' YUV mode
if (bools2 and 1) then
ccy=(((7471*cmblu)+(38469*cmgrn)+(19595*cmred)) shr 16)        ' -128
ccu=(((32767*cmblu)-(21692*cmgrn)-(11075*cmred)) shr 16)
ccv=(((32767*cmred)-(27444*cmgrn)-(5318*cmblu)) shr 16)
for cmx=pzone to testrange-1
cmblu=(bpal(cmx) and 63)
cmgrn=((bpal(cmx) shr 6) and 63)
cmred=((bpal(cmx) shr 12) and 63)
cdg=(((7471*cmblu)+(38469*cmgrn)+(19595*cmred)) shr 16)-ccy:if cdg<0 then cdg=0-cdg
cdr=(((32767*cmblu)-(21692*cmgrn)-(11075*cmred)) shr 16)-ccu
cdb=(((32767*cmred)-(27444*cmgrn)-(5318*cmblu)) shr 16)-ccv
cmd1=(cdr*cdr)+((cdg+stats(74))*cdg)+(cdb*cdb)
if cmd1<cmd0 then
cmd0=cmd1:cmy=cmx
if cmd0=0 then goto cmdone
if cmd1<thresh then goto cmdone
end if
next cmx
goto cmdone
end if

' RGB - round down mode
if (bools2 and 16) then
for cmx=pzone to testrange-1
cdb=(bpal(cmx) and 63)-cmblu:if cdb>0 then cdb=255
cdg=((bpal(cmx) shr 6) and 63)-cmgrn:if cdg>0 then cdg=255
cdr=((bpal(cmx) shr 12) and 63)-cmred:if cdr>0 then cdr=255
cmd1=(cdr*cdr)+(cdg*cdg)+(cdb*cdb)
if cmd1<cmd0 then
cmd0=cmd1:cmy=cmx
if cmd0=0 then goto cmdone
if cmd1<thresh then goto cmdone
end if
next cmx
goto cmdone
end if

' RGB mode
for cmx=pzone to testrange-1
cdb=(bpal(cmx) and 63)-cmblu
cdg=((bpal(cmx) shr 6) and 63)-cmgrn
cdr=((bpal(cmx) shr 12) and 63)-cmred
cmd1=(cdr*cdr)+(cdg*cdg)+(cdb*cdb)
if cmd1<cmd0 then
cmd0=cmd1:cmy=cmx
if cmd0=0 then goto cmdone
if cmd1<thresh then goto cmdone
end if
next cmx

cmdone:
function=cmy
end function








